jQuery.sap.require({ modName: "sas.stress.config.view.CreateWorksheetTemplateEditor", type: "controller" });
jQuery.sap.require("sap.ui.core.Orientation");
jQuery.sap.require("sas.hc.m.Button");
jQuery.sap.require("sas.hc.m.Input");
jQuery.sap.require("sas.hc.m.Label");
jQuery.sap.require("sas.hc.m.Select");
jQuery.sap.require("sas.hc.m.SearchField");
jQuery.sap.require("sas.hc.m.Text");
jQuery.sap.require("sas.hc.m.TextArea");
jQuery.sap.require("sas.hc.m.CheckBox");
jQuery.sap.require("sas.hc.m.Toolbar");
jQuery.sap.require("sas.hc.m.ToolbarSpacer");
jQuery.sap.require("sas.hc.ui.commons.HorizontalDivider");
jQuery.sap.require("sas.hc.ui.commons.layout.BorderLayout");
jQuery.sap.require("sas.hc.ui.commons.layout.BorderLayoutArea");
jQuery.sap.require("sas.hc.ui.commons.layout.MatrixLayout");
jQuery.sap.require("sas.hc.ui.commons.layout.MatrixLayoutRow");
jQuery.sap.require("sas.hc.ui.commons.layout.MatrixLayoutCell");
jQuery.sap.require("sas.hc.ui.core.Item");
jQuery.sap.require("sas.hc.ui.layout.Splitter");
jQuery.sap.require("sas.hc.ui.layout.VerticalLayout");
jQuery.sap.require("sas.hc.ui.table.TreeTable");
jQuery.sap.require("sas.hc.ui.table.Column");
jQuery.sap.require("sas.risk.common.widgets.WidgetFactory");
jQuery.sap.require("sas.stress.wkbench.widget.CustomBreadcrumb");

sap.ui.jsview("sas.stress.config.view.CreateWorksheetTemplateEditor", {

    XAXIS: "xAxis",
    YAXIS: "yAxis",
    FILTER: "filter",
    HIDDENHIERARCHY: "hidden",

    rb: sap.ui.getCore().getLibraryResourceBundle("sas.stress.config"),

    getControllerName: function () {
        return "sas.stress.config.view.CreateWorksheetTemplateEditor";
    },

    createContent: function (controller) {

        this.setHeight("100%");

        //this.hierarchiesTreeTable = new sas.hc.ui.table.TreeTable({
        //    columns: [
        //        new sas.hc.ui.table.Column({
        //            label: new sas.hc.m.Label({ text: this.rb.getText("hierarchiesTreeTable.column.name.header.title") }),
        //            template: new sas.hc.m.Text({ text: "{name}", tooltip: "{name}", wrapping: false }),
        //            width: "100%"
        //        })
        //    ],
        //    visibleRowCountMode: sap.ui.table.VisibleRowCountMode.Auto,
        //    minAutoRowCount: 1,
        //    selectionMode: sap.ui.table.SelectionMode.MultiToggle,
        //    selectionBehavior: sap.ui.table.SelectionBehavior.RowSelector,
        //    rowSelectionChange: $.proxy(controller.hierarchiesTreeTableRowSelectionChange, controller)
        //}).addStyleClass("treeTable"); // SOPHIE TODO: is this necessary?

        var layout = new sas.hc.ui.commons.layout.BorderLayout();

        layout.setTop(new sas.hc.ui.commons.layout.BorderLayoutArea({
            size: "8rem",
            content: this._createTopPanel(controller)
        }));

        layout.setCenter(new sas.hc.ui.commons.layout.BorderLayoutArea({
            content: this._createBottomPanel(controller)
        }));

        this.breadCrumb = new sas.stress.wkbench.widget.CustomBreadcrumb({
            customData: new sap.ui.core.CustomData({key: "size", value: "3rem"}),
            itemSelected: $.proxy(controller.breadcrumbClickHandler, controller)
        });

        this.saveButton = new sas.hc.m.Button({
            icon: sas.icons.HC.SAVE,
            enabled: false,
            press: $.proxy(controller.saveCreateWorksheetButtonPress, controller)
        });

        return sas.risk.common.widgets.WidgetFactory.buildPanel({
            top: new sas.risk.common.widgets.RiskToolbar({
                title: this.breadCrumb,
                headerContent: [
                    this.saveButton
                ]
            }).addStyleClass("innerToolbar"),
            content: layout
        });
    },

    _createTopPanel: function (controller) {
        return new sas.hc.ui.layout.VerticalLayout({
            width: "100%",
            content: [
                new sas.hc.ui.commons.layout.MatrixLayout({
                    layoutFixed: false,
                    columns: 2,
                    width: "80%",
                    rows: [
                        new sas.hc.ui.commons.layout.MatrixLayoutRow({
                            cells: [
                                new sas.hc.ui.commons.layout.MatrixLayoutCell({
                                    vAlign: sap.ui.commons.layout.VAlign.Top,
                                    content: new sas.hc.ui.layout.VerticalLayout({
                                        width: "100%",
                                        content: [
                                            new sas.hc.m.Label({text: this.rb.getText("sheetTemplate.name.control.label")}),
                                            this._createNameInput(controller)
                                        ]
                                    })
                                }),
                                new sas.hc.ui.commons.layout.MatrixLayoutCell({
                                    rowSpan: 2,
                                    vAlign: sap.ui.commons.layout.VAlign.Top,
                                    content: new sas.hc.ui.layout.VerticalLayout({
                                        width: "100%",
                                        content: [
                                            new sas.hc.m.Label({text: this.rb.getText("sheetTemplate.description.control.label")}),
                                            this._createDescInput(controller)
                                        ]
                                    })
                                })
                            ]
                        }),
                        new sas.hc.ui.commons.layout.MatrixLayoutRow({
                            cells: [
                                new sas.hc.ui.commons.layout.MatrixLayoutCell({
                                    vAlign: sap.ui.commons.layout.VAlign.Top,
                                    content: new sas.hc.ui.layout.HorizontalLayout({
                                        content: [
                                            new sas.hc.ui.layout.VerticalLayout({
                                                width: "100%",
                                                content: [
                                                    new sas.hc.m.Label({text: this.rb.getText("sheetTemplate.category.control.label")}),
                                                    this._createCategoriesList(controller)
                                                ]
                                            }),
                                            new sas.hc.ui.layout.VerticalLayout({
                                                width: "100%",
                                                content: [
                                                    new sas.hc.m.Label({text: this.rb.getText("sheetTemplate.version.control.label")}),
                                                    this._createVersionInput(controller)
                                                ]
                                            }).addStyleClass("templateVersion"),
                                            new sas.hc.ui.layout.VerticalLayout({
                                                width: "100%",
                                                content: [
                                                    this._createHiddenHierarchiesCheckBox(controller)
                                                ]
                                            })
                                        ]
                                    })
                                })
                            ]
                        })
                    ]
                })//,
               // new sas.hc.ui.commons.HorizontalDivider()
            ]
        });
    },

    _createNameInput: function (controller) {
        var capabilityManager = sas.stress.wkbench.CapabilityManager.getInstance();
        this.worksheetNameInput = new sas.hc.m.Input({
            id: "createWorksheetNameInput",
            value: "{/name}",
            type: sap.m.InputType.Text,
            width: "95%",
            disableValidation: false,
            enabled: capabilityManager.isCapableOf(sas.stress.wkbench.CapabilityManager.TEMPLATE.UPDATE),
            maxLength: 64,
            liveChange: $.proxy(controller.createWorksheetNameVersionLiveChange, controller),
            change: $.proxy(controller.handleWorksheetNameChange, controller),
            required: false
        });
        return this.worksheetNameInput;
    },
    _createVersionInput: function (controller) {
        var capabilityManager = sas.stress.wkbench.CapabilityManager.getInstance();
        this.worksheetVersionInput = new sas.hc.m.Input({
            id: "createWorksheetVersionInput",
            value: "{/version}",
            type: sap.m.InputType.Text,
            width: "95%",
            enabled: capabilityManager.isCapableOf(sas.stress.wkbench.CapabilityManager.TEMPLATE.UPDATE),
            disableValidation: false,
            maxLength: 256,
            liveChange: $.proxy(controller.createWorksheetNameVersionLiveChange, controller),
            required: false
        });
        return this.worksheetVersionInput;
    },
    _createHiddenHierarchiesCheckBox: function (controller) {
        var capabilityManager = sas.stress.wkbench.CapabilityManager.getInstance();
        this.hiddenHierarchies = new sas.hc.m.CheckBox({
            id: "createWorksheetHiddenHierarchiesInput",
            text: this.rb.getText("sheetTemplate.hidden.checkbox.label"),
            //selected: true,
            width: "100%",
            //enabled: capabilityManager.isCapableOf(sas.stress.wkbench.CapabilityManager.TEMPLATE.UPDATE),
            //disableValidation: false,
            select: $.proxy(controller.toggleHiddenHierarchies, controller)
        }).addStyleClass("createWorksheetTemplateEnableAggregation");
        return this.hiddenHierarchies;
    },
    _createDescInput: function (controller) {
        var capabilityManager = sas.stress.wkbench.CapabilityManager.getInstance();
        this.worksheetDescInput = new sas.hc.m.TextArea({
            id: "createWorksheetDescInput",
            autoExpandable: true,
            //type: sap.m.InputType.Text,
            maxLength: 256,
            value: "{/description}",
            rows: 3,
            enabled: capabilityManager.isCapableOf(sas.stress.wkbench.CapabilityManager.TEMPLATE.UPDATE),
            width: "100%",
            liveChange: $.proxy(controller.createWorksheetDescLiveChange, controller)
        });
        return this.worksheetDescInput;
    },


    _createCategoriesList: function (controller) {
        var capabilityManager = sas.stress.wkbench.CapabilityManager.getInstance();
        this.worksheetCategoryList = new sas.hc.m.Select({
            id: "createWorksheetCategoryList",
            enabled: capabilityManager.isCapableOf(sas.stress.wkbench.CapabilityManager.TEMPLATE.UPDATE),
            items: {
                path: "/sheetCategories",
                template: new sas.hc.ui.core.Item({
                    key: '{id}',
                    tooltip: '{label}',
                    text: '{label}'
                })
            },
            autoAdjustWidth: true
            //  selectedKey:'{/label}'
        });

        this.worksheetCategoryList.attachChange($.proxy(this.getController().worksheetCategoryChange, this.getController()));
        return this.worksheetCategoryList;
    },

    _createBottomPanel: function (controller) {
        return new sas.hc.ui.layout.Splitter("worksheetSplitter", {
            contentAreas: [
                sas.risk.common.widgets.WidgetFactory.buildPanelNoPadding(
                    {
                        content: this._createHierarchiesTreeTable(controller)
                    }
                ),
                this._createRightPanel(controller)
            ],
            orientation: sap.ui.core.Orientation.Horizontal,
            width: "100%",
            height: "100%"
        });
    },

    _createHierarchiesTreeTable: function (controller) {
        this.hierarchiesTreeTable = new sas.hc.ui.table.TreeTable({
            columns: [
                new sas.hc.ui.table.Column({
                    label: new sas.hc.m.Label({ text: this.rb.getText("hierarchiesTreeTable.column.name.header.title") }),
                    template: new sas.hc.m.Text({ text: "{name}", tooltip: "{name}", wrapping: false }),
                    width: "15rem"
                }),
                new sas.hc.ui.table.Column({
                    label: new sas.hc.m.Label({ text: this.rb.getText("hierarchiesTreeTable.column.version.header.title") }),
                    template: new sas.hc.m.Text({ text: "{version}", tooltip: "{version}", wrapping: false }),
                    width: "5rem"
                })
            ],
            visibleRowCountMode: sap.ui.table.VisibleRowCountMode.Auto,
            minAutoRowCount: 1,
            selectionMode: sap.ui.table.SelectionMode.Single,
            selectionBehavior: sap.ui.table.SelectionBehavior.RowOnly,
            rowSelectionChange: $.proxy(controller.hierarchiesTreeTableRowSelectionChange, controller),
            title: this.rb.getText("sheetTemplates.categories.header.title"),
            toolbar: this._createHierarchyTableToolbar(controller)
        }).addStyleClass("treeTable");

        //TEMPORARY FIX for busted HC treetable code
        this.hierarchiesTreeTable.hasPopin = function () {
            return false;
        };
        this.hierarchiesTreeTable.getAllowReflow = function () {
            return false;
        };

        return this.hierarchiesTreeTable;
    },

    _createHierarchyTableToolbar: function (controller) {
        this.searchField = this._createSearchField(controller);

        return new sas.hc.m.Toolbar({
            content: [
                this.searchField,  // Removing Search field until we can get it to work
                new sas.hc.m.ToolbarSpacer(),
                new sas.hc.m.Button({
                    id: "hierarchyTreeTableExpandButton",
                    icon: sas.icons.HC.SHOWALL,
                    tooltip: this.rb.getText("sheetTemplate.hierarchyTreeTable.expandCollapseButton.tip"),
                    press: $.proxy(controller.hierarchyTreeTableExpandButtonPress, controller)
                }),
                new sas.hc.m.Button({
                    id: "hierarchyTreeTableCollapseButton",
                    icon: sas.icons.HC.HIDEALL,
                    tooltip: this.rb.getText("sheetTemplate.hierarchyTreeTable.collapseButton.tip"),
                    press: $.proxy(controller.hierarchyTreeTableCollapseButtonPress, controller)
                })
            ]
        });
    },

    _createSearchField: function (controller) {
        return new sas.hc.m.SearchField({
            placeholder: this.rb.getText("sheetTemplates.categories.search.placeholder.txt"),
            liveChange: $.proxy(controller.filterHierarchyListLiveChange, controller),
            visible: false,  // Disabling till we can makeit work with hierarchical data
            search: $.proxy(controller.filterHierarchyListLiveChange, controller)
        });
    },

    _createRightPanel: function (controller) {
        var contentInnerContainer = new sas.hc.ui.commons.layout.BorderLayout({
            width: "100%",
            height: "100%"
        });
        this.contentInnerContainerArea = new sas.hc.ui.commons.layout.BorderLayoutArea({
            content: [
                this.xLayout = this._createAxisBox(this.XAXIS),
                this.yLayout = this._createAxisBox(this.YAXIS),
                this.filterLayout = this._createAxisBox(this.FILTER),
                this.hiddenHLayout = this._createAxisBox(this.HIDDENHIERARCHY)
            ]
        }).addStyleClass("createWorksheetTemplateRightSectionLayout");
        contentInnerContainer.setCenter(this.contentInnerContainerArea);
        return contentInnerContainer;
    },

    _createAxisBox: function (axis) {
        var controller = this.getController();
        var layout = new sas.hc.ui.commons.layout.BorderLayout({
            id: axis + "_LayoutHeight",
            width: "100%",
            //height: (axis !== this.FILTER) ? "33%" : "34%"
            height: "25%"
        });

        layout.setTop(new sas.hc.ui.commons.layout.BorderLayoutArea({ size: "10px" }));

        this[axis + "AddButton"] = new sas.hc.m.Button({
            id: axis + "_AddButton",
            icon: sas.icons.HC.ARROWRIGHTADDDUALSELECTOR,
            press: $.proxy(controller.addMappingButtonPress, controller),
            enabled: false //False initially, selecting correct nodes will enable this.
        });

        this[axis + "RemoveButton"] = new sas.hc.m.Button({
            id: axis + "_RemoveButton",
            icon: sas.icons.HC.ARROWLEFTREMOVEDUALSELECTOR,
            press: $.proxy(controller.removeMappingButtonPress, controller),
            enabled: false //False initially, selecting correct nodes will enable this.
        });

        layout.setBegin(new sas.hc.ui.commons.layout.BorderLayoutArea({
            size: "4rem",
            contentAlign: "middle",
            content: new sas.hc.ui.layout.VerticalLayout({
                content: [
                    this[axis + "AddButton"],
                    this[axis + "RemoveButton"]
                ]
            })
        }).addStyleClass("stressCreateWorksheetEditorMoveButtons"));

        this[axis + "RefineButton"] = new sas.hc.m.Button({
            id: axis + "_RefineButton",
            text: this.rb.getText("sheetTemplate.refine.button.label"),
            press: $.proxy(controller.refineAxisButtonPress, controller),
            visible: axis !== this.FILTER,
            enabled: false
        });

        this[axis + "Table"] = new sas.hc.ui.table.Table({
            id: axis + "_Table",
            columns: [
                new sas.hc.ui.table.Column({
                    // label: new sas.hc.m.Label({text: this.rb.getText("hierarchiesTreeTable.column.name.header.title")}),
                    template: new sas.hc.m.Text({ text: "{nameVersion}", tooltip: "{nameVersion}", wrapping: false }),
                    width: "15rem"
                })
                //new sas.hc.ui.table.Column({
                //    template: new sas.hc.m.Text({ text: "{version}", tooltip: "{version}", wrapping: false }),
                //    width: "5rem"
                //})
            ],
            columnHeaderVisible: false,
            visibleRowCountMode: sap.ui.table.VisibleRowCountMode.Auto,
            minAutoRowCount: 1,
            showTableOptions: false,
            selectionMode: sap.ui.table.SelectionMode.Single,
            noDataText: this.rb.getText("sheetTemplate.axis." + axis + ".table.noData.txt"),
            selectionBehavior: sap.ui.table.SelectionBehavior.RowOnly,
            rowSelectionChange: $.proxy(controller.onAxisTableRowSelectionChanged, controller),
            toolbar: new sas.hc.m.Toolbar({
                content: [
                    new sas.hc.m.Label({ text: this.rb.getText("sheetTemplate.axis." + axis + ".label") }),
                    new sas.hc.m.ToolbarSpacer(),
                    this[axis + "RefineButton"]
                ]
            })
        });

        layout.setCenter(new sas.hc.ui.commons.layout.BorderLayoutArea({
            content: this[axis + "Table"]
        }));

        this[axis + "UpButton"] = new sas.hc.m.Button({
            id: axis + "_UpButton",
            icon: sas.icons.HC.ARROWSMALLUP,
            press: $.proxy(controller.onAxisMoveUpPressed, controller),
            enabled: false, //False initially, selecting correct nodes will enable this.
            visible: axis !== this.FILTER
        });

        this[axis + "DownButton"] = new sas.hc.m.Button({
            id: axis + "_DownButton",
            icon: sas.icons.HC.ARROWSMALLDOWN,
            press: $.proxy(controller.onAxisMoveDownPressed, controller),
            enabled: false, //False initially, selecting correct nodes will enable this.
            visible: axis !== this.FILTER
        });

        layout.setEnd(
            new sas.hc.ui.commons.layout.BorderLayoutArea(
                {
                    size: "3rem",
                    content: new sas.hc.ui.layout.VerticalLayout({
                        content: [
                            this[axis + "UpButton"],
                            this[axis + "DownButton"]
                        ]
                    })
                }
            ).addStyleClass("stressCreateWorksheetEditorSortButtons")
        );

        return layout;

    },

    attachClosing: function (callBack, listener) {
        this.attachEvent(this.getId() + "_CLOSING", callBack, listener);
    },

    destroy: function () {
        sap.ui.core.mvc.JSView.prototype.destroy.apply(this, arguments);
    }

});