/*
 * Copyright 2014 SAS Institute Inc.
 * All Rights Reserved.
 *
 * NOTE: This is a generated file. Changes should be made in the underlying
 * source files (*.js, .library, etc) or they will be lost after the next generation
 */

jQuery.sap.declare("sas.stress.library");
jQuery.sap.require("sap.ui.core.Core");

/**
 * @namespace
 * @name sas.stress.wkbench
 * @public
 */

// library dependencies
jQuery.sap.require("sap.ui.commons.library");
jQuery.sap.require("sap.m.library");
jQuery.sap.require("sap.ui.core.library");
jQuery.sap.require("sap.ui.table.library");
jQuery.sap.require("sas.hc.m.library");
jQuery.sap.require("sas.hc.ui.commons.library");
jQuery.sap.require("sas.hc.ui.core.library");
jQuery.sap.require("sas.hc.ui.layout.library");
jQuery.sap.require("sas.hc.ui.table.library");

// delegate further initialization of this library to the Core
sap.ui.getCore().initLibrary({
    name : "sas.stress",
    dependencies : ["sap.m","sap.ui.commons","sap.ui.core","sap.ui.table","sas.hc.m","sas.hc.ui.commons","sas.hc.ui.core","sas.hc.ui.layout","sas.hc.ui.table","sas.risk.common"],
    types : [
    ],
    interfaces : [
    ],
    controls : [
        "sas.stress.wkbench/CellEvaluationUtil",
        "sas.stress.wkbench/CellPickerUtil",
        "sas.stress.wkbench/StressAPI",
        "sas.stress.wkbench/StressFixes",
        "sas.stress.wkbench/StressGoTemplates",
        "sas.stress.wkbench/StressRouter",
        "sas.stress.wkbench/StressUtil",
        "sas.stress.wkbench/UserPrefs",
        "sas.stress.wkbench/ViewManager",
        "sas.stress.wkbench.model/CellHistoryItem",
        "sas.stress.wkbench.model/CellHistoryItemUncommitted",
        "sas.stress.wkbench.model/Entity",
        "sas.stress.wkbench.model/Formatter",
        "sas.stress.wkbench.model/Process",
        "sas.stress.wkbench.model/Project",
        "sas.stress.wkbench.model/Scenario",
        "sas.stress.wkbench.model/Sheet",
        "sas.stress.wkbench.model/SheetCategory",
        "sas.stress.wkbench.model/SheetInfo",
        "sas.stress.wkbench.model/Task",
        "sas.stress.wkbench.model/TaskAction",
        "sas.stress.wkbench.model/Transition",
        "sas.stress.wkbench.parser/Lexer",
        "sas.stress.wkbench.parser/Parser",
        "sas.stress.wkbench.parser/Precedence",
        "sas.stress.wkbench.parser/Token",
        "sas.stress.wkbench.parser/TokenType",
        "sas.stress.wkbench.parser/ExpressionUtil",
        "sas.stress.wkbench.parser/parselet/BinaryOperatorParselet",
        "sas.stress.wkbench.parser/parselet/CallParselet",
        "sas.stress.wkbench.parser/parselet/ComparisonParselet",
        "sas.stress.wkbench.parser/parselet/ConditionalParselet",
        "sas.stress.wkbench.parser/parselet/GroupParselet",
        "sas.stress.wkbench.parser/parselet/NameParselet",
        "sas.stress.wkbench.parser/parselet/PostfixOperatorParselet",
        "sas.stress.wkbench.parser/parselet/PrefixOperatorParselet",
        "sas.stress.wkbench.view/CellCommentEditor.controller",
        "sas.stress.wkbench.view/CellCommentEditor.view",
        "sas.stress.wkbench.view/CellConflictDialog.fragment",
        "sas.stress.wkbench.view/CellEditor.controller",
        "sas.stress.wkbench.view/CellEditor.view",
        "sas.stress.wkbench.view/CompareDialog.fragment",
        "sas.stress.wkbench.view/ConflictProjectDialog.fragment",
        "sas.stress.wkbench.view/EditProjectDialog.fragment",
        "sas.stress.wkbench.view/HomePage.controller",
        "sas.stress.wkbench.view/HomePage.view",
        "sas.stress.wkbench.view/LogDialog.fragment",
        "sas.stress.wkbench.view/ProjectManager.controller",
        "sas.stress.wkbench.view/ProjectManager.view",
        "sas.stress.wkbench.view/ScenarioEditor.controller",
        "sas.stress.wkbench.view/ScenarioEditor.view",
        "sas.stress.wkbench.view/StressShell.controller",
        "sas.stress.wkbench.view/StressShell.view",
        "sas.stress.wkbench.view/Workbench.controller",
        "sas.stress.wkbench.view/Workbench.view",
        "sas.stress.wkbench.widget/CommentDialog",
        "sas.stress.wkbench.widget/CustomBreadcrumb",
        "sas.stress.wkbench.widget/DropdownBox",
        "sas.stress.wkbench.widget/DropdownBoxRenderer",
        "sas.stress.wkbench.widget/MessageDetailsBox",
        "sas.stress.wkbench.widget/ProcessDiagram",
        "sas.stress.wkbench.widget/SortableList",
        "sas.stress.wkbench.widget/StatusLabel",
        "sas.stress.wkbench.widget/TextAreaAuto",
        "sas.stress.wkbench.widget/TextFieldSpellCheck",
        "sas.stress.config.model/Hierarchy.js",
        "sas.stress.config.model/HierarchyCategory.js",
        "sas.stress.config.model/HierarchyDetail.js",
        "sas.stress.config.model/HierarchyItemMap.js",
        "sas.stress.config.model/HierarchyItemMapDetail.js",
        "sas.stress.config.model/HierarchyLineItem.js",
        "sas.stress.config.model/HierarchyMapPair.js",
        "sas.stress.config.model/HierarchyMaps.js",
        "sas.stress.config.model/HierarchySource.js",
        "sas.stress.config.model/ModelHierItemMap.js",
        "sas.stress.config.model/SheetConfig.js",
        "sas.stress.config.model/SheetScenarioConfig.js",
        "sas.stress.config.view/AddHierarchyMappingDialog.fragment.js",
        "sas.stress.config.view/EditHierarchyDialog.fragment.js",
        "sas.stress.config.view/HierarchyMapping.controller.js",
        "sas.stress.config.view/HierarchyMapping.view.js",
        "sas.stress.config.view/ImportProcessDefinitionsDialog.fragment.js",
        "sas.stress.config.view/ProcessDefinitions.controller.js",
        "sas.stress.config.view/ProcessDefinitions.view.js",
        "sas.stress.config.view/ProjectConfiguration.controller.js",
        "sas.stress.config.view/ProjectConfiguration.view.js",
        "sas.stress.config.view/SheetCategoryEditor.controller.js",
        "sas.stress.config.view/SheetCategoryEditor.view.js",
        "sas.stress.config.view/SheetTemplateManager.controller.js",
        "sas.stress.config.view/SheetTemplateManager.view.js",
        "sas.stress.data/DataAPI.js",
        "sas.stress.data.model/DataLoadHistoryItem.js",
        "sas.stress.data.view/DataEditor.controller.js",
        "sas.stress.data.view/DataEditor.view.js",
        "sas.stress.data.view/LoadDataEditor.controller.js",
        "sas.stress.data.view/LoadDataEditor.view.js",
        "sas.stress.data.view/LoadProjectDataEditor.controller.js",
        "sas.stress.data.view/LoadProjectDataEditor.view.js",
        "sas.stress.data.view/ProjectDataEditor.controller.js",
        "sas.stress.data.view/ProjectDataEditor.view.js",
        "sas.stress.models/Model.js",
        "sas.stress.models/ModelsCommon.js",
        "sas.stress.models.view.browse/BrowseModelInventory.controller.js",
        "sas.stress.models.view.browse/BrowseModelInventory.view.js",
        "sas.stress.models.view.browse/InventoryModelDetails.controller.js",
        "sas.stress.models.view.browse/InventoryModelDetails.view.js",
        "sas.stress.models.view.execution/ExecutionLog.controller.js",
        "sas.stress.models.view.execution/ExecutionLog.view.js",
        "sas.stress.models.view.execution/ModelDetails.controller.js",
        "sas.stress.models.view.execution/ModelDetails.view.js",
        "sas.stress.models.view.execution/ModelManager.controller.js",
        "sas.stress.models.view.execution/ModelManager.view.js",
        "sas.stress.pfd/PfdStyles.js",
        "sas.stress.reports/StressAPI.js",
        "sas.stress.reports.model/ReportConfig.js",
        "sas.stress.reports.model/ReportHistory.js",
        "sas.stress.reports.model/ReportConfigCategory.js",
        "sas.stress.reports.view/EditReportDialog.fragment.js",
        "sas.stress.reports.view/RunReportDialog.fragment.js",
        "sas.stress.reports.view/MessagesDialog.fragment.js",
        "sas.stress.reports.view/ProjectReportsEditor.controller.js",
        "sas.stress.reports.view/ProjectReportsEditor.view.js",
        "sas.stress.scenarios/Scenario.js",
        "sas.stress.scenarios/ScenarioAPI.js",
        "sas.stress.scenarios.view/AddScenarios.controller.js",
        "sas.stress.scenarios.view/AddScenarios.view.js",
        "sas.stress.scenarios.view/GlobalScenarioPage.controller.js",
        "sas.stress.scenarios.view/GlobalScenarioPage.view.js",
        "sas.stress.scenarios.view/ImportScenariosDialog.fragment.js",
        "sas.stress.scenarios.view/PerturbationTable.controller.js",
        "sas.stress.scenarios.view/PerturbationTable.view.js",
        "sas.stress.scenarios.view/ScenarioManager.controller.js",
        "sas.stress.scenarios.view/ScenarioManager.view.js",
        "sas.stress.scenarios.view/ScenarioPage.controller.js",
        "sas.stress.scenarios.view/ScenarioPage.view.js"
    ],
    elements : [
    ],
    version : "401001.11.0.20180713093800_f0risk164"});
