jQuery.sap.declare("sas.stress.models.Model");
jQuery.sap.require("sas.stress.wkbench.StressAPI");
jQuery.sap.require("sas.stress.wkbench.StressUtil");

sap.ui.base.Object.extend("sas.stress.models.Model", {
    constructor: function (id,
                           name,
                           description,
                           dateInterval,
                           updatedTimestamp,
                           createdTimestamp,
                           createdByUser,
                           updatedByUser,
                           customattributes,
                           code,
                           modelId,
                           owner,
                           sourceType,
                           formType,
                           formTypeName,
                           fromState,
                           toState,
                           developer,
                           businessUnit,
                           codeLocation,
                           businessModelId,
                           modifiedBy,
                           modifiedByName,
                           documentationUrl,
                           modifiedTimeStamp,
                           version,
                           workGroup) {
        this.id = id;
        this.name = name;
        this.description = description;
        this.dateInterval = dateInterval;
        this.createdTimestamp = createdTimestamp;
        this.updatedTimestamp = updatedTimestamp;
        this.createdByUser = createdByUser;
        this.updatedByUser = updatedByUser;
        this.customattributes = customattributes;
        this.code = code;
        this.modelId = modelId;

        this.owner = owner;
        this.sourceType = sourceType;
        this.formType = formType;
        this.formTypeName = formTypeName;
        this.fromState = fromState;
        this.toState = toState;
        this.developer = developer;
        this.businessUnit = businessUnit;
        this.codeLocation = codeLocation;
        this.businessModelId = businessModelId;
        this.modifiedBy = modifiedBy;
        this.modifiedByName = modifiedByName;
        this.documentationUrl = documentationUrl;
        this.modifiedTimeStamp = modifiedTimeStamp;
        this.inUse = { inUse: false, byGroups: [] };
        this.version=version;
        this.workGoup=workGroup;
        this.nameVersion=sas.stress.wkbench.StressUtil.getNameVersion(this.name,this.version);
    }
});

sas.stress.models.Model.prototype.getId = function () {
    return this.id;
};
sas.stress.models.Model.prototype.getName = function () {
    return this.name;
};
sas.stress.models.Model.prototype.getDescription = function () {
    return this.description;
};
sas.stress.models.Model.prototype.getUpdatedByUser = function () {
    return this.updatedByUser;
};
sas.stress.models.Model.prototype.getUpdatedTimestamp = function () {
    return this.updatedTimestamp;
};
sas.stress.models.Model.prototype.getCreatedByUser = function () {
    return this.createdByUser;
};
sas.stress.models.Model.prototype.getCreatedTimestamp = function () {
    return this.createdTimestamp;
};
sas.stress.models.Model.prototype.getCode = function () {
    return this.code;
};
sas.stress.models.Model.prototype.getCustomAttributes = function () {
    return this.customattributes;
};
sas.stress.models.Model.prototype.getModelId = function () {
    return this.modelId;
};

sas.stress.models.Model.prototype.getOwner = function () {
    return this.owner;
};
sas.stress.models.Model.prototype.getSourceType = function () {
    return this.sourceType;
};
sas.stress.models.Model.prototype.getFormType = function () {
    return this.formType;
};
sas.stress.models.Model.prototype.getFormTypeName = function () {
    return this.formTypeName;
};
sas.stress.models.Model.prototype.getFromState = function () {
    return this.fromState;
};
sas.stress.models.Model.prototype.getToState = function () {
    return this.toState;
};
sas.stress.models.Model.prototype.getDeveloper = function () {
    return this.developer;
};
sas.stress.models.Model.prototype.getBusinessUnit = function () {
    return this.businessUnit;
};
sas.stress.models.Model.prototype.getCodeLocation = function () {
    return this.codeLocation;
};
sas.stress.models.Model.prototype.getBusinessModelId = function () {
    return this.businessModelId;
};
sas.stress.models.Model.prototype.getModifiedBy = function () {
    return this.modifiedBy;
};
sas.stress.models.Model.prototype.getModifiedByName = function () {
    return this.modifiedByName;
};
sas.stress.models.Model.prototype.getDocumentationUrl = function () {
    return this.documentationUrl;
};
sas.stress.models.Model.prototype.getModifiedTimeStamp = function () {
    return this.modifiedTimeStamp;
};
sas.stress.models.Model.prototype.getDateInterval = function () {
    return this.dateInterval;
};
sas.stress.models.Model.prototype.getInUse = function () {
    return this.inUse;
};
sas.stress.models.Model.prototype.setInUse = function (inUse) {
    this.inUse = inUse;
};
sas.stress.models.Model.prototype.getNameVersion=function(){
    return this.nameVersion;
};

sas.stress.models.Model._models = {};
sas.stress.models.Model._json = [];
/*sas.stress.models.Model._modelcategories=[];
 sas.stress.models.Model._categoriesjson=[];*/
sas.stress.models.Model._currentId = null;
sas.stress.models.Model._pollTimeOutIDs = [];
sas.stress.models.Model.getModels = function (RB) {
    var deferred = $.Deferred();
    if (_.size(sas.stress.models.Model._models)>0&&RB===undefined){
        deferred.resolve(sas.stress.models.Model._models);
    }
    sas.stress.wkbench.StressAPI.loadModels(RB).done(function (modelsJSON) {
        sas.stress.models.Model._models = {};
        var models = [];
        _.each(modelsJSON, function (json) {
            var model = new sas.stress.models.Model(json.id, json.name, json.description, json.dateInterval, json.updatedTimestamp,
                json.createdTimestamp, json.createdByUser, json.updatedByUser, json.customAttributes, json.code, json.modelId,
                json.owner, json.sourceType, json.formType, json.formTypeName, json.fromState, json.toState, json.developer,
                json.businessUnit, json.codeLocation, json.businessModelId, json.modifiedBy, json.modifiedByName,
                json.documentationLink, json.modifiedTimeStamp,json.version, json.workgroupName);
            sas.stress.models.Model._models[model.id] = model;
            models.push(model);
        });
        sas.stress.models.Model._jsonifymodels(modelsJSON, RB).done(function (json) {
            deferred.resolve(models, json);
        });
    }).fail(function (jqxhr) {
        deferred.reject(jqxhr);
    });
    return deferred;
};

/* the below are static functions for the polling timeout IDs */
sas.stress.models.Model.getPollTimeoutIDs = function () {
    return sas.stress.models.Model._pollTimeOutIDs;
};
sas.stress.models.Model.clearPollTimeoutIDs = function () {
    sas.stress.models.Model._pollTimeOutIDs = [];
};


sas.stress.models.Model.loadAndCategorizeModels = function (projectid, RB) {
    var deferred = $.Deferred();
    sas.stress.models.Model._modelcategories = {};

    sas.stress.wkbench.StressAPI.loadModelsByProject(projectid).done(function (modelsJSON) {
        var executing = 0;
        sas.stress.models.Model._jsonifymodels(modelsJSON, RB, executing).done(function (json, executing) {
            deferred.resolve(json, executing); //sas.stress.models.Model._modelcategories,
        }).fail(function (e) {
            deferred.reject(e);
        });

    }).fail(function (jqXHR) {
        deferred.reject(jqXHR);
    });

    return deferred;
};

sas.stress.models.Model._jsonifymodels = function (modelsJSON, RB, executing) {
    var deferred = $.Deferred();

    try {
        var category = "";
        var modelcategoryCount = 0;
        //var length=models.length;
        var _categories = {};
        if (RB === undefined) {
            RB = sap.ui.getCore().getLibraryResourceBundle("sas.stress.models");
        }
        var uncategorized = (RB) ? RB.getText("model.category.no.name.txt") : "Uncategorized";
        var allcategory = (RB) ? RB.getText("model.category.all.name.txt") : "All";
        var json = { categories: [], models: [] }; // jsz: selectedSheetCategory: []};

        // the all category will contain the total count and it goes first
        _categories[allcategory] = modelsJSON.length;

        // push the uncategoried category first with count of 0..
        // the un-categorized will only exist if there are models that have "no category"
        //_categories[uncategorized]=0;

        // now let's loop
        _.each(modelsJSON, function (model, idx) {
            var modelRep = model.modelRep || model;
            var modelRun = model.modelRun;

            var categoryname = "", periodType = "", version = "", executionType = "", sourceType = "", businessUnit = "", codeLocation = ""; // S1193425

            var status = "", runUser = "", key = "",nameVersion="";
            var runTS;
            var runErrors = [];

            // find the current model category
            categoryname = modelRep.category || uncategorized;

            // store the model count in the 'uncategorized' category
            modelcategoryCount = _categories[categoryname] || 0;
            // increment the count &&
            modelcategoryCount++;
            _categories[categoryname] = modelcategoryCount;

            // The other custom attributes
            // version
            version = modelRep.version || null;
            // executionType
            executionType = modelRep.executionType || null;
            //sourceType
            sourceType = modelRep.sourceType || null;
            //business unit
            businessUnit = modelRep.businessUnit || null;
            //codeLocation
            codeLocation = modelRep.codeLocation || null;
            if (modelRun) {
                if (modelRun.status === "Running" || modelRun.status === "Scheduled") {
                    executing++;
                }
                status = modelRun.status;
                runTS = (status !== "NotRun") ? modelRun.timestamp : null;
                runUser = modelRun.user;
                runErrors = modelRun.errors;
                key = modelRun.key;
            }
            // the name version combination
            nameVersion=sas.stress.wkbench.StressUtil.getNameVersion(modelRep.name,version);

            json.models.push(
                {
                    id: modelRep.id,
                    modelId: modelRep.modelId,
                    name: modelRep.name,
                    description: modelRep.description,
                    createdTimestamp: modelRep.createdTimeStamp, // fixes for S1190675
                    updatedTimestamp: modelRep.modifiedTimeStamp,
                    createdByUser: modelRep.createdBy,
                    createdByName: modelRep.createdByName,
                    updatedByUser: modelRep.modifiedBy,
                    //owner:modelRep.owner:model.owner,
                    developer: modelRep.developer,
                    formType: modelRep.formType,
                    formTypeName: modelRep.formTypeText,
                    modifiedBy: modelRep.modifiedBy,
                    modifiedByName: modelRep.modifiedByName,
                    /*fromState:modelRep.fromState,
                     toState:modelRep.toState,*/
                    modifiedTimeStamp: modelRep.modifiedTimeStamp,
                    documentationLink: modelRep.documentationLink,
                    loadHistory: modelRep.loadHistoryFlag,
                    nameVersion:nameVersion,
                    runStatus: status,
                    runTimestamp: runTS,
                    runUser: runUser,
                    runErrors: runErrors,
                    key: key,
                    category: categoryname,
                    periodType: modelRep.dateInterval,
                    executionType: executionType,
                    version: version,
                    sourceType: sourceType,
                    businessUnit: businessUnit,
                    codeLocation: codeLocation,
                    workGroup:modelRep.workgroupName
                }
            );
        });
        var idx = 0;
        _.each(_categories, function (count, category) {
            json.categories.push({ key: idx, name: category, count: count });
            idx++;
        });

        deferred.resolve(json, executing);
    } catch (ex) {
        deferred.reject(ex);
    }
    return deferred;
};

/*
 *
 * @param modelId
 * @returns {*}
 */
sas.stress.models.Model.getModel = function (modelId) {
    if (sas.stress.models.Model._models) {
        return sas.stress.models.Model._models[modelId];
    } else {
        sas.stress.models.Model.getModels().done(function (models, json) {
            return sas.stress.models.Model._models[modelId];
        }).fail(function (jqxhr) {
            return undefined;
        });
    }
};

sas.stress.models.Model.getModelsByInterval = function (interval) {
    var _models = [];
    _models = _.filter(sas.stress.models.Model._models, function (model, key) {
        return model.getDateInterval().toUpperCase() === interval.toUpperCase();
    });

    return _models;
};

sas.stress.models.Model._getDateIntervals = function () {
    var interval = "";
    var modelIntervalCount = 0;
    var _intervals = {};

    //first push all the valid period types
    _intervals["YEAR"] = 0;
    _intervals["SEMIYEAR"] = 0;
    _intervals["QUARTER"] = 0;
    _intervals["MONTH"] = 0;
    _intervals["WEEK"] = 0;

    _.each(sas.stress.models.Model._models, function (model, key) {
        interval = model.getDateInterval();
        if (interval.length > 0) {
            // store the model count in the 'uncategorized' category
            modelIntervalCount = _intervals[interval] || 0;
            // increment the count &&
            modelIntervalCount++;
            _intervals[interval] = modelIntervalCount;
        }
    });

    return _intervals;
};