jQuery.sap.require("sap.ui.core.format.DateFormat");
jQuery.sap.require("sap.ui.model.Filter");
jQuery.sap.require("sap.ui.model.Sorter");
jQuery.sap.require("sap.ui.model.resource.ResourceModel");
jQuery.sap.require("sap.ui.model.resource.ResourceModel");
jQuery.sap.require("sas.stress.wkbench.ViewManager");
jQuery.sap.require("sas.stress.wkbench.StressAPI");
jQuery.sap.require("sas.stress.wkbench.StressUtil");
jQuery.sap.require("sas.stress.wkbench.widget.MessageDetailsBox");

sap.ui.controller("sas.stress.models.view.browse.CommonModelDetails", {

    onInit: function () {
        var view = this.getView();
        this._init();
    },
    _init: function () {
        var ctrl = this;
        var view = this.getView();

        ctrl.i18N = new sap.ui.model.resource.ResourceModel({ bundleName: "sas.stress.models.messagebundle" });
        view.setModel(ctrl.i18N, "i18N");
        var modelid = view.getViewData().modelId;
        ctrl.modelId=modelid;
        /*$.when(*/
        sas.stress.wkbench.StressAPI.getModel(0, modelid).done(function (jsonmodel) {
            var rb = ctrl.i18N.getResourceBundle();

            // create the variables json from the jsonmodel.modelRep.
            // variables are 2 types: input and output... they come in 2 objects.. need to combine them into one
            var variablesjson = { variables: [] };
            var variables = {};
            variables[rb.getText("variables.type.input.txt")] = jsonmodel.modelRep.rootInputVars;
            variables[rb.getText("variables.type.output.txt")] = jsonmodel.modelRep.outputVars;
            _.each(variables, function (values, key) {
                _.each(values, function (variable) {
                    variablesjson.variables.push({ type: key, name: (variable.name) || variable });
                });
            });
            // the view's model == the jsonmodel
            var model = new sas.stress.wkbench.model.RiskJSONModel(jsonmodel);
            view.setModel(model);

            //view.breadCrumb.removeAllItems();
            //view.breadCrumb.addBreadcrumbItem("Top", rb.getText("models.header.title"));
            //view.breadCrumb.addBreadcrumbItem("New", model.getProperty("/modelRep/name"));

            // the variables model goes onto the variables table directly.. the
            var variablesmodel = new sas.stress.wkbench.model.RiskJSONModel(variablesjson);
            view.variablesTable.setModel(variablesmodel);

            // the code
            view.editor.setText(jsonmodel.modelCode.code);

            var dateTimeFormat = sap.ui.core.format.DateFormat.getDateTimeInstance(
                {
                    /*pattern: "MM/dd/yyyy',' HH:mm", */
                    nosec: true,
                    notzone: true
                }
            ); // style: "short"
            var format = "";
            if (jsonmodel.modelRep.createdTimeStamp !== null) {
                format = dateTimeFormat.format(new Date(jsonmodel.modelRep.createdTimeStamp));
            }

            var propData = {};
            propData.modelRep = [];
            var propReq = rb.getText("modelDetails.requiredHeader.label.txt");
            var propOpt = rb.getText("modelDetails.optionalHeader.label.txt");
            propData.modelRep.push(
                {
                    title: rb.getText("modelDetails.businessUnit.label.txt"),
                    description: jsonmodel.modelRep.businessUnit,
                    type: propOpt
                }
            );
            propData.modelRep.push(
                {
                    title: rb.getText("modelDetails.category.label.txt"),
                    description: jsonmodel.modelRep.category,
                    type: propOpt
                }
            );
            propData.modelRep.push(
                {
                    title: rb.getText("modelDetails.codeLocation.label.txt"),
                    description: jsonmodel.modelRep.codeLocation,
                    type: propOpt
                }
            );
            propData.modelRep.push(
                {
                    title: rb.getText("modelDetails.createdByUser.label.txt"),
                    description: jsonmodel.modelRep.createdBy,
                    type: propOpt
                }
            );
            propData.modelRep.push(
                {
                    title: rb.getText("modelDetails.createdTimestamp.label.txt"),
                    description: format,
                    type: propReq
                }
            );
            // S1190710
            var desc = "";
            switch (jsonmodel.modelRep.dateInterval) {
                case "YEAR":
                    desc = rb.getText("modelgroup.periodtype.year.txt");
                    break;
                case "SEMIYEAR":
                    desc = rb.getText("modelgroup.periodtype.semiyear.txt");
                    break;
                case "QUARTER":
                    desc = rb.getText("modelgroup.periodtype.quarter.txt");
                    break;
                case "MONTH":
                    desc = rb.getText("modelgroup.periodtype.month.txt");
                    break;
                case "WEEK":
                    desc = rb.getText("modelgroup.periodtype.month.txt");
                    break;
                default:
                    desc = rb.getText("modelgroup.periodtype.year.txt");
                    break;
            }
            propData.modelRep.push(
                {
                    title: rb.getText("modelDetails.dateInterval.label.txt"),
                    description: desc,
                    type: propReq
                }
            );
            propData.modelRep.push(
                {
                    title: rb.getText("modelDetails.dependencies.label.txt"),
                    description: jsonmodel.modelRep.dependencies,
                    type: propOpt
                }
            );
            propData.modelRep.push(
                {
                    title: rb.getText("modelDetails.developer.label.txt"),
                    description: jsonmodel.modelRep.developer,
                    type: propOpt
                }
            );
            propData.modelRep.push(
                {
                    title: rb.getText("modelDetails.executionType.label.txt"),
                    description: jsonmodel.modelRep.executionType,
                    type: propReq
                }
            );
            // S1190710
            var formtype = "";
            switch (jsonmodel.modelRep.formType) {
                case "logit":
                    formtype = rb.getText("model.formtype.logit.txt");
                    break;
                case "linear":
                    formtype = rb.getText("model.formtype.linear.txt");
                    break;
                case "proportionalHazard":
                    formtype = rb.getText("model.formtype.proportionalHazard.txt");
                    break;
                case "fractionalLogit":
                    formtype = rb.getText("model.formtype.fractionalLogit.txt");
                    break;
                case "timeSeries":
                    formtype = rb.getText("model.formtype.timeSeries.txt");
                    break;
                case "external":
                    formtype = rb.getText("model.formtype.external.txt");
                    break;
                default:
                    formtype = rb.getText("model.formtype.timeSeries.txt");
                    break;
            }
            propData.modelRep.push(
                {
                    title: rb.getText("modelDetails.formType.label.txt"),
                    description: formtype,
                    type: propReq
                });
            /*
             * fixes for: S1272125
             propData.modelRep.push(
             {
             title: rb.getText("modelDetails.loadHistoryFlag.label.txt"),
             description: jsonmodel.modelRep.loadHistoryFlag,
             type: propReq
             });
             */
            propData.modelRep.push({
                    title: rb.getText("modelDetails.name.label.txt"),
                    description: jsonmodel.modelRep.name,
                    type: propOpt
                }
            );
            // S1190710
            var resultformtype = "";
            switch (jsonmodel.modelRep.resultVariableForm) {
                case "probability":
                    resultformtype = rb.getText("model.result.formtype.probability.txt");
                    break;
                case "oddsratio":
                    resultformtype = rb.getText("model.result.formtype.oddsratio.txt");
                    break;
                case "proportion":
                    resultformtype = rb.getText("model.result.formtype.proportion.txt");
                    break;
                default:
                    resultformtype = rb.getText("model.formtype.timeSeries.txt");
                    break;
            }
            propData.modelRep.push(
                {
                    title: rb.getText("modelDetails.resultVariableForm.label.txt"),
                    description: resultformtype,
                    type: propReq
                }
            );
            propData.modelRep.push(
                {
                    title: rb.getText("modelDetails.sourceType.label.txt"),
                    description: jsonmodel.modelRep.sourceType,
                    type: propOpt
                }
            );
            propData.modelRep.push(
                {
                    title: rb.getText("modelDetails.version.label.txt"),
                    description: jsonmodel.modelRep.version,
                    type: propOpt
                }
            );
            propData.modelRep.push(
                {
                    title:rb.getText("modelDetails.WorkGroup.hdr.txt"),
                    description: jsonmodel.modelRep.workgroupName,
                    type: propReq
                }
            );

            view.propList.setModel(new sas.stress.wkbench.model.RiskJSONModel(propData));

        }).fail(function (jqXHR, status, error) {
            if (jqXHR) {
                var responseJSON = (jqXHR.responseJSON) ? jqXHR.responseJSON : JSON.parse(jqXHR.responseText);
                sas.stress.wkbench.widget.MessageDetailsBox.error(responseJSON, sas.config.appName);
            }
        });
    },

    onExit: function () {

    },

    breadcrumbClickHandler: function (event) {
        switch (event.getParameter("item").getKey()) {
            case "Top":
                sas.eventBus.publish(sas.stress.wkbench.EventBusConstants.CHANNEL_NAME, sas.stress.wkbench.EventBusConstants.VIEW_MODELS, {});
                break;
        }
    },

    onFilterChanged: function (e) {
        var value = e.getSource().getValue() || "";
        var table = this.getView().variablesTable;
        var nameFilter = new sap.ui.model.Filter("name", sap.ui.model.FilterOperator.Contains, value);
        var typeFilter = new sap.ui.model.Filter("type", sap.ui.model.FilterOperator.Contains, value);
        var allFilters = new sap.ui.model.Filter([nameFilter, typeFilter]);
        var binding = table.getBinding("rows");
        binding.filter(allFilters);
    }
});