jQuery.sap.require("sap.ui.core.routing.Router");
jQuery.sap.require("sas.risk.common.utils.NavChecker");

sas.stress.wkbench.StressUtil = {
    calculateColumnAlias:function(columnIndex){
    	columnIndex=columnIndex;
    	if(columnIndex<0){
            return "";
        }
    	var calc=function(index){
        	var over=Math.floor((index)/26);
        	var remainder=index % 26;
        	var result="";
    		if (over>0) {
    			result+=calc(over-1);
    		}
    		return result+String.fromCharCode(65+remainder);
    	};
    	return calc(columnIndex);
    },
    validateDatePicker:function(elemId) {
        sap.ui.getCore().attachParseError(
            function(oEvent) {
                var oElement = oEvent.getParameter("element");
                if (oElement.getId() === elemId) {
                    oElement.setValueState(sap.ui.core.ValueState.Error);
                }
            });

        sap.ui.getCore().attachValidationSuccess(
            function(oEvent) {
                var oElement = oEvent.getParameter("element");
                if (oElement.getId() === elemId) {
                    oElement.setValueState(sap.ui.core.ValueState.Success);
                }
            });
    },
    handleDatePickerChange:function(event, required) {
        var validDate = event.getParameter("valid");
        var datePicker = event.getSource();
        if (required && datePicker.getEnabled() && datePicker.getValue().length < 1) {
            validDate = false;
        }
        if (validDate) {
            datePicker.setValueState(sap.ui.core.ValueState.None);
        } else {
            datePicker.setValueState(sap.ui.core.ValueState.Error);
        }
    },
    getCaretPosition:function(elemId){
        var elem = document.getElementById(elemId);
		var iCaretPos = 0;
		if (document.selection) {//IE Support
			elem.focus ();
			var oSel = document.selection.createRange ();
			oSel.moveStart ('character', -elem.value.length);
			iCaretPos = oSel.text.length;
		} else if (elem.selectionStart || elem.selectionStart === '0'){
			iCaretPos = elem.selectionStart;
		}
		return iCaretPos;
    },
    setCaretPosition:function(elemId, caretPos) {
        var elem = document.getElementById(elemId);
        caretPos=(caretPos===undefined)?elem.value.length:caretPos;
        if(elem != null) {
            if(elem.createTextRange) {
                var range = elem.createTextRange();
                range.move('character', caretPos);
                range.select();
            } else {
                elem.focus();
                if(elem.selectionStart !== undefined) {
                    elem.setSelectionRange(caretPos, caretPos);
                }
            }
        }
    },
    _userName : "",
    setUserName : function(userName) {
    	sas.stress.wkbench.StressUtil._userName = userName;
    },
    getUserName : function() {
    	var userName = "";
    	var oUserInfo = sas.hc.ui.core.util.UserInfo.instance;
    	if (oUserInfo !== undefined) {
    		userName = oUserInfo.name; // I don't know what object property to use. Assuming name.
    	} else {
    		userName = sas.stress.wkbench.StressUtil._userName;
    	}
    	return userName;
    },
    _userWorkGroups : [],
    setUserWorkGroups : function(userWorkGroups) {
        sas.stress.wkbench.StressUtil._userWorkGroups = userWorkGroups;
    },
    getUserWorkGroups : function() {
        return sas.stress.wkbench.StressUtil._userWorkGroups;
    },
    _rb:sap.ui.getCore().getLibraryResourceBundle("sas.stress.wkbench"),
    getBundle:function(){
    	return sas.stress.wkbench.StressUtil._rb;
    },
    getSolutionURLs:function(e) {
        var deferred = $.Deferred();
        $.getJSON("rest/sysinfo", function (urls) {
            deferred.resolve(urls);
        }).fail(function (jqxhr, textStatus, errorThrown) {
            jQuery.sap.log.error("loading solution URLs FAILURE: " + errorThrown);
            deferred.reject(jqxhr);
        });
        return deferred;
    },
    launchSASScenarioEditor:function(id) {
        $.when(sas.stress.wkbench.StressAPI.getScenarioManagerClientVersion(), this.getSolutionURLs()).done(function (useClassic, urls) {
            var url;
            if (useClassic === true) {
                url = urls.hpriskUrl + "/HPRisk.jsp?scenarioEditor=true&scenarioId=" + id;
            } else {
                url = urls.scenarioEditorUrl + "?id=" + id;
            }
            var scenarioWindow = window.open(url, '_blank');
        }).fail(function (jqxhr) {
            sas.stress.wkbench.StressUtil.handleServerFailure(jqxhr);
        });
    },
    _differenceObj:function(obj1,obj2) {
        return _.filter(obj1, function (o1) {
            return !_.some(obj2, function (o2) {
                return o1.equals(o2);
            });
        });
    },
    _isValidName:function(name){
        // UTF-8 or DBCS characters are not allowed, the other reg ex will allow UTF-8 or DBCS characters
        var isValid=name.match(/[^\w]/gi);  /* /[`~!@#$%^&*()|+\-=?;:'",.<>\{\}\[\]\\\/ ]/gi*/
        if (isValid&&isValid.length){
            return false;
        }
        return true;
    },
    _getCleanColumnName:function(name){
        var cleaned=name.replace(/[`~!@#$%^&*()|+\-=?;:'",.<>\{\}\[\]\\\/ ]/gi, "_"); // /[^\w]/gi
        if (cleaned.length>32) {
            return cleaned.substring(0, 31); //only need 32 characters
        }else{
            return cleaned;
        }
    },
    _updateFiltersPanelSize:function(bvisible,facets) {
        // wait for the rendering to occur before applying the height
        /*var $mainpanel = document.getElementsByClassName("sasFacetPanel_facetsArea")[0];	// the facets area
        var $area = document.getElementsByClassName("sapUiBorderLayoutBottom")[0];	// the button area
        var scrolllist = document.getElementsByClassName("sapMScrollCont sapMScrollContV sasDescriptionFacet-scroll");	// the list of scrollable facets
        var h = $mainpanel.scrollHeight - $area.scrollHeight;	// discount the button area height
        var items = scrolllist.length;
        if (bvisible) {
            _.each(scrolllist, function (filterlist, idx) {
                var $list = filterlist;
                if (items > 1&&facets[idx]) {
                    if (facets[idx].list.getItems().length >= 10) {
                        $list.style.height = (h - 130).toString() + "px";
                    }
                } else {
                    if ((h - 450) > 300) {
                        $list.style.height = (h - 450).toString() + "px";
                    } else {
                        $list.style.height = $mainpanel.scrollHeight.toString() + "px"
                    }
                }
            });
        }*/
    },
    _updateFilterFacetSize:function(bvisible,facet,idx) {
        // wait for the rendering to occur before applying the height
        /*var $mainpanel = document.getElementsByClassName("sasFacetPanel_facetsArea")[0];	// the facets area
        var $area = document.getElementsByClassName("sapUiBorderLayoutBottom")[0];	// the button area
        var scrolllist = document.getElementsByClassName("sapMScrollCont sapMScrollContV sasDescriptionFacet-scroll");	// the list of scrollable facets
        var h = $mainpanel.scrollHeight - $area.scrollHeight;	// discount the button area height
        var items = scrolllist.length;
        if (bvisible) {
            var $list = scrolllist[idx];
            if (items > 1) {
                if (facet.list.getItems().length >= 10) {
                    $list.style.height = (h - 130).toString() + "px";
                }
            } else {
                if ((h - 450) > 300) {
                    $list.style.height = (h - 450).toString() + "px";
                } else {
                    $list.style.height = $mainpanel.scrollHeight.toString() + "px"
                }
            }
        }*/
    },

    /**
     * Create a NacChecker and start if needed
     * @param {boolean} start whether or not start immediately
     * @param {sap.ui.core.mvc.View} view the View that the NavChecker needs to destroy when exit
     * @return {sas.risk.common.utils.NavChecker} the navChecker
     */
    createNavChecker: function (start, view) {
        var router = sap.ui.core.routing.Router.getRouter("router");
        var navChecker = new sas.risk.common.utils.NavChecker(sas.config.getAppId(), this._rb.getText("project.dirty.question.txt"), router);
        if (start) {
            if (view && view.destroy) {
                var callback = $.proxy(view.destroy, view);
            }
            navChecker.start(callback);
        }
        return navChecker;
    },

    /**
     * Popup a confirmation that is similar to NavChecker if the page is dirty, and call back to continue
     * @param {boolean} isDirty whether or not the page is dirty
     * @param {function} continueCallback back function if page is not dirty or ok to continue
     * @param {Object} callbackParam callback function's parameter if needed
     */
    confirmBeforeContinue: function (isDirty, continueCallback, callbackParam) {
        if (isDirty) {
            if (confirm(this._rb.getText("project.dirty.question.txt"))) {
                continueCallback(callbackParam);
            }
        } else {
            continueCallback(callbackParam);
        }
    },

    /**
     * Popup a confirmation that is similar to NavChecker if the page is dirty, and call back to continue
     * @param {boolean} isDirty whether or not the page is dirty
     * @return {boolean} if it is ok to continue
     */
    confirmToContinue: function (isDirty) {
        if (isDirty) {
            if (!confirm(this._rb.getText("project.dirty.question.txt"))) {
                return false;
            }
        }
        return true;
    },
    /**
     * Allows setting a custom label for the given sas.hc.m.SearchField element's
     * landmark in the Landmarks dialog. This is particularly necessary for SearchField
     * because there is another search field in the SAS common UI shell which generically
     * appears as "Search" in the Landmarks dialog. This function allows us to create a
     * distinguishable Landmark label for MIP specific search fields (ex: "Search Models",
     * "Search Variables", etc.)
     * See S1221065
     *
     * @param {sas.hc.m.SearchField} quickSearchField search field
     * @param {string} landmarkText - landmark text
     */
    setQuickSearchLandmarkLabel: function(quickSearchField, landmarkText) {
        quickSearchField.onAfterRendering = function() {
            sas.hc.m.SearchField.prototype.onAfterRendering.apply(quickSearchField, arguments);
            $("form", quickSearchField.getDomRef()).attr({
                "data-landmark-label": landmarkText
            });
        };
    },
    /**
     * Handle server error with message popup
     * @param {Object} errorResponse error response object
     */
    handleServerFailure: function (errorResponse) {
        if (errorResponse) {
            try {
                var responseJSON = errorResponse.responseJSON|| errorResponse.response  || JSON.parse(errorResponse.responseText);
                if (responseJSON) {
                    if (typeof(responseJSON)!=="object"){   // S1341678 HF5..
                        responseJSON=JSON.parse(responseJSON);
                    }
                    sas.stress.wkbench.widget.MessageDetailsBox.error(responseJSON, sas.config.appName);
                }
            } catch(ex) {
                var errorMsg = errorResponse.responseText || ex.message;
                sas.hc.m.MessageBox.error(errorMsg, sas.config.appName);
            }
        } else {
            sas.hc.m.MessageBox.error(this._rb.getText('error.message.txt'), this._rb.getText('error.window.title'));
        }
    },

    /*
     * Common method for downloading files
     *
     * @param {Object} the response of the download request
     * @param {String} the filename
     * @private
     */
    _downloadHandler: function (response, filename) {
        if (window.navigator.msSaveBlob) {
            window.navigator.msSaveBlob(response, filename);
        } else {
            var downloadUrl = URL.createObjectURL(response);
            var a = document.createElement("a");
            a.href = downloadUrl;
            a.download = decodeURIComponent((filename+'').replace(/\+/g, '%20'));   // fixes for S1188266
            a.textContent = "error message";
            document.body.appendChild(a);
            a.click();
        }
    },
    /*
     * Commmon Method that is shared between wkbench/Taskdownload and reports/downloadReport
     * @param {Integer} attachmentId
     * @returns {*}
     * @private
     */
    _downloadAttachment: function (attachmentId) {
        // fixes for S1188266
        //$("#xlsFrame").attr('src', 'rest/attachments/' + attachmentId);
        var deferred = $.Deferred();
        var self = this;
        var exportURL = 'rest/attachments/' + attachmentId;

        var xhr = new XMLHttpRequest();
        xhr.open("GET", exportURL, true);
        xhr.responseType = "blob";
        xhr.onload = function (e) {
            switch (this.status) {
                case 200:
                {
                    var contentDispositionHeader = xhr.getResponseHeader("content-disposition");
                    var fileName = contentDispositionHeader.slice(contentDispositionHeader.indexOf("filename")).replace("filename=\"", "").replace("\"", "");
                    sas.stress.wkbench.StressUtil._downloadHandler(this.response, fileName);
                    deferred.resolve();
                }
                    break;
                default:
                {
                    jQuery.sap.log.error(e.target.statusText);
                    sas.stress.wkbench.StressUtil._downloadHandler(this.response, "Error.txt");
                    deferred.reject(e.target.statusText);
                }
                    break;
            }
        };
        xhr.onerror = function (e) {
            console.log(e);
            //alert('Unable to download excel.');
            deferred.reject(e.target.statusText);
        };
        xhr.send(); //

        return deferred;
    },
    getNameVersion:function(name,version){
        if (version) {
            var rb = sap.ui.getCore().getLibraryResourceBundle("sas.stress.config");
            return rb.getText("hierarchy.NameVersion.fmt.txt", [name, version]);
        }
        return name;
    },
    getConfirmationMessage: function (confirmationText, itemNames) {

        //if (itemNames && itemNames.length > 0) {
            confirmationText += "\n\n";
            var rb = this._rb;
            _.each(itemNames, function (itemName) {
                confirmationText += rb.getText("list.bullet.txt") + itemName + "\n";
            });
        //}
        return confirmationText;
    },
    /**
     *
     * @param number
     * @param precision
     * @returns {number}
     */
    precisionRound: function (number, precision) { // S1401405
        precision=precision===undefined?10:precision;
        var factor = Math.pow(10, precision);
        return Math.round(number * factor) / factor;
    }
};