jQuery.sap.declare("sas.stress.wkbench.model.CellRef");
jQuery.sap.require("sas.stress.wkbench.model.Project");

sas.stress.wkbench.model.CellRef=function(column,row,filter/*scenario*/){
	this.column=column;
	this.row=row;
	this.filterId/*scenarioId*/=filter/*scenario*/.getId();
	this.filterName/*scenario*/=filter/*scenario*/.getId();
	this.sheetInfo=filter/*scenario*/.getSheetInfo();
	this.sheetId=this.sheetInfo.getSheet().getId();
	this.sheetName=this.sheetInfo.getSheet().getName();

	var infoData=this.sheetInfo.getData();
	var row=infoData.rows[row];
	var col=infoData.columns[column];
	this.colLong=col.long;
	this.rowLong=row.long;
	this.colShort=col.short;
	this.rowShort=row.short;
};
sas.stress.wkbench.model.CellRef.prototype={
	/*getScenario:function(){
		var project=sas.stress.wkbench.model.Project.getCurrentProject();
		var sheet=project.getSheet(this.sheetId);
		return sheet.getInfo().getScenario(this.scenarioId);
	},*/
    getSheetFilters:function(){
        var project=sas.stress.wkbench.model.Project.getCurrentProject();
        var sheet=project.getSheet(this.sheetId);
        return sheet.getInfo().getFilters();
    },
	getInfoData:function(){
		var project=sas.stress.wkbench.model.Project.getCurrentProject();
		var sheet=project.getSheet(this.sheetId);
		return sheet.getInfo().getData();
	},
	/*getScenarioData:function(){
		return this.getScenario().getData();
	},*/
    getFilterData:function(){
        return this.getSheetFilters().getData();
    },
	toIdString:function(){
		return this.column+":"+this.row+":"+this.filterId/*scenarioId*/+":"+this.sheetId;
	},
	toString:function(format){
		switch(format){
			case sas.stress.wkbench.model.CellRef.FMT_CELL_LONG_LOCAL:
				return "$"+this.colLong+"$"+this.rowLong;
			case sas.stress.wkbench.model.CellRef.FMT_CELL_LONG_LOCAL_BY_SCENARIO:
				return "'"+this.sheetName+"'!$"+this.colLong+"$"+this.rowLong;
			case sas.stress.wkbench.model.CellRef.FMT_CELL_SHORT_LOCAL:
				return this.colShort+this.rowShort;
			case sas.stress.wkbench.model.CellRef.FMT_CELL_SHORT_LOCAL_BY_SCENARIO:
				return "'"+this.sheetName+"'!"+this.colShort+this.rowShort;
			case sas.stress.wkbench.model.CellRef.FMT_CELL_SHORT:
				return "'"+this.sheetName+" - "+this.filterName/*.scenarioName*/+"'!"+this.colShort+this.rowShort;
//			case sas.stress.wkbench.model.CellRef.FMT_SCENARIO_DIVID:
//				return this.sheetId+"_"+this.scenarioId;
			case sas.stress.wkbench.model.CellRef.FMT_CELL_DIVID:
				return this.sheetId+"_"+this.filterId/*.scenarioId*/+"_"+this.column+"_"+this.row;
			default:
				return "'"+this.sheetName+
			    ((this.filterId/*.scenarioId*/!==undefined)?" - "+this.filterName/*.scenarioName*/+"'!":"'!")+
				((this.colLong!==undefined)?"$"+this.colLong:"")+
				((this.rowLong!==undefined)?"$"+this.rowLong:"");
		}
	},
	equals:function(other){
		return other &&
			   this.sheetId===other.sheetId &&
			   this.filterId/*.scenarioId*/===other.filterId/*.scenarioId*/ &&
			   this.colLong===other.colLong &&
			   this.rowLong===other.rowLong;
	},
	getRowNode:function(){
		var infoData=this.sheetInfo.getData();
		var row=infoData.rows[this.row];

		return row.node;
	},
	getColumnNode:function(){	// fixes for allocations on columns
		var infoData=this.sheetInfo.getData();
		var col=infoData.columns[this.column];

		var nodeParent=col.node.getParent();
		var subtotalChild=nodeParent.getChildren()[0];
		if (subtotalChild){
			return subtotalChild;
		}
		return nodeParent;
	},
	destroy:function(){
		this.sheetInfo=undefined;
	}
};
sas.stress.wkbench.model.CellRef.FMT_CELL_SHORT="FMT_CELL_SHORT";
sas.stress.wkbench.model.CellRef.FMT_CELL_SHORT_LOCAL="FMT_CELL_SHORT_LOCAL";
sas.stress.wkbench.model.CellRef.FMT_CELL_SHORT_LOCAL_BY_SCENARIO="FMT_CELL_SHORT_LOCAL_BY_SCENARIO";
sas.stress.wkbench.model.CellRef.FMT_CELL_LONG_LOCAL="FMT_CELL_LONG_LOCAL";
sas.stress.wkbench.model.CellRef.FMT_CELL_LONG_LOCAL_BY_SCENARIO="FMT_CELL_LONG_LOCAL_BY_SCENARIO";
sas.stress.wkbench.model.CellRef.FMT_CELL_DIVID="FMT_CELL_DIVID";

sas.stress.wkbench.model.CellRef.getCellRefs=function(incoming,scenario){
	var CellRef=sas.stress.wkbench.model.CellRef;
    var range=incoming.split(":");
	switch(range.length){
        case 2:
			var id1=CellRef.getCellRef(range[0],scenario);
			var id2=CellRef.getCellRef(range[1],id1.getSheetFilters()/*getScenario()*/); // fixes for S1207436... we should use the scenario from the first range item
			if(id1.filterId/*scenarioId*/===id2.filterId/*scenarioId*/ && id1.sheetId===id2.sheetId){
				var project=sas.stress.wkbench.model.Project.getCurrentProject();
				var sheet=project.getSheet(id1.sheetId);
				var sheetId=sheet.getId();
				var scenarioId=id1.scenarioId;
				var sheetInfo=sheet.getInfo();
				var calcScenario=sheetInfo.getFilters();//.getScenario(scenarioId);
				var id1RowIdx=id1.row;
				var id2RowIdx=id2.row;
				var id1ColIdx=id1.column;
				var id2ColIdx=id2.column;
				var ids=[];
				var loRow=Math.min(id1RowIdx,id2RowIdx);
				var hiRow=Math.max(id1RowIdx,id2RowIdx);
				var loCol=Math.min(id1ColIdx,id2ColIdx);
				var hiCol=Math.max(id1ColIdx,id2ColIdx);
				for(var row=loRow;row!==null && row<=hiRow;row=sheetInfo.nextRowIdx(row)){
					for(var col=loCol;col<=hiCol;col++){
						ids.push(new CellRef(col,row,calcScenario));
					}
				}
				return ids;
			}
		break;
		case 1:
			return [CellRef.getCellRef(incoming,scenario)];
		//break;
	}
	throw "Invalid Range:"+incoming;
};
/*
 The [^'\-] needs to be [^']. We had a case where the sheet and scenario name were separated with a -
 for eg sheet1 - baseline
 This is no longer the case
 this is the original regex
 /^(?:'([^'\-]*)(?:\s\-\s)?([^'\-]*)'!){0,1}\$([\w|\@]*)\$([\w|\@]*)/
 */
sas.stress.wkbench.model.CellRef.shorthandRegex=/^(?:'([^']*)(?:\s\-\s)?([^']*)'!){0,1}([A-Za-z]*)(\d*)$/;
sas.stress.wkbench.model.CellRef.longhandRegex=/^(?:'([^']*)(?:\s\-\s)?([^']*)'!){0,1}\$([\w|\@]*)\$([\w|\@]*)/;/*/^(?:'([^'\-]*)(?:\s\-\s)?([^'\-]*)'!){0,1}\$([\w]*)\$(\w*)$/;*/
sas.stress.wkbench.model.CellRef.getCellRef=function(incoming,filters/*scenario*/){
	var CellRef=sas.stress.wkbench.model.CellRef;
	var isShorthand=CellRef.shorthandRegex.test(incoming);
	if(!isShorthand && !CellRef.longhandRegex.test(incoming)){
		return null;//short circuit;
	}
	var project=sas.stress.wkbench.model.Project.getCurrentProject();
	var parsed=isShorthand?CellRef.shorthandRegex.exec(incoming):CellRef.longhandRegex.exec(incoming);
	var sheet=parsed[1]?project.getSheetByName(parsed[1])
			           :filters/*scenario*/.getSheetInfo().getSheet();
	if(!sheet){
    	console.error("Invalid cell reference:"+incoming);
		throw "#NAME?";
	}
	var sheetInfo=sheet.getInfo();
	var calcScenario=parsed[2]?sheetInfo.getFilters()/*.getScenarioByName(parsed[2])*/
						      :(parsed[1]?sheetInfo.getFilters()/*.getScenarioByName(scenario.getName())*/:filters/*scenario*/);
	/*
	 * this condition may not be valid anymore?? -- Srini

	var thissheetfilters=sheet?filters.getSheetInfo().getSheet().getSheetFilterHierarchies():[];
	var thatsheetfilters=calcScenario?calcScenario.getSheetInfo().getSheet().getSheetFilterHierarchies():[];
	if (calcScenario&&sheet&&!(_.isEqual(thissheetfilters,thatsheetfilters))){
		if (_.intersection(thissheetfilters,thatsheetfilters).length>0) {
			console.error("Invalid cell reference:" + incoming);
			throw {message:"#INVALID REFERENCE!"};
		}
	}
	*/
	var infoData=sheetInfo.getData();
	var colRowKey, datakey;
	if (!isShorthand){
		colRowKey="$"+parsed[3]+"$"+parsed[4];
	}
	var index;
	index=isShorthand?infoData.getColumnIndexByShort(parsed[3]):infoData.getColumnIndexByLong(parsed[3]);
	if (index<0){
		datakey=infoData.getDatakeyFromRowColumn(colRowKey);
		index=infoData.getColumnIndexByLongUsingDatakey(datakey);
	}
	var colIndex=index;
	index=isShorthand?infoData.getRowIndexByShort(parsed[4]):infoData.getRowIndexByLong(parsed[4]);
	if (index<0){
		datakey=infoData.getDatakeyFromRowColumn(colRowKey);
		index=infoData.getRowIndexByLongUsingDatakey(datakey);
	}
	var rowIndex=index;
	return new CellRef(colIndex,rowIndex,calcScenario);
};
sas.stress.wkbench.model.CellRef.getCellRefStrs=function(incoming,scenario){
	var CellRef=sas.stress.wkbench.model.CellRef;
	var range=incoming.split(":");
	switch(range.length){
		case 2:
			var id1=CellRef.getCellRefStr(range[0],scenario,true).split(":");
			var id2=CellRef.getCellRefStr(range[1],scenario,true).split(":");
			if(id1[2]===id2[2] && id1[3]===id2[3]){
				var project=sas.stress.wkbench.model.Project.getCurrentProject();
				var sheet=project.getSheet(id1[3]);
				var sheetId=sheet.getId();
				var scenarioId=id1[2];
				var sheetInfo=sheet.getInfo();
				var calcScenario=sheetInfo.getFilters(scenarioId)/*sheetInfo.getScenario(scenarioId)*/;
				var id1RowIdx=id1[1];
				var id2RowIdx=id2[1];
				var id1ColIdx=id1[0];
				var id2ColIdx=id2[0];
				var ids=[];
				var loRow=Math.min(id1RowIdx,id2RowIdx);
				var hiRow=Math.max(id1RowIdx,id2RowIdx);
				var loCol=Math.min(id1ColIdx,id2ColIdx);
				var hiCol=Math.max(id1ColIdx,id2ColIdx);
				for(var row=loRow;row!==null && row<=hiRow;row=sheetInfo.nextRowIdx(row)){
					for(var col=loCol;col<=hiCol;col++){
						ids.push(col+":"+row+":"+calcScenario.id+":"+sheetId);
					}
				}
				return ids;
			}
		break;
		case 1:
			return [CellRef.getCellRefStr(incoming,scenario)];
		//break;
	}
	throw "Invalid Range:"+incoming;
};
sas.stress.wkbench.model.CellRef.getCellRefStr=function(incoming,scenario){
	var CellRef=sas.stress.wkbench.model.CellRef;
	var project=sas.stress.wkbench.model.Project.getCurrentProject();
	var trimmedstr=incoming.trim();
	var parsed=CellRef.longhandRegex.exec(trimmedstr);
	var isShorthand=false;
	if(!parsed){
		isShorthand=CellRef.shorthandRegex.test(trimmedstr);
		if(!isShorthand && !CellRef.longhandRegex.test(trimmedstr)){
			return null;//short circuit;
		}
		parsed=CellRef.shorthandRegex.exec(trimmedstr);
	}
	var sheet=parsed[1]?project.getSheetByName(parsed[1])
			           :scenario.getSheetInfo().getSheet();
	if(!sheet){
		throw "Invalid sheet reference:"+incoming;
	}
	var sheetInfo=sheet.getInfo();
	var calcScenario=parsed[2]?sheetInfo.getScenarioByName(parsed[2])
						      :(parsed[1]?sheetInfo.getFilters():scenario);	// fixes for S1248704
	if(calcScenario===undefined){
		calcScenario=scenario;
	}
	var infoData=sheetInfo.getData();
	try{
		var colRowKey, datakey;
		if (!isShorthand){
			colRowKey="$"+parsed[3]+"$"+parsed[4];
			datakey=infoData.getDatakeyFromRowColumn(colRowKey);
			if (!datakey){
				colRowKey="$"+parsed[4]+"$"+parsed[3];
				datakey=infoData.getDatakeyFromRowColumn(colRowKey);
			}
		}
		var index;
		index=isShorthand?infoData.getColumnIndexByShort(parsed[3]):infoData.getColumnIndexByLong(parsed[3]);
		if (index<0){
			datakey=infoData.getDatakeyFromRowColumn(colRowKey);
			index=infoData.getColumnIndexByLongUsingDatakey(datakey);
		}
		var colIndex=index;
		index=isShorthand?infoData.getRowIndexByShort(parsed[4]):infoData.getRowIndexByLong(parsed[4]);
		if (index<0){
			datakey=infoData.getDatakeyFromRowColumn(colRowKey);
			index=infoData.getRowIndexByLongUsingDatakey(datakey);
		}
		var rowIndex=index;
	}catch(e){
		console.error(e);
		throw "Invalid cell reference:"+incoming;
	}
	return colIndex+":"+rowIndex+":"+calcScenario.id+":"+sheet.id;
};
sas.stress.wkbench.model.CellRef.parse=function(cellRefStr){
	var parsed=cellRefStr.split(":");
	var project=sas.stress.wkbench.model.Project.getCurrentProject();
	var sheet=project.getSheet(parsed[3]);
	var scenario=sheet.getInfo().getFilters(parsed[2]);
	return new sas.stress.wkbench.model.CellRef(parsed[0],parsed[1],scenario);
};