jQuery.sap.declare("sas.stress.wkbench.model.Project");
jQuery.sap.require("sas.stress.wkbench.StressAPI");
jQuery.sap.require("sas.stress.wkbench.model.Sheet");
jQuery.sap.require("sas.stress.wkbench.model.Task");
jQuery.sap.require("sas.stress.wkbench.model.TaskAction");
jQuery.sap.require("sas.stress.wkbench.model.Process");
jQuery.sap.require("sas.stress.wkbench.model.Transition");
jQuery.sap.require("sas.stress.wkbench.StressUtil");
jQuery.sap.require("sas.stress.wkbench.model.SheetCategory");
jQuery.sap.require("sas.stress.wkbench.model.CellRef");
jQuery.sap.require("sas.stress.wkbench.UserPrefs");

sap.ui.base.Object.extend("sas.stress.wkbench.model.Project", {
    constructor: function (id, name, description, lastModified, createdTime, processId, processDefId, createdByUser, updatedByUser,
                           asOfDate, processStartDate, processNotificationType, currentIterationNo, processDefinitionName, sheetDefinitions, locked, lockHistory,
                           requireComments) {
        this.id = id;
        this.name = name;
        this.description = description;
        this.lastModified = lastModified;
        this._sheetCategories = {};
        this._sheetCatsOrder = [];
        this._sheets = {};
        this._sheetsOrder = [];
        this._overlayDeps = {};
        this._overlayRefs = {};
        this.createdTime = createdTime;
        this.processId = processId;
        this.processDefId = processDefId;
        this.processDefinitionName = processDefinitionName;
        this.createdByUser = createdByUser;
        this.updatedByUser = updatedByUser;
        this.asOfDate = asOfDate;
        this.processStartDate = processStartDate;
        this.processNotificationType = processNotificationType;
        this.currentIterationNo = currentIterationNo;
        this.sheetDefinitions = sheetDefinitions;
        this.locked = locked;
        this.lockHistory = lockHistory;

        this.requireComments=requireComments;

        this._filters=[];
        this._data={};
        this._overlays={};
        this._values={};
        this._dataKeys=[];
    }
});
sas.stress.wkbench.model.Project.prototype.getId = function () {
    return this.id;
};
sas.stress.wkbench.model.Project.prototype.getName = function () {
    return this.name;
};
sas.stress.wkbench.model.Project.prototype.getDescription = function () {
    return this.description;
};
sas.stress.wkbench.model.Project.prototype.getProcessDefinitionName = function () {
    return this.processDefinitionName;
};
sas.stress.wkbench.model.Project.prototype.getProcessDefId = function () {
    return this.processDefId;
};
sas.stress.wkbench.model.Project.prototype.getProcessId = function () {
    return this.processId;
};
sas.stress.wkbench.model.Project.prototype.getLastModified = function () {
    return this.lastModified;
};
sas.stress.wkbench.model.Project.prototype.setLastModified = function (val) {
    this.lastModified = val;
};
sas.stress.wkbench.model.Project.prototype.getCreatedTime = function () {
    return this.createdTime;
};
sas.stress.wkbench.model.Project.prototype.getCreatedByUser = function () {
    return this.createdByUser;
};
sas.stress.wkbench.model.Project.prototype.getUpdatedByUser = function () {
    return this.updatedByUser;
};
sas.stress.wkbench.model.Project.prototype.getAsOfDate = function () {
    return this.asOfDate;
};
sas.stress.wkbench.model.Project.prototype.setAsOfDate = function (val) {
    this.asOfDate = val;
};
sas.stress.wkbench.model.Project.prototype.getProcessStartDate = function () {
    return this.processStartDate;
};
sas.stress.wkbench.model.Project.prototype.setProcessStartDate = function (val) {
    this.processStartDate = val;
};
sas.stress.wkbench.model.Project.prototype.getProcessNotificationType = function () {
    return this.processNotificationType;
};
sas.stress.wkbench.model.Project.prototype.setProcessNotificationType = function (val) {
    this.processNotificationType = val;
};
sas.stress.wkbench.model.Project.prototype.getCurrentIterationNo = function () {
    return this.currentIterationNo;
};
sas.stress.wkbench.model.Project.prototype.setCurrentIterationNo = function (val) {
    this.currentIterationNo = val;
};
sas.stress.wkbench.model.Project.prototype.getSheetDefinitions = function () {
    return this.sheetDefinitions;
};
sas.stress.wkbench.model.Project.prototype.setSheetDefinitions = function (val) {
    this.sheetDefinitions = val;
};
sas.stress.wkbench.model.Project.prototype.addSheetCategory = function (sheetCategory) {
    var sheetCatId = sheetCategory.getId();
    this._sheetCatsOrder.push(sheetCatId);
    this._sheetCategories[sheetCatId] = sheetCategory;
};
sas.stress.wkbench.model.Project.prototype.getSheetCategories = function () {
    var sheetCats = [];
    var that = this;
    _.each(this._sheetCatsOrder, function (sheetCatId) {
        sheetCats.push(that._sheetCategories[sheetCatId]);
    });
    return sheetCats;
};
sas.stress.wkbench.model.Project.prototype.addSheet = function (sheet) {
    var sheetId = sheet.getId();
    this._sheetsOrder.push(sheetId);
    this._sheets[sheetId] = sheet;
};
sas.stress.wkbench.model.Project.prototype.getSheets = function () {
    var sheets = [];
    var that = this;
    _.each(this._sheetsOrder, function (sheetId) {
        sheets.push(that._sheets[sheetId]);
    });
    return sheets;
};

/* delete the sheet */
sas.stress.wkbench.model.Project.prototype.deleteSheet = function (sheetId) {
    var sheetIdString = sheetId.toString();
    var index = this._sheetsOrder.indexOf(sheetIdString);
    this._sheetsOrder.splice(index, 1);	// remove it
    delete this._sheets[sheetId];
};
sas.stress.wkbench.model.Project.prototype.getSheetByName = function (sheetName) {
    return _.findWhere(this._sheets, {name: sheetName});
};
sas.stress.wkbench.model.Project.prototype.getSheet = function (sheetId) {
    return this._sheets[sheetId];
};
sas.stress.wkbench.model.Project.prototype.isLocked = function () {
    return this.locked;
};
sas.stress.wkbench.model.Project.prototype.doesRequireComments=function(){
    return this.requireComments;
};
sas.stress.wkbench.model.Project.prototype.getHistoricalTasks = function () {
    return sas.stress.wkbench.model.Task.getHistoricalTasks(this);
};
sas.stress.wkbench.model.Project.prototype.getSummaryTasks = function () {
    return sas.stress.wkbench.model.Task.getSummaryTasks(this);
};
sas.stress.wkbench.model.Project.prototype.getMyTasks = function () {
    var deferred = $.Deferred();
    if (this.getProcessDefId() > 0 && this.getProcessId() > 0) { //Only ids > 0 are valid.
        return sas.stress.wkbench.model.Task.getMyTasks(this);
    } else {
        deferred.resolve([]);
    }
    return deferred;
};
sas.stress.wkbench.model.Project.prototype.getAllMyTasks = function () {
    var deferred = $.Deferred();
    if (this.getProcessDefId() > 0 && this.getProcessId() > 0) { //Only ids > 0 are valid.
        return sas.stress.wkbench.model.Task.getAllMyTasks(this);
    } else {
        deferred.resolve([]);
    }
    return deferred;
};
sas.stress.wkbench.model.Project.prototype.getProcess = function () {
    var deferred = $.Deferred();
    var that = this;
    sas.stress.wkbench.StressAPI.loadProcess(this.getProcessDefId(), this.getProcessId()).done(function (json) {
        var process = new sas.stress.wkbench.model.Process(that, json.id, json.name, json.description, json.startNodeId, json.endNodeId);
        _.each(json.sequenceFlow, function (trans) {
            var transition = new sas.stress.wkbench.model.Transition(trans.id, trans.sourceId, trans.targetId, trans.syncGroup, trans.expression);
            process.addTransition(transition);
        });
        _.each(json.tasks, function (tsk) {
            var task = sas.stress.wkbench.model.Task._fromJSON(tsk);
            process.addTask(task);
        });
        deferred.resolve(process);
    });
    return deferred;
};
sas.stress.wkbench.model.Project.prototype.commitChanges = function () {
    var i, j, sheet, scenarios, scenario, ncFormulas, cFormulas, ncComments, cComments, key, overlay,
        payloadEntry, info, infoData, data, values, comments, sheetFilter;
    var timestamp = this.getLastModified();
    var sheets = this.getSheets();
    for (i = 0; i < sheets.length; i++) {
        sheet = sheets[i];
        if (!sheet.errored) {
            info = sheet.getInfo();
            infoData = info.getData();
            scenarios = info.getScenarios();
            sheetFilter = info.getFilters();

            data = sheetFilter.getData();
            if (!data) {
                continue;
            }//scenario had not even been loaded
            ncFormulas = data.ncFormulas;
            cFormulas = data.cFormulas;
            ncComments = data.ncComments;
            cComments = data.cComments;
            for (key in ncFormulas) {
                if (ncFormulas.hasOwnProperty(key)) {
                    overlay = ncFormulas[key];
                    overlay.timestamp = timestamp;
                    delete ncFormulas[key];//remove from not committed
                    cFormulas[key] = overlay;//move to committed
                    if (data.cDrillDowns[key] && data.cDrillDowns[key].propertyKey) {
                        data.cDrillDowns[key].propertyKey = 0;
                    }
                }
            }
            for (key in ncComments) {
                if (ncComments.hasOwnProperty(key)) {
                    overlay = ncComments[key];
                    overlay.timestamp = timestamp;
                    delete ncComments[key];//remove from not committed
                    cComments[key] = overlay;//move to committed
                }
            }
        }
    }
};
sas.stress.wkbench.model.Project.prototype.commit = function () {
    sas.stress.wkbench.model.Project._projects[this.id] = this;
};
sas.stress.wkbench.model.Project.prototype.mergeUncommittedOverlays = function (otherProject) {
    var i, j, sheet, filters, ncFormulas, ncComments, key, overlay,
        mysheet, myinfo, myfilters, mydata, myncComments,
        info, infoData, data, cellRef;
    var sheets = otherProject.getSheets();
    for (i = 0; i < sheets.length; i++) {
        sheet = sheets[i];
        if (!sheet.errored) {
            mysheet = this.getSheet(sheet.getId());
            myinfo = mysheet.getInfo();
            info = sheet.getInfo();
            infoData = info.getData();
            filters = info.getFilters();
            myfilters = myinfo.getFilters();
            //for(j=0;j<scenarios.length;j++){
            //scenario=scenarios[j];
            //myscenario=myinfo.getScenario(scenario.getId());
            data = filters.getData();
            if (!data) {
                continue;
            }//scenario had not even been loaded
            mydata = myfilters.getData();
            ncFormulas = data.ncFormulas;
            ncComments = data.ncComments;
            myncComments = mydata.ncComments;
            for (key in ncFormulas) {
                if (ncFormulas.hasOwnProperty(key)) {
                    overlay = ncFormulas[key];
                    cellRef = new sas.stress.wkbench.model.CellRef(overlay.columnIndex, overlay.rowIndex, myfilters);
                    sas.stress.wkbench.CellEvaluationUtil.saveNewFormula(overlay.origtxt || overlay.txt, cellRef, true);	// fixes for S1201112..
                }
            }
            for (key in ncComments) {
                if (ncComments.hasOwnProperty(key)) {
                    myncComments[key] = ncComments[key];
                }
            }
        }
    }
};
sas.stress.wkbench.model.Project.prototype.getUncommittedPayload = function () {
    var payload = [];
    var i, j, sheet, scenarios, scenario, ncFormulas, ncComments, key, overlay,
        payloadEntry, info, infoData, values, comments, data, filters, sheetFilter, processedKeys = [];
    var columnlong,rowlong,indexkey,datakey;
    var eachSheetValues;

    var sheets = this.getSheets();
    filters = this.getFilters();
    var sheetfilters;
    for (i = 0; i < sheets.length; i++) {
        sheetfilters = [];
        sheet = sheets[i];
        if (!sheet.errored) {
            info = sheet.getInfo();
            if (info) {
                infoData = info.getData();
                scenarios = info.getScenarios();
                sheetFilter = info.getFilters();

                data = sheetFilter.getData();
                if (!data) {
                    continue;
                }//scenario had not even been loaded
                values = [];
                var dataPointSource = "sheetOverride";
                ncFormulas = data.ncFormulas;
                ncComments = data.ncComments;
                var txt = "", comment = "";
                var defFilters = sheet.getPreferredSheetFilter();
                _.each(defFilters, function (eachfilter) {
                    var tosendfilter = _.find(filters, function (filter, key) {
                        return filter.liKey === eachfilter; //S1316002
                    });
                    if (tosendfilter) {
                        sheetfilters.push(tosendfilter);
                    }
                });
                payloadEntry = {
                    sheetId: sheet.id,
                    filters: sheetfilters,
                    /*comments:comments,*/
                    values: values
                };
                for (key in ncFormulas) {
                    //reset
                    comment = "";
                    txt = "";
                    eachSheetValues = {
                        dataKey: "",
                        value: {value: null},
                        dataPointSource: dataPointSource,
                        comment: {value: null},
                        source: null
                    };	// the defaults
                    overlay = undefined;
                    if (ncFormulas.hasOwnProperty(key)) {
                        overlay = ncFormulas[key];
                        txt = overlay.txt;
                    }
                    if (ncComments.hasOwnProperty(key)) {
                        overlay = ncComments[key];
                        comment = overlay.comment;
                        processedKeys.push(key);
                    }
                    if (overlay/*&&!(!!overlay.error)*/) {	//if there is an overlay to be processed
                        columnlong = infoData.getLongColumn(overlay.columnIndex);
                        rowlong = infoData.getLongRow(overlay.rowIndex);
                        indexkey = "$" + columnlong + "$" + rowlong;
                        datakey = infoData.getDatakeyFromRowColumn(indexkey);
                        eachSheetValues.dataKey = datakey;
                        if (txt) {
                            eachSheetValues.value.value = txt;
                        }
                        if (comment) {
                            eachSheetValues.comment.value = comment;
                        }
                        eachSheetValues.dataPointSource = overlay.source;
                        eachSheetValues.source = sheet.getName() + "!" + infoData.getShortColumn(overlay.columnIndex) + infoData.getShortRow(overlay.rowIndex);
                        values.push(eachSheetValues);
                    }
                }
                for (key in ncComments) {
                    eachSheetValues = {
                        dataKey: "",
                        value: {value: null},
                        comment: {value: null},
                        dataPointSource: dataPointSource,
                        source: null
                    };	// the defaults
                    if (ncComments.hasOwnProperty(key)) {
                        var processed = _.find(processedKeys, function (processedKey) {
                            return processedKey === key;
                        });
                        if (!processed) {
                            overlay = ncComments[key];
                            columnlong = infoData.getLongColumn(overlay.columnIndex);
                            rowlong = infoData.getLongRow(overlay.rowIndex);
                            indexkey = "$" + columnlong + "$" + rowlong;
                            datakey = infoData.getDatakeyFromRowColumn(indexkey);
                            eachSheetValues.dataKey = datakey;
                            eachSheetValues.dataPointSource = overlay.source;
                            eachSheetValues.comment.value = overlay.comment;	// comments fixes
                            eachSheetValues.source = sheet.getName() + "!" + infoData.getShortColumn(overlay.columnIndex) + infoData.getShortRow(overlay.rowIndex);
                            values.push(eachSheetValues);
                        }
                    }
                }
                if (values.length) {
                    payload.push(payloadEntry);
                }
            }
        }
    }
    return payload;
};

/*
 the following methods are the newest way for loading sheet data
 */
sas.stress.wkbench.model.Project.prototype.setFilters=function(filters){
    if (filters) {
        this._filters = filters;
    }
};
sas.stress.wkbench.model.Project.prototype.getFilters=function(){
    return this._filters;
};
sas.stress.wkbench.model.Project.prototype.clearFilters=function(){
    this._filters=undefined;
    sas.stress.wkbench.UserPrefs.delete("sas.stress.wkbench.project_filters",this.getId());
};
sas.stress.wkbench.model.Project.prototype.setCellDataByDataKey=function(datakey,cellValue){
    var value={
        user:undefined,
        timestamp:undefined,
        value:undefined,
        parsedFormula:undefined
    };
    var overlay={
        dataKey:undefined,
        value:value,
        status:0
    };
    var numericvalue=null;
    var newvalue;
    if (cellValue) {
        // this is an overlay
        overlay.dataKey = datakey;
        /*overlay.source=datakey;
        overlay.systemGenerated=cellValue.systemGenerated;
        overlay.isReadOnly=cellValue.isReadOnly;*/

        // formula?
        overlay.value.parsedFormula=cellValue.expr;
        overlay.value.user = cellValue.user;

        newvalue=cellValue.txt;
        overlay.value.value=newvalue;
        if (!(_.isNaN(+newvalue))){
            numericvalue=+newvalue;
        }else {
            numericvalue = null;
        }
    }
    // the values from the data
    this._values[datakey]=numericvalue;
    // the overlays from the data
    this._overlays[datakey]=overlay;
};

sas.stress.wkbench.model.Project.prototype.setCellCommentByDataKey=function(datakey,cellcomment){
    var overlay=this._overlays[datakey];
    var comment={
        user:undefined,
        timestamp:undefined,
        value:comment
    };
    comment.value=cellcomment.comment;
    comment.user=cellcomment.user;
    comment.timestamp=cellcomment.timestamp;

    if (!overlay){
        overlay={
            dataKey:undefined,
            comment:comment,
            status:0
        };

        overlay.dataKey = datakey;
        comment.value=cellcomment.comment;
        comment.user=cellcomment.user;
        comment.timestamp=cellcomment.timestamp;
    }
    overlay.comment=comment;
    // the overlays from the data
    this._overlays[datakey]=overlay;
};

sas.stress.wkbench.model.Project.prototype.getIndexOfDataKey=function(datakey){
    return this._dataKeys.indexOf(datakey);
};

sas.stress.wkbench.model.Project.prototype.getDataKeyByIndex=function(index){
    return this._dataKeys[index];
};

sas.stress.wkbench.model.Project.prototype.getCellOverlayByDataKey=function(datakey){
    return this._overlays[datakey];
};

sas.stress.wkbench.model.Project.prototype.setCellOverlayByDataKey=function(datakey,value){
    this._overlays[datakey]=value;
};

sas.stress.wkbench.model.Project.prototype.getCellValueByDataKey=function(datakey){
    if (this._values[datakey]!==undefined) {    //fixes for
        return this._values[datakey];
    }else{
        var cellOverlay=this.getCellOverlayByDataKey(datakey);
        if(cellOverlay&&cellOverlay.value){
            if (!cellOverlay.value.parsedFormula)
                return (cellOverlay.value.value)?+cellOverlay.value.value:null;
        }
    }
};

sas.stress.wkbench.model.Project.prototype.setCellValueByDataKey=function(datakey,value){
    this._values[datakey]=value;
};

sas.stress.wkbench.model.Project.prototype.isCellByDatakeyReadonly=function(datakey){
    var cellValue=this._overlays[datakey];
    if (cellValue&&cellValue.readOnly!==undefined){
        return cellValue.readOnly;
    }
    return undefined;
};

sas.stress.wkbench.model.Project.prototype.loadSheetsData=function(){
    var deferred= $.Deferred();
    var that=this;
    var requestProjectFilters;
    var projectId=this.getId();
    var iterationnum=sas.stress.wkbench.UserPrefs.get("sas.stress.wkbench.project_iteration_id",projectId)||this.getCurrentIterationNo();
    var projectFilters=sas.stress.wkbench.UserPrefs.get("sas.stress.wkbench.project_filters", projectId);
    if (projectFilters){
        requestProjectFilters=JSON.parse(projectFilters);
    }
    requestProjectFilters=requestProjectFilters||this.getFilters()||[];
    sas.stress.wkbench.StressAPI.loadSheetsDataForProjectAndSelectedFilters(projectId, iterationnum, requestProjectFilters).done(function (datajson) {
        if (datajson) {
            if (/*datajson.cellValues.length===0||*/datajson.sheetData.length===0/*||datajson.filters.length===0*/){// fixes for S1296642
                _.each(that.getSheets(),function(sheet){
                    sheet.errored=true;
                });
                deferred.reject(sas.stress.wkbench.model.Sheet.NO_PERMISSONS);
            }else{
                // the project data.. convert into a map. key=datakey, value=cellvalue
                _.each(datajson.cellValues, function (cellvalue) {
                    var datakey = cellvalue.dataKey;
                    that._overlays[datakey] = cellvalue;
                    if(cellvalue&&cellvalue.value&&!cellvalue.value.parsedFormula) {
                        that.setCellValueByDataKey(datakey,cellvalue.value.value);
                    }
                });
                that._dataKeys = _.keys(that._overlays);

                // the sheet information.. fixes for S1266931
                for (var index = 0; index < datajson.sheetData.length; index++) {
                    var sheetinfo = datajson.sheetData[index];
                    var sheet = that.getSheet(sheetinfo.sheetKey);
                    var noVisibilityReasons=sheetinfo.noVisibilityReasons;
                    if (noVisibilityReasons) {
                        console.error("Sheet "+sheetinfo.sheetName+" because: "+noVisibilityReasons);
                        //S1266931
                        sheet.setNoVisibilityReasons(noVisibilityReasons);
                        sheet.errored = true;
                    }else {
                        if (sheet) {    // HF3... Luis has some weird config
                            try {
                                sheet.loadSheetInfo(sheetinfo);
                            } catch (e) {
                                //S1266931
                                sheet.errored = true;
                            }
                        }else{
                            console.error("SHEET: " +  sheetinfo.sheetName +" was not loaded with getProject() API call and is present in loadData() API call !!!!");
                        }
                    }
                }
                for (var index=0;index<that.getSheets().length;++index){
                    var sheet=that.getSheets()[index];
                    var existsInResponse= _.find(datajson.sheetData,function(sheetData){
                        return sheetData.sheetKey.toString()===sheet.getId();
                    });
                    if (!existsInResponse){
                        sheet.errored=true;
                    }
                }
                // save the filters
                // fixes for S1268615... the in-correct filters are being stored or not stored...
                _.each(datajson.filters, function (projectFilter) {
                    var found = _.find(requestProjectFilters, function (filter) {
                        // find the filter hierarchy
                        return (filter.hierarchyKey === projectFilter.hierarchyKey && filter.hierarchyCategoryCode === projectFilter.hierarchyCategoryCode);
                    });
                    if (!found) {
                        // not found save it
                        requestProjectFilters.push({
                            hierarchyKey: projectFilter.hierarchyKey,
                            hierarchyCategoryCode: projectFilter.hierarchyCategoryCode,
                            liKey: projectFilter.liKey
                        });
                    } else {
                        // update
                        found.liKey === projectFilter.liKey;
                    }
                });
                // make sure only the filters returned are processed from the user preferences.. remove the unwanted ones
                if (_.size(requestProjectFilters) !== _.size(datajson.filters)) {
                    var hkeys = {};
                    _.each(datajson.filters, function (filters) {
                        hkeys[filters.hierarchyKey] = true;
                    });
                    var out = _.filter(requestProjectFilters, function (filters) {
                        return hkeys[filters.hierarchyKey];
                    }, datajson.filters);

                    // save or update the user preferences
                    sas.stress.wkbench.UserPrefs.save("sas.stress.wkbench.project_filters", JSON.stringify(out), projectId);
                    that.setFilters(out);
                }else{
                    // save or update the user preferences
                    sas.stress.wkbench.UserPrefs.save("sas.stress.wkbench.project_filters", JSON.stringify(requestProjectFilters), projectId);
                    that.setFilters(requestProjectFilters);
                }
            }
            deferred.resolve(that);
        }else{
            deferred.reject("<Empty response>");
        }
    }).fail(function (jqxhr) {
        deferred.reject(jqxhr);
    });
    //}

    return deferred;
};
/* ******************************************************************* */

/*
 * Internal method to load only those sheets for the preferred category.
 */
sas.stress.wkbench.model.Project.prototype._getFilteredSheets = function () {
    var sheets = this.getSheets();
    var preferredCategory = sas.stress.wkbench.UserPrefs.get("sas.stress.wkbench.category_key", this.getId());
    if (preferredCategory && preferredCategory !== "-1") {
        return _.filter(sheets, function (sheet) {
            return (sheet.getSheetCategory().getId() === preferredCategory);
        });
    } else {
        return sheets;
    }
};

/*STATICS (PROJECT MANAGER)*/
sas.stress.wkbench.model.Project._projects = {};
sas.stress.wkbench.model.Project._currentId = null;
sas.stress.wkbench.model.Project.getProjects = function () {
    var deferred = $.Deferred();
    var projects = [];
    // do we have projects in the cache? fixes for S1200823

    sas.stress.wkbench.StressAPI.loadProjects().done(function (projectsJSON) {
            sas.stress.wkbench.model.Project._projects = {};
            _.each(projectsJSON, function (json) {
                json.asOfDate = json.asOfDateStr;
                json.processStartDate = json.processStartDateStr;
                var project = sas.stress.wkbench.model.Project._fromJSON(json);
                sas.stress.wkbench.model.Project._projects[project.id] = project;
                projects.push(project);
            });
            deferred.resolve(projects);
        })
        .fail(function (jqxhr) {
            deferred.reject(jqxhr);
        });

    return deferred;
};
sas.stress.wkbench.model.Project.clearProject = function (projectId) {
    sas.stress.wkbench.model.Project._projects[projectId] = undefined;
    delete sas.stress.wkbench.model.Project._projects[projectId];
};
sas.stress.wkbench.model.Project.getProject = function (projectId) {
    sas.stress.wkbench.model.Project._currentId = projectId;
    return sas.stress.wkbench.model.Project._projects[projectId];
};
sas.stress.wkbench.model.Project.getProjectByName = function (projectName) {
    return _.findWhere(sas.stress.wkbench.model.Project._projects, {name: projectName});
};
sas.stress.wkbench.model.Project.getCurrentProject = function () {
    return sas.stress.wkbench.model.Project._projects[sas.stress.wkbench.model.Project._currentId];
};


/* Used to initially set the Name input in the New Project dialog with a unique name. */
sas.stress.wkbench.model.Project.getNewProjectName = function () {
    var rb = sas.stress.wkbench.StressUtil.getBundle();
    var newProjectName = "";
    var count = 1;
    while (newProjectName === "") {
        var tempProjectName = rb.getText("project.name.fmt", [count++]);
        //check if project with this name exists
        var project = _.find(sas.stress.wkbench.model.Project._projects, function (project) {
            return project.getName().toLocaleLowerCase() === tempProjectName.toLocaleLowerCase();
        });
        //if not, use this name
        if (project === undefined) {
            newProjectName = tempProjectName;
        }
    }
    return newProjectName;
};

sas.stress.wkbench.model.Project.createProject = function (project) {
    var deferred = $.Deferred();
    sas.stress.wkbench.StressAPI.createProject(project).done(function (newProjectJSON) {
            var newProject = new sas.stress.wkbench.model.Project(newProjectJSON.projectKey, newProjectJSON.projectName,
                newProjectJSON.description, newProjectJSON.updatedTimeMillis, newProjectJSON.createdTimestamp,
                newProjectJSON.processKey, newProjectJSON.processDefinitionKey, newProjectJSON.createdByUser,
                newProjectJSON.updatedByUser, newProjectJSON.asOfDateStr, newProjectJSON.processStartDateStr,
                newProjectJSON.processNotificationType, newProjectJSON.currentIterationNum,
                newProjectJSON.processDefinitionName, newProjectJSON.sheetDefinitions, newProjectJSON.locked, newProjectJSON.lockHistory,
                newProjectJSON.requireComments);
            sas.stress.wkbench.model.Project._projects[newProject.id] = newProject;
            deferred.resolve(newProject);
        })
        .fail(function (jqxhr, textStatus, error) {
            deferred.reject(jqxhr);
        });
    return deferred;
};

sas.stress.wkbench.model.Project.editProject = function (editedProject) {
    var deferred = $.Deferred();
    sas.stress.wkbench.StressAPI.editProject(editedProject).done(function (projectJson) {
            //update project in cache
            var project = sas.stress.wkbench.model.Project._projects[projectJson.projectKey];
            if (project != null) {
                project.name = projectJson.projectName;
                project.description = projectJson.description;
                project.lastModified = projectJson.updatedTimeMillis;
                project.updatedByUser = projectJson.updatedByUser;

                //Convert millisecs to date format
                //var dateFormat = sap.ui.core.format.DateFormat.getDateInstance({pattern: "yyyy-MM-dd"});
                //var dateStr = dateFormat.format(new Date(projectJson.asOfDate), true);
                project.asOfDate = projectJson.asOfDateStr;

                //Convert millisecs to date format
                //var processStartDateFormat = sap.ui.core.format.DateFormat.getDateInstance({pattern: "yyyy-MM-dd"});
                //var processStartDateStr = processStartDateFormat.format(new Date(projectJson.processStartDate), true);
                project.processStartDate = projectJson.processStartDateStr;

                project.processNotificationType = projectJson.processNotificationType;
                project.currentIterationNo = projectJson.currentIterationNum;

                project.processId = projectJson.processKey;
                project.processDefId = projectJson.processDefinitionKey;
                project.processDefinitionName = projectJson.processDefinitionName;
                project.sheetDefinitions = projectJson.sheetDefinitions;
                project.requireComments=projectJson.requireComments;
            }
            deferred.resolve(project);
        })
        .fail(function (jqxhr, textStatus, error) {
            deferred.reject(jqxhr);
        });
    return deferred;
};

sas.stress.wkbench.model.Project.deleteProjects = function (projectIdList) {
    var deferred = $.Deferred();
    sas.stress.wkbench.StressAPI.deleteProjects(projectIdList).done(function () {
            _.each(projectIdList, function (projectId) {
                sas.stress.wkbench.model.Project._projects[projectId] = undefined;
                delete sas.stress.wkbench.model.Project._projects[projectId];
                deferred.resolve();
            });
            deferred.resolve();
        })
        .fail(function (jqxhr, textStatus, error) {
            deferred.reject(jqxhr);
        });
    return deferred;
};

sas.stress.wkbench.model.Project.loadProject = function (projectId, replaceProject) {
    var deferred = $.Deferred();

    var oldProjectPreferredIterationId;	//	fixes for S1228592
    sas.stress.wkbench.StressAPI.loadProject(projectId).done(function (json) {
        var project = sas.stress.wkbench.model.Project._fromJSON(json);
        if (replaceProject) {
            var oldProject = sas.stress.wkbench.model.Project.getProject(projectId);
            if (oldProject) {
                // fixes for S1228592... store the iterationID of the old Project if a replace is being asked for
                oldProjectPreferredIterationId = oldProject.getCurrentIterationNo();
                project.setFilters(oldProject.getFilters());
                oldProject.destroy();
            }
            sas.stress.wkbench.model.Project._projects[projectId] = project;
        }
        //oldProjectPreferredIterationId = oldProjectPreferredIterationId || project.getCurrentIterationNo();
        deferred.resolve(project);
    }).fail(function (jqxhr) {
        deferred.reject(jqxhr);
    });

    return deferred;
};
sas.stress.wkbench.model.Project._fromJSON = function (json) {
    var project = new sas.stress.wkbench.model.Project(json.id, json.name, json.description, json.lastModified,
        json.createdTime, json.processKey, json.processDefinitionKey, json.createdByUser, json.updatedByUser,
        json.asOfDateStr, json.processStartDateStr, json.processNotificationType, json.currentIterationNum,
        json.processDefinitionName, json.sheetDefinitions, json.locked, json.lockHistory, json.requireComments);
    // the version is in the sheetDefinitions object.. not sure who uses this
    var sheetDefns=json.sheetDefinitions;
    _.each(json.sheetCategories, function (sheetCatJson) {
        // current sheet category
        var sheetCategory = new sas.stress.wkbench.model.SheetCategory(sheetCatJson.id.toString(), sheetCatJson.name);
        _.each(sheetCatJson.sheets, function (sheetJson) {
            var sheetDefn=_.find(sheetDefns,function(sheetDef){
                // compare the category names too.. fixes for S1324430
                return sheetDef.sheetTemplateName===sheetJson.name && sheetDef.sheetCategory===sheetCategory.name;
            });
            // make sure the sheet definition is available, else it is undefined version
            var sheet = new sas.stress.wkbench.model.Sheet(project, sheetCategory, sheetJson.id.toString(), sheetJson.name,
                sheetDefn?sheetDefn.sheetVersion:undefined);
            sheetCategory.addSheet(sheet);
            project.addSheet(sheet);
        });
        project.addSheetCategory(sheetCategory);
    });
    return project;
};


sas.stress.wkbench.model.Project.prototype.destroy = function () {
    var that=this;
    var keys=[];

    if (this._sheets !== undefined) {
        _.each(this._sheets, function (sheet) {
            sheet.destroy();
            delete sheet;
        });
    }
    keys=_.keys(this._overlays);
    _.each(keys,function(key){
        that._overlays[key]=undefined;
        delete that._overlays[key];
    });
    keys=[];
    keys=_.keys(this._values);
    _.each(keys,function(key){
        that._values[key]=undefined;
        delete that._values[key];
    });
    this.destroyed = true;
    this._data={};
    this._sheets = {};
    this._sheetsOrder = [];
    this._overlayDeps = {};
    this._overlayRefs = {};
    this._overlays={};

    return this;
};