jQuery.sap.declare("sas.stress.wkbench.model.SheetCategory");
jQuery.sap.require("sas.stress.wkbench.model.SheetTemplate");
jQuery.sap.require("sas.stress.config.StressAPI");

sap.ui.base.Object.extend("sas.stress.wkbench.model.SheetCategory",{
	constructor:function(id,name){
		this.id=id;
		this.name=name;
		this._sheets={};
		this._sheetsOrder=[];
		this._templates={};
		this._templatesOrder=[];
	}
});
sas.stress.wkbench.model.SheetCategory.prototype.getId=function(){
	return this.id;
};
sas.stress.wkbench.model.SheetCategory.prototype.getName=function(){
	return this.name;
};
sas.stress.wkbench.model.SheetCategory.prototype.addSheet=function(sheet){
	var sheetId=sheet.getId();
	this._sheetsOrder.push(sheetId);
	this._sheets[sheetId]=sheet;
};
sas.stress.wkbench.model.SheetCategory.prototype.getSheets=function(){
	var sheets=[];
	var that=this;
	_.each(this._sheetsOrder,function(sheetId){
		sheets.push(that._sheets[sheetId]);
	});
	return sheets;
};
sas.stress.wkbench.model.SheetCategory.prototype.addSheetTemplate=function(template){
	var templateId=template.getId();
	template.setCategory(this);
	this._templatesOrder.push(templateId);
	this._templates[templateId]=template;
};
sas.stress.wkbench.model.SheetCategory.prototype.getSheetTemplates=function(){
	var templates=[];
	var that=this;
	_.each(this._templatesOrder,function(templateId){
		templates.push(that._templates[templateId]);
	});
	return templates;
};
sas.stress.wkbench.model.SheetCategory.prototype.getSheetTemplate=function(templateId){
	return this._templates[templateId];
};
//STATIC
sas.stress.wkbench.model.SheetCategory._cats=null;
sas.stress.wkbench.model.SheetCategory.getSheetCategories=function(useCache){
	var deferred = $.Deferred();
	if(useCache && sas.stress.wkbench.model.SheetCategory._cats){
		deferred.resolve(_.values(sas.stress.wkbench.model.SheetCategory._cats));
	} else {
		$.when(sas.stress.config.StressAPI.loadSheetCategories(),sas.stress.config.StressAPI.loadSheetTemplates()).done(function(catsJSON,templatesJSON){
			sas.stress.wkbench.model.SheetCategory._cats={};
			var cats=[];
			var catMap={};
			_.each(catsJSON,function(json){
				var cat=new sas.stress.wkbench.model.SheetCategory(json.categoryKey.toString(),json.name);
				sas.stress.wkbench.model.SheetCategory._cats[cat.id]=cat;
				cats.push(cat);
				catMap[cat.getId()]=cat;
			});
			_.each(templatesJSON,function(json){
				var cat=catMap[json.categoryKey];
				var template=new sas.stress.wkbench.model.SheetTemplate(json.id,json.name,cat,json.hierarchyKey,json.periodType,json.numHistoryPeriods,json.numFuturePeriods,
																		json.createdByUser,json.createdTimestamp,json.description,json.updatedByUser,json.updatedTimestamp, json.axes,json.version, json.aggregateMissingValues);
				if (cat !== undefined) {
					cat.addSheetTemplate(template);
				}
			});
			deferred.resolve(cats);
		}).fail(function(){
			deferred.reject();
		});
	}
	return deferred;
};
sas.stress.wkbench.model.SheetCategory.getSheetCategory=function(catId){
	return sas.stress.wkbench.model.SheetCategory._cats[catId];
};