jQuery.sap.declare("sas.stress.wkbench.model.SheetTemplate");
jQuery.sap.require("sas.stress.wkbench.model.SheetTemplateAxes");
jQuery.sap.require("sas.stress.wkbench.StressUtil");

sap.ui.base.Object.extend("sas.stress.wkbench.model.SheetTemplate",{
	constructor:function(id,name,category,hierarchyKey,periodType,numHistoryPeriods,numFuturePeriods,createdByUser,createdTimestamp,description,updatedByUser,updatedTimestamp, axesjson,version, aggregateMissingValues){
		this.id=id;
		this.name=name;
		this.category=category;
		this.hierarchyKey=hierarchyKey;
		this.periodType=periodType;
		this.numHistoryPeriods=numHistoryPeriods;
		this.numFuturePeriods=numFuturePeriods;
		this.createdByUser=createdByUser;
		this.createdTimestamp=createdTimestamp;
		this.description=description;
		this.updatedByUser=updatedByUser;
		this.updatedTimestamp=updatedTimestamp;
		this.axes = [];
		this.version=version;
		this.aggregateMissingValues=aggregateMissingValues;

        var that = this;

		_.each(axesjson,function(json){
			var axisDetails=new sas.stress.wkbench.model.SheetTemplateAxes(json.sheetTemplateKey, json.sheetTemplateAxisKey,
				json.hierarchyCode, json.hierarchyKey, json.hierarchyName, json.hierarchyVersion, json.axis,json.order,
				json.startLevel,json.endLevel,json.members, category.getId(), json.subtotalCode);    // HF2 fixes--
			if (that.axes !== undefined) {
				that.axes.push(axisDetails);
			}
		});

		this.nameVersion=sas.stress.wkbench.StressUtil.getNameVersion(this.name,this.version);
	}
});

sas.stress.wkbench.model.SheetTemplate.prototype.getId=function(){
	return this.id;
};
sas.stress.wkbench.model.SheetTemplate.prototype.getName=function(){
	return this.name;
};
sas.stress.wkbench.model.SheetTemplate.prototype.getCategory=function(){
	return this.category;
};
sas.stress.wkbench.model.SheetTemplate.prototype.setCategory=function(category){
	this.category=category;
};
sas.stress.wkbench.model.SheetTemplate.prototype.getHierarchyKey=function(){
	return this.hierarchyKey;
};
sas.stress.wkbench.model.SheetTemplate.prototype.getPeriodType=function(){
	return this.periodType;
};
sas.stress.wkbench.model.SheetTemplate.prototype.getNumHistoryPeriods=function(){
	return this.numHistoryPeriods;
};
sas.stress.wkbench.model.SheetTemplate.prototype.getNumFuturePeriods=function(){
	return this.numFuturePeriods;
};
sas.stress.wkbench.model.SheetTemplate.prototype.getCreatedByUser=function(){
	return this.createdByUser;
};
sas.stress.wkbench.model.SheetTemplate.prototype.getCreatedTimestamp=function(){
	return this.createdTimestamp;
};
sas.stress.wkbench.model.SheetTemplate.prototype.getDescription=function(){
	return this.description;
};
sas.stress.wkbench.model.SheetTemplate.prototype.getUpdatedByUser=function(){
	return this.updatedByUser;
};
sas.stress.wkbench.model.SheetTemplate.prototype.getUpdatedTimestamp=function(){
	return this.updatedTimestamp;
};
sas.stress.wkbench.model.SheetTemplate.prototype.getNameVersion=function(){
	return this.nameVersion;
};
sas.stress.wkbench.model.SheetTemplate.prototype.getVersion=function(){
	return this.version;
};
sas.stress.wkbench.model.SheetTemplate.prototype.getAggregateMissingValues=function(){
	return this.aggregateMissingValues;
};


sas.stress.wkbench.model.SheetTemplate.prototype.toJson=function(){
	return {
		id:this.id,
		categoryKey:this.category.getId(),
		hierarchyKey:this.hierarchyKey,
		name:this.name,
		version:this.version,
		numFuturePeriods:this.numFuturePeriods,
		numHistoryPeriods:this.numHistoryPeriods,
		periodType:this.periodType,
		createdByUser:this.createdByUser,
		createdTimestamp:this.createdTimestamp,
		description:this.description,
		updatebyUser:this.updatedByUser,
		updatedTimestamp:this.updatedTimestamp,
		aggregateMissingValues:this.aggregateMissingValues
	};
};