jQuery.sap.require("sas.stress.wkbench.StressUtil");
jQuery.sap.require("sap.ui.core.format.DateFormat");

sap.ui.controller("sas.stress.wkbench.view.CellCommentEditor",{
	onInit:function(){
		var view=this.getView();
		var cellRef=view.getViewData().cellRef;
		var bShowCommentField=view.getViewData().showCommentField;
		var bshowValidation=view.getViewData().showValidation;
		var data=cellRef.getFilterData()/*getScenarioData()*/;
	    var overlay = data.ncComments["$"+cellRef.colLong+"$"+cellRef.rowLong];
		var validationoverlay=data.cValidationErrors["$"+cellRef.column+"$"+cellRef.row];
	    var comment = overlay?overlay.comment:"";
		this.newValue=comment;
	    var user = overlay?overlay.user:sas.stress.wkbench.StressUtil.getUserName();
	    var timestamp = overlay?overlay.timestamp:"";
	    var dttm="";
	    if(timestamp){
		    var fmt = sap.ui.core.format.DateFormat.getDateTimeInstance();
		    dttm=fmt.format(new Date(timestamp),false);
	    }
		var validationError=validationoverlay?validationoverlay.validationError:undefined;
		var validationuser = validationoverlay?validationoverlay.user:sas.stress.wkbench.StressUtil.getUserName();
		timestamp = validationoverlay?validationoverlay.timestamp:"";
		var validationdttm="";
		if(timestamp){
			var fmt = sap.ui.core.format.DateFormat.getDateTimeInstance();
			validationdttm=fmt.format(new Date(timestamp),false);
		}
		var model=new sas.stress.wkbench.model.RiskJSONModel({
			comment:comment,
			user:user,
			dttm:dttm,
			showCommentField:bShowCommentField,
			validationError:validationError,

			validationuser:validationuser,
			validationdttm:validationdttm,
			showValidation:bshowValidation,

			requiresComment: cellRef.getSheetFilters().getSheetInfo().getSheet().getProject().doesRequireComments()
		});
		view.setModel(model);
	},
	cancelEdit:function(){
		var view = this.getView();
		view.fireEvent(view.getId()+"_CLOSING",{"view":view,"action":"CANCEL"});
	},
	saveCellComment:function(){
		var view = this.getView();
		var newComment = view.commentTextArea.getLiveValue();
		var liveModel=sas.stress.wkbench.ViewManager.getWorkbench().getModel("live");
		var slimsheet= liveModel.getProperty("/slimsheet");
		var userName = sas.stress.wkbench.StressUtil.getUserName();
		var cellRef=view.getViewData().cellRef;
		if (newComment.length===0&&cellRef.getSheetFilters().getSheetInfo().getSheet().getProject().doesRequireComments()){
			return;
		}

		var data=cellRef.getFilterData()/*getScenarioData()*/;
		data.addComment("$"+cellRef.colLong+"$"+cellRef.rowLong,cellRef.row,cellRef.column,userName,newComment);
		view.fireEvent(view.getId()+"_CLOSING",{"view":view,data:view.getModel().getData(),"action":"SAVE"});

		slimsheet.getSlimsheetSource().clearInfo();
		slimsheet.rerender();
		//sas.applicationSwitcher.updateDirtyFlag(sas.config.getAppId(), true);// Let Appswitcher know
		// fixes for S1203977
		var wkbenchView=sas.stress.wkbench.ViewManager.getWorkbench();
		wkbenchView.getController().navChecker.setDirty(true);
		wkbenchView.getController().hasUnSavedValues=true;
		liveModel.setProperty("/toggleButtons", true);//Update property in model
	},
	livechange:function(e){
		this.newValue= e.getParameter("value");
	}
});
