jQuery.sap.require("sas.hc.ui.commons.layout.VerticalLayout");
jQuery.sap.require("sas.hc.ui.commons.TextView");
jQuery.sap.require("sas.stress.wkbench.widget.TextAreaAuto");
jQuery.sap.require({ modName: "sas.stress.wkbench.view.CellCommentEditor", type: "controller" });

sap.ui.jsview("sas.stress.wkbench.view.CellCommentEditor", {
    getControllerName: function () {
        return "sas.stress.wkbench.view.CellCommentEditor";
    },
    createContent: function (controller) {
        var commentUserLabel = new sas.hc.ui.commons.TextView({
            text: "{/user}",
            design: sap.ui.commons.TextViewDesign.Bold,
            visible: "{/showCommentField}"
        });
        var commentTimestampLabel = new sas.hc.ui.commons.TextView({
            text: "{/dttm}",
            design: sap.ui.commons.TextViewDesign.Small,
            visible: "{/showCommentField}"
        });
        this.commentTextArea = new sas.stress.wkbench.widget.TextAreaAuto({
            value: "{/comment}",
            width: "350px",
            rows: 5,
            maxLength: 2048,
            /*autoExpandable: true,*/
            textAlign: sap.ui.core.TextAlign.Begin,
            enterPressed: $.proxy(controller.saveCellComment, controller),
            escapePressed: $.proxy(controller.cancelEdit, controller),
            visible: {
                path: "/showCommentField",
                formatter: function (show) {
                    return show ? true : false;
                }
            }
        });
        var validationUserLabel = new sas.hc.ui.commons.TextView({
            text: "{/validationuser}",
            design: sap.ui.commons.TextViewDesign.Bold,
            visible: "{/showValidation}"
        });
        var validationTimestampLabel = new sas.hc.ui.commons.TextView({
            text: "{/validationdttm}",
            design: sap.ui.commons.TextViewDesign.Small,
            visible: "{/showValidation}"
        });
        this.validationText = new sas.stress.wkbench.widget.TextAreaAuto({
            value: "{/validationError}",
            width: "350px",
            /*height: "100px",*/
            rows: 5,
            enabled: false,
            /*autoExpandable: true,*/
            textAlign: sap.ui.core.TextAlign.Begin,
            wrapping: sap.ui.core.Wrapping.Hard,
            visible: "{/showValidation}"
        });
        return new sas.hc.ui.commons.layout.VerticalLayout({
            content: [commentUserLabel, commentTimestampLabel, this.commentTextArea,
                new sas.hc.ui.commons.HorizontalDivider({
                    visible: {
                        parts: ["/showCommentField", "/showValidation"],
                        formatter: function (cVisible, vVisible) {
                            return cVisible && vVisible;
                        }
                    }
                }),
                validationUserLabel, validationTimestampLabel, this.validationText]
        });
    },
    attachClosing: function (callBack, listener) {
        this.attachEvent(this.getId() + "_CLOSING", callBack, listener);
    },
    destroy:function(){
        sap.ui.core.mvc.JSView.prototype.destroy.apply(this, arguments);
    }
});