jQuery.sap.require({ modName: "sas.stress.wkbench.view.Workbench", type: "controller" });
jQuery.sap.require("sas.hc.ui.core.ListItem");
jQuery.sap.require("sas.hc.m.Button");
jQuery.sap.require("sas.hc.m.Page");
jQuery.sap.require("sas.hc.m.Select");
jQuery.sap.require("sas.hc.m.Toolbar");
jQuery.sap.require("sas.hc.m.ToolbarSpacer");
jQuery.sap.require("sas.hc.m.FlexItemData");
jQuery.sap.require("sas.hc.ui.commons.layout.BorderLayout");
jQuery.sap.require("sas.hc.ui.commons.layout.BorderLayoutArea");
jQuery.sap.require("sas.stress.wkbench.StressUtil");
jQuery.sap.require("sas.stress.wkbench.UserPrefs");
jQuery.sap.require("sas.stress.wkbench.model.Project");
jQuery.sap.require("sas.risk.common.widgets.RiskToolbar");
jQuery.sap.require("sas.risk.common.widgets.WidgetFactory");
jQuery.sap.require("sas.risk.common.widgets.RiskPage");
jQuery.sap.require("sas.stress.wkbench.widget.StressGrooveBar");
jQuery.sap.require("sas.stress.wkbench.widget.StressIconBar");
jQuery.sap.require("sas.stress.wkbench.widget.TaskActionButtons");


sap.ui.jsview("sas.stress.wkbench.view.Workbench", {
    getControllerName: function () {
        return "sas.stress.wkbench.view.Workbench";
    },

    createContent: function (controller) {

        this.setHeight("100%");
        this.sheetSelect = this._createSheetSelect();
        this.iterationSelect = this._createIterationSelect();
        this.sheetCategorySelect = this._createCategoriesSelect();

        this.tokenizer = new sas.hc.ui.commons.facetFilter.FacetTokenizer({
            showCount: false
        }).addStyleClass("filterTokenizer");

        var contentLayout = new sas.hc.ui.commons.layout.BorderLayout({ width: "100%", height: "100%" });
        contentLayout.setAreaData(sap.ui.commons.layout.BorderLayoutAreaTypes.top, {size: "2.5rem"});
        this.topLayout = new sas.hc.ui.commons.layout.BorderLayout({ height: "100%", width: "100%" });
        this.centerLayout = new sas.hc.ui.commons.layout.BorderLayout({
            height: "100%",
            width: "100%"
        }).addStyleClass("stressScenarioEditorLayout");
        contentLayout.addContent(sap.ui.commons.layout.BorderLayoutAreaTypes.top, this.topLayout);
        contentLayout.addContent(sap.ui.commons.layout.BorderLayoutAreaTypes.center, this.centerLayout);
        contentLayout.getArea(sap.ui.commons.layout.BorderLayoutAreaTypes.center);

        var worksheetLayout = new sas.hc.ui.commons.layout.BorderLayout({ width: "100%", height: "100%" });
        var headerArea = new sas.hc.ui.commons.layout.BorderLayoutArea({
            size: "2.5rem",
            content: [this._createFilterToolbar(controller).addStyleClass("worksheetFilterToolbar")]
        }).addStyleClass("stresssheetscenario");

        var sheetArea = new sas.hc.ui.commons.layout.BorderLayoutArea({ content: [contentLayout] }).addStyleClass("stresssheetscenario");
        worksheetLayout.setTop(headerArea);
        worksheetLayout.setCenter(sheetArea);

        this.viewLayout = new sas.risk.common.widgets.RiskPage({
            iconBar: new sas.stress.wkbench.widget.StressGrooveBar({
                section: sas.stress.wkbench.widget.StressGrooveBar.PROJECTS
            }),
            mainContent: sas.risk.common.widgets.WidgetFactory.buildPanel(
                {
                    type: sas.risk.common.widgets.WidgetFactory.OBJECT,
                    top: new sas.risk.common.widgets.RiskToolbar({
                        homeFunction: function () {
                            sas.stress.wkbench.ViewManager.loadProjectManager();
                        },
                        title: new sas.hc.m.Label({text: "{/name}"}),
                        headerContent: [
                            new sas.hc.m.ToolbarSpacer(),
                            this._createTaskActionButtons(controller),
                            new sas.hc.m.ToolbarSpacer({ width: "1rem" }),
                            this._createCommentButton(controller),
                            this._createDrillDownButton(controller),
                            this._createLogButton(controller),
                            this._createExportButton(controller),
                            this._createImportButton(controller),
                            this._createRefreshButton(controller),
                            this._createSaveButton(controller)
                        ]
                    }),
                    content: new sas.risk.common.widgets.RiskPage({
                        mainContent: worksheetLayout,
                        iconBar: new sas.stress.wkbench.widget.StressIconBar({
                            section: sas.stress.wkbench.widget.StressIconBar.WORKSHEET
                        })
                    })
                }
            )
        });

        return this.viewLayout;

    },

    _createFilterToolbar: function (controller) {
        var categoryLabel = new sas.hc.m.Label({ text: sas.stress.wkbench.StressUtil.getBundle().getText("workbench.toolbar.sheet.category.label") });
        categoryLabel.setLabelFor(this.sheetCategorySelect);
        var currentWorksheetLabel = new sas.hc.m.Label({ text: sas.stress.wkbench.StressUtil.getBundle().getText("workbench.toolbar.currentWorksheet.label") });
        currentWorksheetLabel.setLabelFor(this.sheetSelect);
        var iterationLabel = new sas.hc.m.Label({ text: sas.stress.wkbench.StressUtil.getBundle().getText("workbench.toolbar.iteration.label") });
        iterationLabel.setLabelFor(this.iterationSelect);
        return new sas.hc.m.Toolbar({
            content: [
                categoryLabel,
                new sas.hc.m.ToolbarSpacer({ width: ".875rem" }),   // create some space
                this.sheetCategorySelect,
                new sas.hc.m.ToolbarSpacer({ width: "1rem" }),   // create some space
                currentWorksheetLabel,
                new sas.hc.m.ToolbarSpacer({ width: ".875rem" }),   // create some space
                this.sheetSelect,
                new sas.hc.m.ToolbarSpacer({ width: "1rem" }),   // create some space
                iterationLabel,
                new sas.hc.m.ToolbarSpacer({ width: ".875rem" }),   // create some space
                this.iterationSelect,
                new sas.hc.m.ToolbarSpacer({ width: ".875rem" }),   // create some space
                this.tokenizer,
                new sas.hc.m.ToolbarSpacer()
            ]
        });

    },

    _createTaskActionButtons:function(controller){
        var buttons=new sas.stress.wkbench.widget.TaskActionButtons({content:"{/actions}"});
        buttons.setLayoutData(new sas.hc.m.FlexItemData({growFactor: 1, alignSelf:sap.m.FlexAlignSelf.Center}));
        return buttons;
    },
    _createCommentButton: function (controller) {
        this.commentButton=new sas.hc.m.Button({
            icon: sas.icons.HC.COMMENT,
            tooltip: sas.stress.wkbench.StressUtil.getBundle().getText("workbench.comment.button.tip"),
            press: $.proxy(controller.openCellCommentPopup, controller),
            enabled: {
                path: 'live>/selected',
                formatter: function (cellRef) {
                    //Disable button if iteration != current (max) iteration.
                    return !!cellRef && cellRef.getInfoData().isEditable(cellRef.row, cellRef.column + 1, true);
                }
            }
        });
        return this.commentButton;
    },
    _createLogButton: function (controller) {
        return new sas.hc.m.Button({
            id: "sas.stress.wkbench.view.infoButton",
            icon: sas.icons.HC.LOG,
            press: $.proxy(controller.pressLogButton, controller)
        });
    },
    _createExportButton: function (controller) {
        return new sas.hc.m.Button({
            id: "sas.stress.wkbench.view.exportButton",
            icon: sas.icons.HC.DOWNLOAD,
            enabled: {
                path: "live>/toggleButtons",
                formatter: function (enabled) {
                    return enabled ? false : true;
                }
            },
            press: $.proxy(controller.pressExportButton, controller)
        });
    },
    _createImportButton: function (controller) {
        return new sas.hc.m.Button({
            id: "sas.stress.wkbench.view.importButton",
            icon: sas.icons.HC.IMPORT,
            enabled: {
                path: "live>/iterationNumber",
                formatter: function (preferredProjectIterationNumber) {
                    //Enable button only if iteration = current (max) iteration.
                    return (controller.project !== undefined && controller.project.getCurrentIterationNo() === Number(preferredProjectIterationNumber) &&
                            !controller.project.isLocked());
                }
            },
            press: $.proxy(controller.pressImportButton, controller)
        });
    },
    _createSaveButton: function (controller) {
        return new sas.hc.m.Button({
            id: "sas.stress.wkbench.view.saveButton",
            icon: sas.icons.HC.SAVE,
            enabled: {
                path: "live>/toggleButtons",
                formatter: function (enabled) {
                    return enabled ? true : false;
                }
            },
            press: $.proxy(controller.saveProject, controller, null)
        });
    },
    _createRefreshButton: function (controller) {
        return new sas.hc.m.Button({
            id: "Refresh",
            icon: sas.icons.HC.REFRESH,
            press: $.proxy(controller.pressRefreshButton, controller)
        });
    },
    _createDrillDownButton: function(controller){
        return new sas.hc.m.Button({
            id: "Drilldown",
            icon: sas.icons.HC.DRILLDOWNARROW,
            enabled: {
                path : "live>/selected",
                formatter: function(selected){
                    if (selected){
                        var key="$"+selected.colLong+"$"+selected.rowLong;
                        var dataKey=selected.getSheetFilters().getSheetInfo().getData().getDatakeyFromRowColumn(key);
                        var drillDownOverlay=selected.getSheetFilters().getData().cDrillDowns[key];
                        if (drillDownOverlay&&(drillDownOverlay.propertyKey>0||drillDownOverlay.inheritedPropertyKey)){
                            return true;
                        }else{
                            return false;
                        }
                    }
                    return selected?true:false;
                }
            },
            press: $.proxy(controller.pressDrillDownButton,controller)
        });
    },
    _createIterationSelect: function () {
        var dd = new sas.hc.m.Select({
            displaySecondaryValues: true,      // this will make sure the width is the same as the select width
            autoAdjustWidth: true
        });
        dd.attachChange($.proxy(this.getController().changeIteration, this.getController()));
        var itemTemplate = new sas.hc.ui.core.ListItem({
            text: "{text}",
            key: "{key}"
        });
        dd.bindAggregation("items", "/iterations", itemTemplate);
        return dd;
    },
    _createSheetSelect: function () {
        var dd = new sas.hc.m.Select({
            width: "25%",
            autoAdjustWidth: true,
            displayListItemIcon: true,
            /* S1246969 Need to initially add a blank/dummy item to the Select, otherwise the other icons in the
             * containing Toolbar are displayed on a separate line */
            items: [new sas.hc.ui.core.Item({ text: "", key: "dummy" })]
        });   // this will make sure the width is the same as the select width
        dd.attachChange($.proxy(this.getController().openSheetNew, this.getController()));
        // fixes for S1228541.. we cannot use bind aggregation else we do not get all sheets
        return dd;
    },
    _createCategoriesSelect: function (project) {
        var dd = new sas.hc.m.Select({ displaySecondaryValues: true, autoAdjustWidth: true });
        dd.attachChange($.proxy(this.getController().changeSheetCategory, this.getController()));
        var itemTemplate = new sas.hc.ui.core.ListItem({
            text: "{name}",
            key: "{key}",
            additionalText: {
                path: "count",
                formatter: function (count) {
                    return "(" + count + ")";
                }
            }
        });
        dd.bindAggregation("items", "/categories", itemTemplate);
        return dd;
    },

    getSelectedSheetId: function () {
        return this.sheetSelect.getSelectedKey();
    },
    getSelectedIterationId: function () {
        return this.iterationSelect.getSelectedKey();
    },
    getSelectedSheetCategoryKey: function () {
        return this.sheetCategorySelect.getSelectedKey();
    },
    getDefaultSheetId: function (sheets) {
        var project = sas.stress.wkbench.model.Project.getCurrentProject();
        var defSheetId = sas.stress.wkbench.UserPrefs.get("sas.stress.wkbench.sheet_key", project.getId());
        if (defSheetId && _.some(sheets, function (sheet) {
                return sheet.id === defSheetId && !sheet.errored;
            })) {
            return defSheetId;
        }
        var firstNonErroredSheet= _.find(sheets,function(sheet){
            return sheet.errored===false;
        });
        return firstNonErroredSheet?firstNonErroredSheet.id:sheets[0].id;
    },

    getDefaultFilterId: function (sheetId) {
        if (sheetId) {
            return "sheet_" + sheetId + ".filters";
        } else {
            return "sheet_" + this.getSelectedSheetId() + ".filters";
        }
    },

    selectSheet: function (sheetId) {
        this.sheetSelect.setSelectedKey(sheetId);
        this.getController().openSheetNew();
    },
    setCellEditorView: function (view) {
        this.topLayout.removeAllContent(sap.ui.commons.layout.BorderLayoutAreaTypes.center);
        this.topLayout.addContent(sap.ui.commons.layout.BorderLayoutAreaTypes.center, view);
    },
    setScenarioEditorView: function (view) {
        this.centerLayout.removeAllContent(sap.ui.commons.layout.BorderLayoutAreaTypes.center);
        this.centerLayout.addContent(sap.ui.commons.layout.BorderLayoutAreaTypes.center, view);
        this.scenarioEditorView = view;
    },
    getScenarioEditorView: function () {
        return this.scenarioEditorView;
    },

    destroy: function () {
        sap.ui.core.mvc.JSView.prototype.destroy.apply(this, arguments);
    },
    closeView: function () {
        //Needs to be fixed to go back to default tab entry Configuration page
        // Setting it to configuration page results in error of dup id for ConfigurationView
        // calling the destroy function results in a blank page
        // this.getController().router.setView("sas.stress.config.view.Configuration",null);
        // sap.ui.core.mvc.JSView.prototype.destroy.apply(this,arguments);
    }
});