jQuery.sap.declare("sas.stress.wkbench.widget.LifecycleTable");
jQuery.sap.require("sas.hc.ui.table.Table");

sas.hc.ui.table.Table.extend("sas.stress.wkbench.widget.LifecycleTable", {
	metadata:{
		properties:{
			selectedIndices:{type:"int[]",defaultValue:[]}
		},
		events:{
			afterRendering:{},
			beforeRendering:{},
			beforeInit:{},
			afterInit:{},
			beforeExit:{},
			afterExit:{},
			rowSelectionChange:{}
		}
	},
	renderer:"sas.hc.ui.table.TableRenderer",
	constructor:function(){
		sas.hc.ui.table.Table.apply(this,arguments);
	}
});
sas.stress.wkbench.widget.LifecycleTable.prototype.onAfterRendering=function(){
	sas.hc.ui.table.Table.prototype.onAfterRendering.apply(this,arguments);
	this.fireEvent("afterRendering",{});
};
sas.stress.wkbench.widget.LifecycleTable.prototype.onBeforeRendering=function(){
	sas.hc.ui.table.Table.prototype.onBeforeRendering.apply(this,arguments);
	this.fireEvent("beforeRendering",{});
};
sas.stress.wkbench.widget.LifecycleTable.prototype.init=function(){
	this.fireEvent("beforeInit",{});
	sas.hc.ui.table.Table.prototype.init.apply(this,arguments);
	this.ITSINITIALIZED=true;
	this.fireEvent("afterInit",{});
};
sas.stress.wkbench.widget.LifecycleTable.prototype.exit=function(){
	this.fireEvent("beforeExit",{});
	sas.hc.ui.table.Table.prototype.exit.apply(this,arguments);
	this.fireEvent("afterExit",{});
};
sas.stress.wkbench.widget.LifecycleTable.prototype.setSelectedIndices=function(indexArray){
	if (indexArray.length === 0) {
		this._oSelection.clearSelection();
	} else {
		var current=this.getSelectedIndices();
		var toRemove=_.difference(current,indexArray);
		var toAdd=_.difference(indexArray,current);
		_.each(toRemove,function(index){
			this._oSelection.removeSelectionInterval(index, index);
		});
		_.each(toAdd,function(index){
			this._oSelection.addSelectionInterval(index, index);
		});
	}
	return this;
};
sas.stress.wkbench.widget.LifecycleTable.prototype._updateSelection=function(){
	sas.hc.ui.table.Table.prototype._updateSelection.apply(this,arguments);
	this.setProperty("selectedIndices", sas.hc.ui.table.Table.prototype.getSelectedIndices.call(this), true);
};




sas.stress.wkbench.widget.LifecycleTable.prototype._setupSelectionControls = function() {
    var self = this, i, iIndex, $aHeaders, oSelectionControl,
        sId = this.getId(),

        sSelectionMode = this.getSelectionMode(),
        bUseRadioForSingleSelection = this.getUseRadioForSingleSelection();

    function _onSelect( oEvent ) {
        var
            // the original jQuery event
            $jQueryEvent = oEvent.getParameter("jQueryEvent"),
            bShift = false, bCtrl = false,

            // the source of the event (the checkbox or radio button)
            $selectionControl = jQuery(this.getDomRef()),
            // the row the selection control belongs to
            $row = $selectionControl.closest(".sapUiTableRowHdr");

        // were modifier keys pressed
        if( $jQueryEvent ) {
            bShift = $jQueryEvent.shiftKey;
            bCtrl = $jQueryEvent.ctrlKey;
        }

        if ($row.length === 1) {
            iIndex = parseInt($row.attr("data-sap-ui-rowindex"), 10);
            var firstRow = self.getFirstVisibleRow();
            if(self.hasPopin()) {
                firstRow = firstRow * 2;
            }
            self._onRowSelect(firstRow + iIndex, bShift, bCtrl);
        }
    }

    if( this._useSelectionControls() === true ) {
        $aHeaders = jQuery(".sapUiTableRowHdr", this.getDomRef());
        for (i = 0; i < $aHeaders.length; i++) {
                    //if popin row do not add selection control, part of observation
                    if (!jQuery($aHeaders[i]).hasClass("sasPopinRowHdr")) {
                        if (sSelectionMode === sap.ui.table.SelectionMode.Single && bUseRadioForSingleSelection === true) {
                    oSelectionControl = new sas.hc.m.RadioButton({
                        id: sId + "-selectionRadioButton" + this._aSelectionControls.length,
                        groupName: 'RadioGroup' + sId,
                        select: function (e) {
                            if (e.getParameter('selected') === true) {
                                jQuery.proxy(_onSelect, this)(e);
                            }
                        }
                    });
                } else {
                    oSelectionControl = new sas.hc.m.CheckBox({
                        id: sId + "-selectionCheckBox" + this._aSelectionControls.length,
                        select: _onSelect
                    });
                }

//                oSelectionControl.placeAt(jQuery($aHeaders[i]));
                oSelectionControl.placeAt($aHeaders[i]);//FIX
                this._aSelectionControls.push(oSelectionControl);
            }
        }
    }
};