jQuery.sap.declare("sas.stress.wkbench.widget.Slimsheet");
jQuery.sap.require("sap.ui.core.Control");
jQuery.sap.require('sap.ui.thirdparty.jqueryui.jquery-ui-core');
jQuery.sap.require('sap.ui.thirdparty.jqueryui.jquery-ui-widget');
jQuery.sap.require('sap.ui.thirdparty.jqueryui.jquery-ui-mouse');
jQuery.sap.require('sap.ui.thirdparty.jqueryui.jquery-ui-draggable');
jQuery.sap.require('sap.ui.thirdparty.jqueryui.jquery-ui-droppable');
jQuery.sap.require('sap.ui.thirdparty.jqueryui.jquery-ui-sortable');
jQuery.sap.require("sas.stress.wkbench.model.TreeNode");
jQuery.sap.require("sas.stress.wkbench.StressUtil");
jQuery.sap.require("sas.stress.wkbench.CellPickerUtil");


sap.ui.core.Control.extend("sas.stress.wkbench.widget.Slimsheet", {
	metadata:{
		properties:{
			slimsheetSource:{type:"any"}
		},
		events : {
			"cellSelected" : {allowPreventDefault : true}
		}
	},
	constructor:function(){
		sap.ui.core.Control.apply(this,arguments);
		this.dom=null;
		this.firstCol=0;
		this.firstRow=0;
		this.selected=null;
		this.rb=sas.stress.wkbench.StressUtil.getBundle();
	},
	renderer:function(rm, control){
		control.dom=null;
		rm.write("<div tabIndex='0' style='width: 100%;' ");
		rm.addClass("StressSlimsheet");
		rm.writeClasses();
		rm.writeControlData(control);
		rm.write(">");
		rm.write("</div>");
	}
});

/*
 div.StressSlimsheet
 |- div.StressSlimsheetBody
 |-div.StressSlimsheetData
 |- div.StressSlimsheetHeader
 |-div.StressSlimsheetHeaderFixed
 |-table-fixed
 |-div.StressSlimsheetHeaderScrolled
 |-table-scrolled
 |- div.StressSlimsheetContent
 |-div.StressSlimsheetContentFixed
 |-table.fixed
 |-div.StressSlimsheetContentScrolled
 |-table.scrolled
 |-div.StressSlimsheetVScrollbar
 |- div.StressSlimsheetHScrollbar
 |-div.scroller
 |-div.stretcher
 */
sas.stress.wkbench.widget.Slimsheet.M_EVENTS = {'cellSelected':'cellSelected'};
sas.stress.wkbench.widget.Slimsheet.prototype.onBeforeRendering = function() {
	var source=this.getSlimsheetSource();
	if(source){
		source.init();
	}
};
sas.stress.wkbench.widget.Slimsheet.prototype.destroy=function(){
	if (document.getElementById(this.getId())) {
		document.getElementById(this.getId()).removeAttribute("onclick");
		document.getElementById(this.getId()).removeAttribute("ondblclick");
	}

	var elements = [];
	elements=document.getElementsByClassName("StressColResizer");
	while(elements[0]) {
		elements[0].parentNode.removeChild(elements[0]);
	}
	elements=[];
	elements=document.getElementsByClassName("StressSlimsheetHeaderFixed");
	while(elements[0]&&elements[0].firstChild){
		elements[0].removeChild(elements[0].firstChild);
	}
	while (elements[0]){
		elements[0].parentNode.removeChild(elements[0]);
	}
	elements=[];
	elements=document.getElementsByClassName("StressSlimsheetHeaderScrolled");
	while(elements[0]&&elements[0].firstChild){
		elements[0].removeChild(elements[0].firstChild);
	}
	while (elements[0]){
		elements[0].parentNode.removeChild(elements[0]);
	}
	elements=[];
	elements=document.getElementsByClassName("StressSlimsheetContentFixed");
	while(elements[0]&&elements[0].firstChild){
		elements[0].removeChild(elements[0].firstChild);
	}
	while (elements[0]){
		elements[0].parentNode.removeChild(elements[0]);
	}
	elements=[];
	elements=document.getElementsByClassName("StressSlimsheetContentScrolled");
	while(elements[0]&&elements[0].firstChild){
		elements[0].removeChild(elements[0].firstChild);
	}
	while (elements[0]){
		elements[0].parentNode.removeChild(elements[0]);
	}
	elements=[];
	elements=document.getElementsByClassName("StressSlimsheetHeader");
	while(elements[0]&&elements[0].firstChild){
		elements[0].removeChild(elements[0].firstChild);
	}
	while (elements[0]){
		elements[0].parentNode.removeChild(elements[0]);
	}
	elements=[];

	elements=document.getElementsByClassName("StressSlimsheetContent");
	while(elements[0]&&elements[0].firstChild){
		elements[0].removeChild(elements[0].firstChild);
	}
	while (elements[0]){
		elements[0].parentNode.removeChild(elements[0]);
	}
	elements=[];
	elements=document.getElementsByClassName("StressSlimsheetData");
	while(elements[0]&&elements[0].firstChild){
		elements[0].removeChild(elements[0].firstChild);
	}
	while (elements[0]){
		elements[0].parentNode.removeChild(elements[0]);
	}
	elements=[];
	elements=document.getElementsByClassName("StressSlimsheetBody");
	while(elements[0]&&elements[0].firstChild){
		elements[0].removeChild(elements[0].firstChild);
	}
	while (elements[0]){
		elements[0].parentNode.removeChild(elements[0]);
	}
	elements=[];
	elements=document.getElementsByClassName("StressSlimsheetHScrollbar");
	while(elements[0]&&elements[0].firstChild){
		if (elements[0].firstChild.firstChild){
			elements[0].firstChild.removeChild(elements[0].firstChild.firstChild);
		}
		elements[0].removeChild(elements[0].firstChild);
	}
	while (elements[0]){
		elements[0].parentNode.removeChild(elements[0]);
	}
	if (this.dom) {
		this.dom.hbar.scroller.val.onscroll = null;
		var $scroller = this.dom.body.vbar.scroller.val;
		$scroller.removeEventListener("scroll", $.proxy(this.onRowScroll, this, this.dims), false);
		var $table = this.dom.body.data.contents.scrolled.table.val;
		$table.removeEventListener("wheel", $.proxy(this.onWheelRowScroll, this, this.dims), false);
	}

	elements=[];
	elements=document.getElementsByClassName("StressSlimsheet");
	while(elements[0]&&elements[0].firstChild){
		elements[0].removeChild(elements[0].firstChild);
	}
	while (elements[0]){
		elements[0].parentNode.removeChild(elements[0]);
	}
	elements=[];
	this.dom=null;
	this.dims=null;
	this.selectedCell=null;

	var source=this.getSlimsheetSource();
	source.destroy();
	delete source;

	delete this.dom;
	delete this.dims;
};
sas.stress.wkbench.widget.Slimsheet.prototype.onExit=function(/*e*/){
	if (sap.ui.core.Control.prototype){
		sap.ui.core.Control.prototype.destroy(true);
	}
};
sas.stress.wkbench.widget.Slimsheet.prototype.onAfterRendering = function() {
	sas.stress.wkbench.widget.Slimsheet.renderTable(this,this.getDomRef());
	var that=this;
	$(window).resize(function(){
		window.setTimeout($.proxy(that.onWindowResize,that),500);
	});
};
sas.stress.wkbench.widget.Slimsheet.prototype.onfocusin=function(e){
	console.info("in onFocus of slimsheet");
	if(sas.stress.wkbench.CellPickerUtil.getOperationMode() !== sas.stress.wkbench.CellPickerUtil.EDIT_MODE) {
		var source = this.getSlimsheetSource();
		var currentcol = source.getSelectedColumn();
		var currentrow = source.getSelectedRow();
		if (currentcol > 0 && currentrow > 0) {
			var filter = source.getCellFilter(currentrow, currentcol);

			console.log("selecting:-- row-" + currentrow + " column-" + currentcol);
			this.fireCellSelected({
				selected: true,
				row: currentrow,
				col: currentcol,
				filter: source.getCellFilter(currentrow, currentcol)
			});
		}
	}
	//this.selectCell(currentrow,currentcol,filter);
};
sas.stress.wkbench.widget.Slimsheet.prototype.onfocusout=function(e){
	console.info("out of Focus of slimsheet");
	if(sas.stress.wkbench.CellPickerUtil.getOperationMode() !== sas.stress.wkbench.CellPickerUtil.EDIT_MODE) {
		var source=this.getSlimsheetSource();
		var id=this.getId();
		if (this.selected) {
			var calculatedColumn = source.getCalculatedColumn(this.selected.col, this.selected.filterId);
			var prevSelectedCell = sas.stress.wkbench.widget.Slimsheet.findCell(this, this.selected.row, calculatedColumn);
			if (prevSelectedCell) {
				$(prevSelectedCell).removeClass("SlimSelected");
			}

			//un-Highlight col headears.. first and last
			$("#"+id+"-head-scrolled-0"+"x"+calculatedColumn).parent().removeClass("SlimSelectedHeader");
			$("#"+id+"-head-scrolled-"+source.getColumnHeadersCount()+"x"+calculatedColumn).parent().removeClass("SlimSelectedHeader");
			//un-Highlight row headears.. first and last
			$("#"+id+"-fixed-"+calculatedColumn+"x"+0).parent().removeClass("SlimSelectedHeader");
			$("#"+id+" .SlimSelectedHeader").removeClass();
		}
	}
};
//----
sas.stress.wkbench.widget.Slimsheet.prototype.onkeydown=function(e){
	var control = this;
	var dims = control.dims;
	var selected = control.selected;
	if (selected) {
		var keycode = e.keyCode;
		var source = this.getSlimsheetSource();
		var info = source.getInfo();
		var currentrow = selected.row;
		var currentcol = selected.col;
		var filter = source.getCellFilter(currentrow, currentcol);
		var scrollPosition = 0;
		switch (keycode) {
			case 37:/*left arrow*/
				if ((currentcol/* - 1*/) === 0) {
					return;
				}
				sas.stress.wkbench.widget.Slimsheet.closeCellCommentEditor(currentcol, currentrow, filter);
				if (currentcol !== 0) {
					// the scrollposiition should be advanced by the width * num of cols
					scrollPosition = 110 * (currentcol - 1);
				}
				control.dom.hbar.scroller.val.scrollLeft = scrollPosition;
				window.setTimeout(function(){
					control.fireCellSelected({selected:true,row:currentrow,col:currentcol-1,filter:source.getCellFilter(currentrow,currentcol)});
				},100);
				break;

			case 38:/*up arrow*/
				if ((currentrow/* - 1*/) === 0) {
					return;
				}
				sas.stress.wkbench.widget.Slimsheet.closeCellCommentEditor(currentcol, currentrow, filter);
				sas.stress.wkbench.widget.Slimsheet.closeCellCommentEditor(currentcol, currentrow, filter);
				if (currentrow-this.firstRow===10){	// scroll ahead if there is a difference of 10
					this.dom.body.vbar.scroller.val.scrollTop -= 20;
				}else{
					this.dom.body.vbar.scroller.val.scrollTop -= 1;
				}
				window.setTimeout(function(){
					control.fireCellSelected({selected:true,row:currentrow-1,col:currentcol,filter:source.getCellFilter(currentrow,currentcol)});
				},100);

				break;

			case 39:/*right arrow*/
				if ((currentcol + 1) === info.scrolled.colCount) {
					return;
				}
				sas.stress.wkbench.widget.Slimsheet.closeCellCommentEditor(currentcol, currentrow, filter);
				// if the initial col is not the firstcol
				if (currentcol !== 0) {
					// the scrollposiition should be advanced by the width * num of cols
					scrollPosition = 110 * (currentcol + 1);
				}
				if (dims.scrolledOffsetWidth > 100) {
					control.dom.hbar.scroller.val.scrollLeft = scrollPosition;
				} else {
					control.dom.hbar.scroller.val.scrollLeft += dims.scrolledOffsetWidth;
				}
				window.setTimeout(function(){
					control.fireCellSelected({selected:true,row:currentrow,col:currentcol+1,filter:source.getCellFilter(currentrow,currentcol)});
				},100);

				break;

			case 40:/*down arrow*/
				if ((currentrow + 1) === info.fixed.rowCount) {
					return;
				}
				sas.stress.wkbench.widget.Slimsheet.closeCellCommentEditor(currentcol, currentrow, filter);
				if (currentrow+10>=dims.viewableRows){
					this.dom.body.vbar.scroller.val.scrollTop += 20;
				}else{
					this.dom.body.vbar.scroller.val.scrollTop += 1;
				}
				window.setTimeout(function(){
					control.fireCellSelected({selected:true,row:currentrow+1,col:currentcol,filter:source.getCellFilter(currentrow,currentcol)});
				},100);

				break;
		}
	}
};
//---
sas.stress.wkbench.widget.Slimsheet.closeCellCommentEditor=function(col,row,filter){
	var cellRef=new sas.stress.wkbench.model.CellRef(col,row,filter);
	var cellCommentEditor=sas.stress.wkbench.ViewManager.getCellCommentEditor(cellRef);
	if (cellCommentEditor){
		cellCommentEditor.fireEvent(cellCommentEditor.getId()+"_CLOSING",{"view":cellCommentEditor,"action":"CANCEL"});
	}
};

sas.stress.wkbench.widget.Slimsheet.prototype.onclick=function(e){
	var target=e.target;
	if (_.size(target.dataset)===0){
		target=e.target.parentElement;
	}
	var row=parseInt(target.dataset.row)+this.firstRow;
	var col=parseInt(target.dataset.col)+this.firstCol;
	var source=this.getSlimsheetSource();
	sas.stress.wkbench.widget.Slimsheet.dimInPlaceEdit(this);
	if(source.isSelectable(row,col)&&target.tagName==="DIV"&&target.id&&target.id.indexOf("-scrolled-")!==-1){
		this.fireCellSelected({selected:true,row:row,col:source.getRealColumn(col),filter:source.getCellFilter(row,col)});
	}
	e.preventDefault();
	e.stopPropagation();
};
sas.stress.wkbench.widget.Slimsheet.prototype.ondblclick=function(e){
	var that=this;
	var target=e.target;
	if (_.size(target.dataset)===0){
		target=e.target.parentElement;
	}
	var rowStr=target.dataset.row;
	var colStr=target.dataset.col;
	var source=this.getSlimsheetSource();
	if(!isNaN(rowStr) && !isNaN(colStr) && !source.isSelectable(parseInt(rowStr)+this.firstRow,parseInt(colStr)+this.firstCol)){
		return;
	}/*only show in place edit for selectable cells*/
	/*only show in place edit for editable cells*/
	var filter=source.getCellFilter(rowStr,colStr);
	if (!filter.getSheetInfo().getData().isEditable(Number(rowStr)+this.firstRow,(Number(colStr)+1)+this.firstCol)){
		return;
	}
	var id=this.getId()+"-inplace-edit";
	var inplace=document.getElementById(id);
	var tester=document.getElementById(id+"-tester");
	var y=$(e.target).offset().top-$(window).scrollTop();
	var x=$(e.target).offset().left-$(window).scrollLeft();
	if(!inplace){
		inplace=document.createElement("TEXTAREA");
		inplace.style.resize="none";
		inplace.id=id;
		inplace.className='StressSlimsheetInplace';
		$(inplace).css({'font': $(e.target.parentElement.parentElement).css("font")});
		window.document.body.appendChild(inplace);
		tester=document.createElement("DIV");
		tester.id=id+"-tester";
		$(tester).css({
			'position': 'absolute',
			'float': 'left',
			'white-space': 'nowrap',
			'visibility': 'hidden',
			'font': $(e.target.parentElement.parentElement).css("font")});
		window.document.body.appendChild(tester);

		$(inplace).keydown(function(event){
			switch(event.keyCode){
				case 27:/*Esc*/
					sas.stress.wkbench.widget.Slimsheet.dimInPlaceEdit(that);
					sas.stress.wkbench.ViewManager.getCellEditor().cancelEditButton.firePress({});
					break;
				case 13:/*Enter*/
					sas.stress.wkbench.widget.Slimsheet.dimInPlaceEdit(that);
					sas.stress.wkbench.ViewManager.getCellEditor().saveEditButton.firePress({});
					break;
			}
		});
		$(inplace).keyup(function(event){
			switch(event.keyCode){
				case 27:/*Esc*/
				case 13:/*Enter*/
					break;
				default:
					sas.stress.wkbench.widget.Slimsheet._adjustInPlaceEditWidth(tester,inplace);
					formulaField.setValue(inplace.value);
					$(formulaField.getDomRef()).keypress();
				//formulaField.fireLiveChange({});
			}
		});
		$(inplace).blur(function(){
			sas.stress.wkbench.widget.Slimsheet.dimInPlaceEdit(that);
			sas.stress.wkbench.ViewManager.getCellEditor().cancelEditButton.firePress({});
		});
	}
	inplace.rows=1;
	inplace.style.visibility="visible";
	inplace.style.width=$(e.target).width()+7+"px";//border:2+2 padding:1+2
	inplace.style.top=y+"px";
	inplace.style.left=x+"px";
	var formulaField=sas.stress.wkbench.ViewManager.getCellEditor().formulaField;
	inplace.value=formulaField.getLiveValue();
	sas.stress.wkbench.widget.Slimsheet._adjustInPlaceEditWidth(tester,inplace);
	$(formulaField.getDomRef()).focus();
	$(inplace).focus();
	sas.stress.wkbench.ViewManager.getCellEditor().getController().gainedFocus();

	//$(inplace).focusout(function(){sas.stress.wkbench.widget.Slimsheet.dimInPlaceEdit(control);});
	sas.stress.wkbench.StressUtil.setCaretPosition(id,inplace.value.length);
};

sas.stress.wkbench.widget.Slimsheet.prototype.selectCell=function(row,col,filterId/*scenarioId*/){
	console.info("Cell Selected-2");

	if(this.selected){
		var calculatedColumn=this.getSlimsheetSource().getCalculatedColumn(this.selected.col,this.selected.filterId/*scenarioId*/);
		var prevSelectedCell=sas.stress.wkbench.widget.Slimsheet.findCell(this,this.selected.row,calculatedColumn);
		if(prevSelectedCell){
			$(prevSelectedCell).removeClass("SlimSelected");
			var id=this.getId();
			$("#"+id+" .SlimSelectedHeader").removeClass();
		}
	}
	this.selected={row:row,col:col,filterId:filterId/*scenarioId:scenarioId*/};
	sas.stress.wkbench.widget.Slimsheet.selectCell(this,row,col,filterId/*scenarioId*/);
	// set the selected on the source so that when the sheet is selected and focussed, this row col gets highlighted
	if(sas.stress.wkbench.CellPickerUtil.getOperationMode() !== sas.stress.wkbench.CellPickerUtil.EDIT_MODE) {
		this.getSlimsheetSource().setSelectedColumn(col);
		this.getSlimsheetSource().setSelectedRow(row);
	}
};
sas.stress.wkbench.widget.Slimsheet.prototype.onWindowResize=function(e){
	console.log("SlimSheet::onWindowResize:" + e);
	$(this.dom.body.val).remove();
	this.dom.body=null;
	$(this.dom.hbar.val).remove();
	this.dom.hbar=null;
	this.firstRow=0;
	this.firstCol=0;
	sas.stress.wkbench.widget.Slimsheet.renderTable(this,this.getDomRef());
};
sas.stress.wkbench.widget.Slimsheet.prototype.onWheelRowScroll=function(dims,e){
	console.warn(e.deltaY,e,this.dom.body.vbar.scroller.val.scrollTop);
	this.dom.body.vbar.scroller.val.scrollTop+=e.deltaY;
};
sas.stress.wkbench.widget.Slimsheet.prototype.onColScroll=function(dims,e){
	console.info("Column Scrolled-1");
	var max=e.target.scrollWidth-e.target.clientWidth;
	var val=e.target.scrollLeft;
	this.firstCol=(val===0||max===0)?0:Math.floor(dims.maxScrolledCol*val/max);
//	$(this.dom.body.data.headers.val).remove();//too slow
	this.dom.body.data.val.removeChild(this.dom.body.data.headers.val);
//	$(this.dom.body.data.contents.val).remove();//too slow
	this.dom.body.data.val.removeChild(this.dom.body.data.contents.val);
	sas.stress.wkbench.widget.Slimsheet.renderTable(this,this.getDomRef());

};

sas.stress.wkbench.widget.Slimsheet.prototype.onRowScroll=function(dims,e){
	console.info("Row Scrolled-1");
	var max=e.target.scrollHeight-(e.target.offsetHeight);//IE doesnt calculate clientHeight
	var val=e.target.scrollTop;
	this.firstRow=Math.floor(dims.maxScrolledRow*val/max);
	var source=this.getSlimsheetSource();
	var info=source.getInfo();
	this.dom.body.data.val.removeChild(this.dom.body.data.contents.val);
	sas.stress.wkbench.widget.Slimsheet.fillInValues(this,info,dims,source);
};

sas.stress.wkbench.widget.Slimsheet.prototype.removeCellWithSelectedClass=function(){
	var $cell=$(".StressSlimsheet .SlimSelected");
	if ($cell&&$cell.hasClass("SlimSelected")){
		$cell.removeClass("SlimSelected");
	}
	/*return;*/
};

/*
 //STATICS BEGIN HERE
 */
sas.stress.wkbench.widget.Slimsheet.selectCell = function(control,row,col,filterId) {
	var source=control.getSlimsheetSource();
	var calculatedColumn=source.getCalculatedColumn(col,filterId);//so compare can adjust
	var id=control.getId();
	$("#"+id+" .SlimSelectedHeader").removeClass();
	var calcRowIdx=row;
	var calcColIdx=calculatedColumn/*-control.firstCol*/; // TODO: should i be worrying about the firstcol moving??- SRINI
	var cell=sas.stress.wkbench.widget.Slimsheet.findCell(control,row,calculatedColumn);
	if(cell){
		$(cell).addClass("SlimSelected");
	}

	//Highlight col headears.. first and last
	$("#"+id+"-head-scrolled-0"+"x"+calcColIdx).parent().addClass("SlimSelectedHeader");
	//$("#"+id+"-head-scrolled-"+source.getColumnHeadersCount()+"x"+calcColIdx).parent().addClass("SlimSelectedHeader");
	//Highlight row headears.. first and last
	$("#"+id+"-fixed-"+calcRowIdx+"x"+0).parent().addClass("SlimSelectedHeader");
	//$("#rowH"+id+"-fixed-"+calcRowIdx+"x"+source.getRowHeadersCount()).parent().addClass("SlimSelectedHeader");
};
sas.stress.wkbench.widget.Slimsheet.decorateCells = function(control,source) {
	$(".StressSlimsheet .SlimCommented .SlimValidationError").removeAttr("onmouseover").removeAttr("onmouseout");
	$(".StressSlimsheet .StressSlimsheetContent .StressSlimsheetContentScrolled td>span>div:first-child").removeClass();
	$(".StressSlimsheet .StressSlimsheetContent .StressSlimsheetContentFixed td+td>span>div.SlimHierarchyRoot").removeClass();
	if(control.selected){
		var selected=control.selected;
		sas.stress.wkbench.widget.Slimsheet.selectCell(control,selected.row,selected.col,selected.filterId);
	}
	source.decorateCells(control);
};
sas.stress.wkbench.widget.Slimsheet.findCell = function(control,rowIdx,colIdx,isFixed) {
	var prefix="-"+(isFixed?"fixed":"scrolled")+"-";
	if (control.dom) {
		if (control.dom.body.data.contents.scrolled) {
			var rowInfo = control.dom.body.data.contents.scrolled.table.tr;
			if (rowInfo[0]) {
				if (rowIdx >= control.firstRow && rowIdx <= control.firstRow + rowInfo.length) {
					if (colIdx >= control.firstCol && colIdx <= control.firstCol + rowInfo[0].length) {
						var calcRowIdx = rowIdx - control.firstRow;
						var calcColIdx = colIdx - control.firstCol;
						var id = control.getId() + prefix + calcRowIdx + "x" + calcColIdx;
						return document.getElementById(id);
					}
				}
			}
		}
	}
	return null;
};
sas.stress.wkbench.widget.Slimsheet.findRow = function(control,rowIdx) {
	var colIdx;
	var cells=[];
	var rowInfo=control.dom.body.data.contents.scrolled.table.tr;
	if(rowIdx>=control.firstRow && rowIdx<=control.firstRow+rowInfo.length){
		var calcRowIdx=rowIdx-control.firstRow;
		var partialId=control.getId()+"-scrolled-"+calcRowIdx+"x";
		if (rowInfo[0]) {
			for (colIdx = control.firstCol; colIdx <= control.firstCol + rowInfo[0].length; colIdx++) {
				var calcColIdx = colIdx - control.firstCol;
				var id = partialId + calcColIdx;
				cells.push(document.getElementById(id));
			}
		}
	}
	return cells;
};
sas.stress.wkbench.widget.Slimsheet.renderTable = function(control, parent) {
	control.dom=control.dom||{val:parent};
	var source=control.getSlimsheetSource();
	if(!source){
		return;
	}
	var info=source.getInfo();
	var dims=sas.stress.wkbench.widget.Slimsheet.calcDimensions(control,info);
	sas.stress.wkbench.widget.Slimsheet.createStructure(control,info,dims,source);
	sas.stress.wkbench.widget.Slimsheet.decorateCells(control,source);
	sas.stress.wkbench.widget.Slimsheet.createColumnResizers(control);
};
//VALUES
sas.stress.wkbench.widget.Slimsheet.fillInValues = function(control,info,dims,source) {
	//sas.stress.wkbench.widget.Slimsheet._fillInValues(control,info,dims,source,"fixed");renderTableContents
	sas.stress.wkbench.widget.Slimsheet.calcDimensions(control,info);
	sas.stress.wkbench.widget.Slimsheet.renderTableContents(control,info,dims,source,"fixed");
	//sas.stress.wkbench.widget.Slimsheet._fillInValues(control,info,dims,source,"scrolled");
	sas.stress.wkbench.widget.Slimsheet.decorateCells(control,source);
};
sas.stress.wkbench.widget.Slimsheet._fillInValues = function(control,info,dims,source,prefix) {
	var i,j,row,col,inRange,tds,values;
	var isScrolled=prefix==="scrolled";
	var colCount=isScrolled?dims.viewableCols:info.fixed.colCount;
	var firstCol=isScrolled?control.firstCol:0;
	var lastCol=isScrolled?Math.min(firstCol+colCount,info.scrolled.colCount):firstCol+colCount;
	var rowCount=dims.viewableRows;
	var lastRow=control.firstRow+rowCount;
	var table=control.dom.body.data.contents[isScrolled?"scrolled":"fixed"].table;
	var getValueFunc=isScrolled?source.getScrolledRowData:source.getFixedRowData;
	for(i=0,row=control.firstRow;row<lastRow;i++,row++){
		inRange=row<info.rowCount;
		tds=table.tr[i];
		values=inRange?getValueFunc.call(source,row):null;
		var formatter=source.getFormatter(row);
		for(j=0,col=firstCol;col<lastCol;j++,col++){
			if (tds[j]) {
				tds[j].text.nodeValue = inRange ? sas.stress.wkbench.widget.Slimsheet.formatValue(values[col], source, isScrolled, formatter) : "";
			}
		}
	}
};
//STRUCTURE
sas.stress.wkbench.widget.Slimsheet.createStructure = function(control,info,dims,source) {
	var reuse=!!control.dom.body;
	var divBody=reuse?control.dom.body.val:document.createElement("DIV");
	if(!reuse){
		control.dom.body={val:divBody};
		divBody.className="StressSlimsheetBody";
		var divData=document.createElement("DIV");
		control.dom.body.data={val:divData};
		divData.className="StressSlimsheetData";
	}
	sas.stress.wkbench.widget.Slimsheet.renderTableHeaders(control,info,dims);
	sas.stress.wkbench.widget.Slimsheet.renderTableContents(control,info,dims,source);
	if(!reuse){
		divBody.appendChild(divData);
	}
	if(!reuse){
		control.dom.val.appendChild(divBody);
	}
	sas.stress.wkbench.widget.Slimsheet.renderVertScrollBar(control,dims);
	sas.stress.wkbench.widget.Slimsheet.renderHorizScrollBar(control,dims);
};
//HEADERS
sas.stress.wkbench.widget.Slimsheet.renderTableHeaders = function(control,info,dims) {
	var divHeaders=document.createElement("DIV");
	control.dom.body.data.headers={val:divHeaders};
	divHeaders.className="StressSlimsheetHeader";
	//FIXED
	var divHeaderFixed=document.createElement("DIV");
	control.dom.body.data.headers.fixed={val:divHeaderFixed};
	divHeaderFixed.style.float="left";
	divHeaderFixed.className="StressSlimsheetHeaderFixed";
	sas.stress.wkbench.widget.Slimsheet.renderTableHeader(control,info,dims,"fixed");
	//sas.stress.wkbench.widget.Slimsheet.renderTableRowHiearchy(control,info,dims,"fixed");
	divHeaders.appendChild(divHeaderFixed);
	//SCROLLED
	var divHeaderScrolled=document.createElement("DIV");
	control.dom.body.data.headers.scrolled={val:divHeaderScrolled};
	divHeaderScrolled.style.overflowX="hidden";
	divHeaderScrolled.className="stressSlimsheetHeaderScrolled";
	sas.stress.wkbench.widget.Slimsheet.renderTableHeader(control,info,dims,"scrolled");
	divHeaders.appendChild(divHeaderScrolled);
	control.dom.body.data.val.appendChild(divHeaders);
};
sas.stress.wkbench.widget.Slimsheet.renderTableHeader = function(control,info,dims,prefix) {
	var j,th;
	var isScrolled=prefix==="scrolled";
	var table=document.createElement("TABLE");
	control.dom.body.data.headers[isScrolled?"scrolled":"fixed"].table={val:table};
	table.style.width=isScrolled?String(dims.scrolledClientWidth)+"px":String(dims.fixedWidth)+"px";
	table.style.tableLayout="fixed";
	var thead=document.createElement("THEAD");
	var theadtr=document.createElement("TR");
	var firstCol=isScrolled?control.firstCol:0;
	var colCount=isScrolled?dims.viewableCols:info.fixed.colCount;
	var lastCol=firstCol+colCount;
	var widths=isScrolled?info.scrolled.widths:info.fixed.widths;
	for(j=firstCol;j<lastCol;j++){
		th=document.createElement("TH");
		th.className=prefix+"-col-"+j;
		if (j===(lastCol-1)&&!isScrolled) {
			th.style.width = String(widths[j] + 16) + "px";
		}else{
			th.style.width = String(widths[j]) + "px";
		}
		theadtr.appendChild(th);
	}
	thead.appendChild(theadtr);
	table.appendChild(thead);
	sas.stress.wkbench.widget.Slimsheet.renderTableHeaderLabels(control,info,dims,prefix);
	control.dom.body.data.headers[isScrolled?"scrolled":"fixed"].val.appendChild(table);
};
sas.stress.wkbench.widget.Slimsheet.renderTableHeaderLabels = function(control,info,dims,prefix) {
	var i,td,div,tr,labels,col,isGrouped,span;
	var isScrolled=prefix==="scrolled";
	var id=control.getId()+"-head-"+prefix+"-";
	var colCount=isScrolled?dims.viewableCols:info.fixed.colCount;
	var firstCol=isScrolled?control.firstCol:0;
	var lastCol=firstCol+colCount;
	var headerCount=info.headerCount;
	var groupCount=info.groupCount;
	var labelsInfo=isScrolled?info.scrolled:info.fixed;
	var table=control.dom.body.data.headers[isScrolled?"scrolled":"fixed"].table.val;
	for(i=0;i<headerCount;i++){
		labels=labelsInfo["label_"+i];
		tr=document.createElement("TR");
		var groupColumnCount= 0, groupColumnIndex= 0/*1*/,j= 0, rspan= 0, txt="",title="";
		if (firstCol!==0){
			groupColumnIndex=1;
		}
		for(col=firstCol;col<lastCol;col++){
			// if we are scrolling horizontally.. then the firstCol!=0
			if (isScrolled&&firstCol!==0) {
				if (groupColumnIndex===1&&j===0) {
					groupColumnIndex = firstCol;
					j=firstCol/*-1*/;
				}
			}
			if (isScrolled/*&&col!==0*//*&&headerrow*/){//||i!==(headerCount-1)
				if (/*(col!==0&&groupCount===1)&&*/col===groupColumnIndex) {
					var node=labels.nodes?labels.nodes[j]:undefined;
					if (node) {
						rspan = groupCount = this._calculateSpanOnHScroll(node,firstCol/*(firstCol-1)*/,col===firstCol);
						txt = node.getName();
						title=node.getDataKey();
					} else{
						rspan=groupCount=1;
						txt=labels[col];
					}
					j+=rspan;
					groupColumnIndex+=rspan;
					groupColumnCount=rspan;
				}
			} else {
				txt=labels?(labels[col]?labels[col]:" "):"";
			}
			isGrouped=isScrolled&& groupCount>1 /*&& col!==0*/ /*headerCount===3 && i===0 &&*/ ;
			if(isGrouped && (col!== (groupColumnIndex-groupColumnCount))){
				continue;
			}
			td=document.createElement("TD");
			// if node has a subtotalChild.. we need to style differently, else no styling.. current 2.3 behavior
			if (node&&sas.stress.wkbench.widget.Slimsheet._doesNodeHaveSubtotalChild(node)===false){
				if(isGrouped){
					td.colSpan=(j===0)?groupCount-((col-1)%groupCount):groupCount;
				}
				if (node.getDataKey()===undefined){// subtotal nodes will not have datakey
					td.className="stressSlimsheetHeaderScrolledNonSubtotalled";
				}else if (sas.stress.wkbench.widget.Slimsheet._doesNodeHaveSubtotalChild(node.getParent())){	// does node's parent have a subtotal?
					td.className+="stressResize";
				}else{	// this is the leaf... therefore, apply different style
					td.className+="stressNonSubtotalResize";
				}
			}else{
				if (node) {
					td.className = "stressSlimsheetHeaderScrolledSubtotalled ";
				}
				if(isGrouped){
					td.colSpan=(j===0)?groupCount-((col-1)%groupCount):groupCount;
					td.className+="stressHighlightSubTotalRow";
				}else if (node&&(node.getDataKey()&&(""===node.getLiKey()||node.getChildren().length>0))){
					td.className+="stressHighlightSubTotalRow stressRemoveTopBorder";	// highlight the column, remove the top border..
				}else if (node&&(node.getDataKey()&&(""!==node.getLiKey()||node.getChildren().length===0))){
					td.className+="stressResize";
				}
			}
			div=document.createElement("DIV");
			div.id=id+i+"x"+col;
			div.innerHTML=txt;
			td.appendChild(div);
			span=document.createElement("SPAN");
			if (!isScrolled) {
				if ((col===0)||(col===(lastCol-1))) {	// only the first and last fixed col will have a resizer
					span.className = "StressColResizerPlaceholder";
				}
			}else{
				span.className = "StressColResizerPlaceholder";
			}
			span.dataset.col=col;
			span.dataset.scrolled=isScrolled?1:0;
			td.appendChild(span);
			if (isScrolled) {	// the fixed columns do not have tool tips on hover
				switch (i) {
					case 0:	// this is the colmn short reference header
						td.title = txt;	// tooltip for the row in the header..
						break;
					default:
						if (txt.length===0){
							td.title = control.rb.getText("slimsheet.td.tip.fmt.txt", [node?node.getParent().getName():"", node?node.getParent().getDataKey():title]);	// tooltip for the row in the header..
						}else {
							td.title = control.rb.getText("slimsheet.td.tip.fmt.txt", [txt, title]);	// tooltip for the row in the header..
						}
						break;
				}
			}

			tr.appendChild(td);
		}
		if (isScrolled&&i===0){ // this is the short column reference row
			tr.className="stressColShortReference";
		}
		table.appendChild(tr);
	}
};
sas.stress.wkbench.widget.Slimsheet.renderTableRowHiearchy = function(control,info,dims,prefix) {
	var i,td,div,tr,labels,isGrouped;
	var isScrolled=prefix==="scrolled";
	var id=control.getId()+"-head-"+prefix+"-";
	var colCount=isScrolled?dims.viewableCols:info.fixed.colCount;
	var firstCol=isScrolled?control.firstCol:1;
	var rowCount=info.fixed.rowCount;
	var groupCount=info.groupCount;

	var labelsInfo=isScrolled?info.scrolled:info.fixed;
	var table=control.dom.body.data.headers[isScrolled?"scrolled":"fixed"].table.val;
	for(i=0;i<rowCount;i++){
		labels=labelsInfo["label_"+i];
		tr=document.createElement("TR");
		var groupColumnCount= 0, groupColumnIndex= 1,j= 0, rspan= 0, txt="";
		for(var row=0;row<colCount;row++){
			if (row!==0){//||i!==(headerCount-1)
				if (row===groupColumnIndex) {
					var node=labels.nodes?labels.nodes[j]:undefined;
					if (node) {
						rspan = groupCount = this._calculateSpanOnHScroll(node,(firstCol-1),false);
						txt=node.getName();
					} else{
						rspan=groupCount=1;
						txt=labels[row];
					}
					/*txt = headerrow ?((headerrow.label[j])?headerrow.label[j]:" "):labels[col];*/
					j+=rspan;
					groupColumnIndex+=rspan;
					groupColumnCount=rspan;
				}
			} else {
				txt=labels[row]?labels[row]:" ";
			}
			isGrouped=groupCount>1 && /*headerCount===3 && i===0 &&*/ row!==0;
			//isGrouped=isScrolled&& groupCount>1 /*&& headerCount===3*/ && i<headerCount && col!==0;
			if(isGrouped && (row!== (groupColumnIndex-groupColumnCount))){
				continue;
			}
			td=document.createElement("TD");
			if(isGrouped){
				td.rowSpan=rspan;
			}
			div=document.createElement("DIV");
			div.id=id+i+"x"+j;
			//var text=labels[col]?labels[col]:" ";
			div.appendChild(document.createTextNode(txt));
			td.appendChild(div);

			tr.appendChild(td);
		}

		table.appendChild(tr);
	}
};
//CONTENTS
sas.stress.wkbench.widget.Slimsheet.renderTableContents = function(control,info,dims,source) {
	var divContents=document.createElement("DIV");
	control.dom.body.data.contents={val:divContents};
	divContents.className="StressSlimsheetContent";
	//FIXED
	var divContentFixed=document.createElement("DIV");
	control.dom.body.data.contents.fixed={val:divContentFixed};
	divContentFixed.style.float="left";
	divContentFixed.className="StressSlimsheetContentFixed";
	sas.stress.wkbench.widget.Slimsheet.renderTableContent(control,info,dims,source,"fixed");
	divContents.appendChild(divContentFixed);
	//SCROLLED
	var divContentScrolled=document.createElement("DIV");
	control.dom.body.data.contents.scrolled={val:divContentScrolled};
	divContentScrolled.style.overflowX="hidden";
	divContentScrolled.className="StressSlimsheetContentScrolled";
	sas.stress.wkbench.widget.Slimsheet.renderTableContent(control,info,dims,source,"scrolled");
	divContents.appendChild(divContentScrolled);
	control.dom.body.data.val.appendChild(divContents);
};
sas.stress.wkbench.widget.Slimsheet.renderTableContent = function(control,info,dims,source,prefix) {
	var i,j,th,inRange,tr,tds,values,td,row,col,formatter,div,txtspan;
	var isScrolled=prefix==="scrolled";
	var parent=control.dom.body.data.contents[isScrolled?"scrolled":"fixed"];
	var id=control.getId()+"-"+prefix+"-";
	var colCount=isScrolled?dims.viewableCols:info.fixed.colCount;
	var firstCol=isScrolled?control.firstCol:0;
	var lastCol=firstCol+colCount;
	var table=document.createElement("TABLE");
	parent.table={val:table};
	table.style.width=isScrolled?dims.scrolledClientWidth+"px":dims.fixedWidth+"px";
	table.style.tableLayout="fixed";
	//table.onwheel=$.proxy(control.onWheelRowScroll,control,dims);
	table.addEventListener("wheel",$.proxy(control.onWheelRowScroll,control,dims));
	var thead=document.createElement("THEAD");
	var theadtr=document.createElement("TR");
	var widths=isScrolled?info.scrolled.widths:info.fixed.widths;
	for(j=firstCol;j<lastCol;j++){
		th=document.createElement("TH");
		th.className=prefix+"-col-"+j;
		if (j===(lastCol-1)&&!isScrolled) {
			th.style.width = String(widths[j] + 16) + "px";
		}else{
			th.style.width = String(widths[j]) + "px";
		}
		theadtr.appendChild(th);
	}
	thead.appendChild(theadtr);
	table.appendChild(thead);
	var trs=[];
	var rowCount=dims.viewableRows;
	var lastRow=control.firstRow+rowCount;


	// if the info has row headers then we will display otherways
	if (!isScrolled&&colCount>=2){
		var divWidth=dims.fixedWidth-widths[0];
		//sas.stress.wkbench.widget.Slimsheet.renderTableRowHiearchy(control,info,dims,source,prefix);
		var labelsInfo=isScrolled?info.scrolled:info.fixed;
		var spans={};
		i=control.firstRow;
		for(/*i=0,*/row=control.firstRow;row<lastRow;i++,row++){
			if (row===info.rowCount){
				break;
			}
			var txt="",j= 0,title="";
			tds = [];
			tr=document.createElement("TR");
			txt=(i+1).toLocaleString();
			td=document.createElement("TD");
			div=document.createElement("DIV");
			div.id=/*"rowH"+*/id+i+"x"+j;
			div.innerHTML=txt;//appendChild(document.createTextNode(txt));
			td.appendChild(div);
			tr.appendChild(td);

			for(var col= 1,j=1;col<colCount;col++,j++){
				var groupRowCount= 0, groupRowIndex= 0, span= 0, exists=false;;
				var labels=labelsInfo["label_"+j];
				var node=labels.nodes?labels.nodes[i]:undefined;
				if (node) {
					if (control.firstRow === 0) {
						span = node.getName().length?this._calculateSpanOnHScroll(node, (firstCol - 1), false):1;	// if the name is "", it is empty or subtotal the span =1
					} else {
						span = node.getName().length?this._calculateSpanOnVScroll(node, row, i):1;	// if the name is "", it is empty or subtotal the span =1
					}
					txt = node.getName();
					title = node.getDataKey();

					var data = {groupRowIndex: 0, previousRow: 0, span: 0};
					if (span > 1) {
						if (!(node.getUniqueID() in spans)) {/*LiKey*/
							data.groupRowIndex = groupRowIndex + span;
							data.previousRow = row;
							data.span = span;

							spans[node.getUniqueID()] = data;/*LiKey*/
						} else {
							data = spans[node.getUniqueID()];/*LiKey*/
							if (col !== 1) {
								var parentspan = this._calculateSpanOnHScroll(node.getParent(), (firstCol - 1), false);
								if (parentspan > 1) {
									data.groupRowIndex = parentspan;
								}
							}
							exists = true;
						}
					} else if (control.firstRow > 0 && node.getUniqueID() in spans) {/*LiKey*/
						exists = true;
					}

					if (exists === false/*|| data.span===1*/ || ( data.groupRowIndex + data.previousRow) === row) {
						td = document.createElement("TD");
						td.rowSpan = span;
						div = document.createElement("DIV");
						td.className = "stressSlimsheetHierarchyFixed";
						div.id = "rowH" + id + i + "x" + j;
						// need to check on each column node
						/*no children = true because we need to give the total width correct */
						var doesNodeHaveSubtotalChildren=node.getChildren().length>0?(node.getChildren()[0].getSubtotalLikey()!==undefined):true;
						if (doesNodeHaveSubtotalChildren) {	// make sure sub-totals are turned ON!!
							if (control.firstRow === 0) {
								if (col === 1) {
										div.style.width = divWidth + "px";
										div.style.maxWidth = divWidth + "px";
								} else if (col === (lastCol - 1)) {
										div.style.width = widths[j] + "px";
										div.style.maxWidth = widths[j] + "px";
								} else {
										div.style.width = divWidth - (widths[j] * j) + "px";
										div.style.maxWidth = divWidth - (widths[j] * j) + "px";
								}
							} else {
								if (span === 1 && node.getChildren() === 0) {	// make sure we are not looking at a sub-total node
									if (col === (lastCol - 1)) {
											div.style.width = widths[j] + "px";
											div.style.maxWidth = widths[j] + "px";
									} else {
											div.style.width = divWidth - (widths[j] * j) + "px";
											div.style.maxWidth = divWidth - (widths[j] * j) + "px";
									}
								} else {
									// if the label after the current is "", we can show the full name of the node.. else it will be truncated
									var oneAfter = labelsInfo["label_" + (col + 1)];
									var labelsAfter = oneAfter ? oneAfter.label[i] : "";
									if ("" === labelsAfter) {
										div.style.width = divWidth - (widths[col - 1] * (col - 1)) + "px";
										div.style.maxWidth = divWidth - (widths[col - 1] * (col - 1)) + "px";
									}
								}
							}
						}
						var text = document.createTextNode(txt);
						div.appendChild(text);
						td.appendChild(div);
						td.title=control.rb.getText("slimsheet.td.tip.fmt.txt",[txt,title]);//"Name: "+txt+"\nDataKey: "+title;
						if (txt.length===0) {
							td.className = "stressRemoveLeftAndRightwidth";
							td.title=control.rb.getText("slimsheet.td.tip.fmt.txt",[node.getParent().getName(),node.getParent().getDataKey()]);//"Name: "++"\nDataKey: "+;
						}
						if ((node.getDataKey()&&node.getSubtotalLikey()===undefined&&node.getChildren().length>0)/*&&!node.getLiKey()&&j<(colCount-1)*//*txt.length===0||j<(colCount-1)*/){    // the span is not 1 (usually emptynodes or if the node is not in the last column
							if (td.className) {
								td.className +=" ";
							}
							td.className+="stressHighlightSubTotalRow";
						} else if(node.getDataKey()&& node.getSubtotalLikey()&&node.getChildren().length===0){
							if (td.className) {
								td.className +=" ";
							}
							td.className+="stressHighlightSubTotalRow";
						} else if (node.getDataKey()&&node.getChildren().length===0){
							if (td.className) {
								td.className +=" ";
							}
							td.className+="stressLeafNode";
						}

						tds.push({td: td, div: div, text: text});

						tr.appendChild(td);
						// the pevious row needs to be updated to current row
						data.previousRow = row;
					}
				}
			}
			trs.push(tds);
			table.appendChild(tr);
		}
	} else {
		var getValueFunc = isScrolled ? source.getScrolledRowData : source.getFixedRowData;
		for (i = 0, row = control.firstRow; row < lastRow; i++, row++) {
			inRange = row < info.rowCount;
			if (inRange) {
				tr = document.createElement("TR");
				tds = [];
				values = inRange ? getValueFunc.call(source, row) : null;
				formatter = source.getFormatter(row);
				for (j = 0, col = firstCol; col < lastCol; j++, col++) {
					td = sas.stress.wkbench.widget.Slimsheet.createCell(control, dims, source, tds, id, row, col, i, j, inRange, values, isScrolled, formatter);
					tr.appendChild(td);
				}
				trs.push(tds);
				table.appendChild(tr);
			}
		}
	}
	parent.table.tr=trs;
	parent.val.appendChild(table);
};
sas.stress.wkbench.widget.Slimsheet.createCell = function(control,dims,source,tds,id,row,col,i,j,inRange,values,isScrolled,formatter) {
	var td=document.createElement("TD");
	var span=document.createElement("SPAN");
	var div=document.createElement("DIV");
	div.id=id+i+"x"+j;
	div.dataset.row=i;
	div.dataset.col=j;
	var txt=inRange?sas.stress.wkbench.widget.Slimsheet.formatValue(values[col],source,isScrolled,formatter):"";
	var text=document.createTextNode(txt);
	tds.push({td:td,div:div,text:text});
	div.innerHTML=txt;//.appendChild(text);
	span.appendChild(div);
	td.appendChild(span);
	if(source.augmentCell){//hook to let the source customize the cell
		td=source.augmentCell(control,dims,source,id,row,col,i,j,inRange,values,isScrolled,td,span,div,text);
	}
	//td.setAttribute("aria-controls","row "+row+ ", col "+col);
	return td;
};
sas.stress.wkbench.widget.Slimsheet.formatValue = function(value,source,isScrolled,formatter) {
	if(isScrolled){
		if(value===null || value===undefined /*|| value===-1*/ || value===" "){	//fixes for S1298955
			return '\u00A0';
		}
		try {
			return formatter.format(value);
		}catch(e){
			return value;
		}
	}
	return value;
};
//SCROLLBARS
sas.stress.wkbench.widget.Slimsheet.renderHorizScrollBar = function(control,dims) {
	var reuse=!!control.dom.hbar;
	var outerdiv=reuse?control.dom.hbar.val:document.createElement("DIV");
	if(!reuse){
		control.dom.hbar={val:outerdiv};
		outerdiv.className="StressSlimsheetHScrollbar";
	}
	outerdiv.style.paddingLeft=dims.fixedWidth+16-1+"px";/*helps align border of scroller div*/
	var div=reuse?control.dom.hbar.scroller.val:document.createElement("DIV");
	if(!reuse){
		control.dom.hbar.scroller={val:div};
	}
	div.style.left=dims.fixedWidth +"px";
	var innerdiv=reuse?control.dom.hbar.scroller.stretcher.val:document.createElement("DIV");
	if(!reuse){
		control.dom.hbar.scroller.stretcher={val:innerdiv};
		innerdiv.style.height="1px";
	}
	innerdiv.style.width=dims.scrolledWidth+"px";
	if(!reuse){
		div.appendChild(innerdiv);
		outerdiv.appendChild(div);
		control.dom.val.appendChild(outerdiv);
		var scrollPosition=dims.maxScrolledCol>0?((div.scrollWidth-div.clientWidth)*control.firstCol)/dims.maxScrolledCol:1;
		div.scrollLeft=scrollPosition;
	}
	div.onscroll=$.proxy(control.onColScroll,control,dims);
};
sas.stress.wkbench.widget.Slimsheet.renderVertScrollBar = function(control,dims) {
	var reuse=!!control.dom.body.vbar;
	if(!reuse){
		var $control=$(control.dom.val);
		var $scrolledheader=$.find(".stressSlimsheetHeaderScrolled");
		var outerdiv=document.createElement("DIV");
		control.dom.body.vbar={val:outerdiv};
		outerdiv.className="StressSlimsheetVScrollbar";
		outerdiv.style.paddingTop=($scrolledheader[0].offsetHeight/*dims.headerHeight+8*/)+"px";
		var div=document.createElement("DIV");
		control.dom.body.vbar.scroller={val:div};
		div.style.top=$scrolledheader[0].offsetHeight/*dims.headerHeight*/+"px";
		//div.onscroll=$.proxy(control.onRowScroll,control,dims);
		div.addEventListener("scroll",$.proxy(control.onRowScroll,control,dims));

		var innerdiv=document.createElement("DIV");
		control.dom.body.vbar.scroller.stretcher={val:innerdiv};
		innerdiv.style.width="1px";
		innerdiv.style.height=dims.contentHeight+"px";
		div.appendChild(innerdiv);
		outerdiv.appendChild(div);
		control.dom.body.val.appendChild(outerdiv);
		var scrollPosition=((div.scrollHeight-div.offsetHeight)*control.firstRow)/dims.maxScrolledRow;
		div.scrollTop=scrollPosition/*+1*/;
	}

};
//DIMENSIONS
sas.stress.wkbench.widget.Slimsheet.calcDimensions = function(control,info) {
	var dims=control.dims||{};
	control.dims=dims;//save reference
	var i;
	var fullOffsetWidth=control.dom.val.offsetWidth;
	var totalFixedColumnWidth=info.fixed.width;
	var totalScrolledColumnWidth=info.scrolled.width;
	var fullOffsetHeight=control.dom.val.offsetHeight;
	var totalHeaderRowHeight=info.headerCount*25+info.headerCount-2;	// there is a 12-14px offset in the header height
	var totalContentRowHeight=info.rowCount*21;
	var scrolledOffsetWidth=fullOffsetWidth-totalFixedColumnWidth/*-19*//*vert scrollbar*/;
	var contentOffsetHeight=fullOffsetHeight-totalHeaderRowHeight-19/*horiz scrollbar*/;	// the height of H scroll bar
	var colCount=info.scrolled.colCount;
	var viewableCols=0;
	var widths=info.scrolled.widths;
	var scrolledClientWidth=0;
	for(i=control.firstCol;i<colCount;i++){
		viewableCols++;
		scrolledClientWidth+=widths[i];
		if(scrolledClientWidth>scrolledOffsetWidth){
			break;
		}
	}
	var maxScrolledCol=0;
	var _clientWidth=0;
	for(i=colCount-1;i>=0;i--){
		_clientWidth+=widths[i];
		if(_clientWidth>scrolledOffsetWidth){
			break;
		}
		maxScrolledCol=i;
	}
	var rowCount=info.rowCount;
	var viewableRows=Math.min(Math.ceil(contentOffsetHeight/21),rowCount);
	var maxScrolledRow=Math.max(rowCount-viewableRows+1,0);
	control.firstRow=Math.min(control.firstRow,maxScrolledRow);
	dims.scrolledClientWidth=scrolledClientWidth;
	dims.fixedWidth=totalFixedColumnWidth;
	dims.scrolledWidth=totalScrolledColumnWidth;
	dims.scrolledOffsetWidth=scrolledOffsetWidth;
	dims.headerHeight=totalHeaderRowHeight;
	dims.contentHeight=totalContentRowHeight;
	dims.contentOffsetHeight=contentOffsetHeight;
	dims.viewableCols=viewableCols;
	dims.viewableRows=viewableRows;
	dims.maxScrolledRow=maxScrolledRow;
	dims.maxScrolledCol=maxScrolledCol;

	return dims;
};
//COLUMN RESIZER
sas.stress.wkbench.widget.Slimsheet.createColumnResizers=function(control){
	$(".StressColResizer").remove();
	var count=control.getSlimsheetSource().getInfo().headerCount;
	var $control=$(control.dom.val);
	var $contentsTable=$(control.dom.body.data.contents.val);
	var $headersTable=$control.find(".StressSlimsheetContentScrolled");
	var placeholders=$control.find(".StressColResizerPlaceholder");
	var headerTable=control.dom.body.data.headers.val;
	var $colShortReference=$control.find(".stressColShortReference");
	var i,placeholder,$placeholder,y,x,h,id,dataset,scrolled,col;
	for(i=0;i<placeholders.length;i++){
		placeholder=placeholders[i];
		dataset=placeholder.dataset;
		scrolled=dataset.scrolled;
		col=dataset.col;
		$placeholder=$(placeholder);
		//$control.offset().top-$(window).scrollTop()+44(headerTable.offsetHeight-18)*count; ////$control.find(".stressColShortReference").height()
		y=$control.offset().top+1;//(count<3?0:(count*10));//$control.offset().top-$(window).scrollTop()+count*12.75;//(count<2?0:50)
		x=$placeholder.offset().left-$(window).scrollLeft();
		h=$colShortReference.height();//headerTable.offsetHeight;//42+8;//$(headerTable).height();
		h2=$contentsTable.height() + (headerTable.offsetHeight-$colShortReference.height());
		id="stress-col-resizer-"+scrolled+"x"+col;
		var resizer=document.createElement("DIV");
		resizer.id=id;
		resizer.style.position="fixed";
		resizer.style.width=5+"px";
		resizer.className="StressColResizer";
		var anchor=document.createElement("DIV");
		anchor.id="stress-col-resizer-anchor";
		anchor.style.position="relative";
		anchor.style.width=5+"px";
		anchor.style.height=h+"px";
		anchor.className="StressColResizerAnchor";
		resizer.appendChild(anchor);
		bar=document.createElement("DIV");
		bar.id="stress-col-resizer-bar-"+scrolled+"x"+col;
		bar.style.position="relative";
		bar.style.width=1+"px";
		bar.style.left=2+"px";
		bar.style.top=0+"px";
		bar.style.height=h2+"px";
		bar.className="StressColResizerBar";
		bar.style.visibility="hidden";
		resizer.appendChild(bar);
		resizer.dataset.col=col;
		resizer.dataset.scrolled=scrolled;
		control.dom.val.appendChild(resizer);
		resizer.style.left=(x+1)+"px";
		resizer.style.top=(y+1)+"px";/*1 is for the top border*/
		resizer.style.height=h+"px";
		resizer.style.visibility="visible";
		$(resizer).draggable({
			axis:"x",
			containment:$control,
			start:(function(barId){
				return function(event,ui){
					$(event.target).addClass("Dragging");
					$(event.target.children[0]).addClass("StressColResizerAnchorHover");
					document.getElementById(barId).style.visibility="visible";
				};
			})(bar.id),
			stop:(function(barId){
				return function(event,ui){
					var col=ui.helper.context.dataset.col;
					var scrolled=Number(ui.helper.context.dataset.scrolled);
					var source=control.getSlimsheetSource();
					var delta=Math.max(source.widths[scrolled][col]+(ui.position.left-ui.originalPosition.left),5);/*at least 5 pixels wide minimum*/
					source.widths[scrolled][col]=delta;
					var w = 0;
					_.each(source.widths[scrolled], function (width) {
						w += width;
					});
					switch(scrolled){
						case 0:
							//source.widths[scrolled][col]=delta+20;
							source.info.fixed.width = w;
							break;
						case 1:
							source.info.scrolled.width=w;
							break;
					}
					// store the new widths
					source.putToLocalStorage();
					$(event.target).removeClass("Dragging");
					$(event.target.children[0]).removeClass("StressColResizerAnchorHover");
					document.getElementById(barId).style.visibility="hidden";
					control.dom.body.data.val.removeChild(control.dom.body.data.headers.val);
					control.dom.body.data.val.removeChild(control.dom.body.data.contents.val);
					sas.stress.wkbench.widget.Slimsheet.renderTable(control,control.getDomRef());
				};
			})(bar.id)
		});
	}
};
//IN-PLACE EDIT
sas.stress.wkbench.widget.Slimsheet.dimInPlaceEdit=function(control){
	var id=control.getId()+"-inplace-edit";
	var inplace=document.getElementById(id);
	if(inplace&&(sas.stress.wkbench.CellPickerUtil.getOperationMode() !== sas.stress.wkbench.CellPickerUtil.EDIT_MODE)){
		inplace.style.visibility="hidden";
	}
};

sas.stress.wkbench.widget.Slimsheet._adjustInPlaceEditWidth=function(tester,inplace){
	var $inplace=$(inplace);
	var stringWidth=$(tester).text(inplace.value).width();
	var maxWidth=$(window).width()-$inplace.offset().left-$(window).scrollLeft();
	var rows=$inplace.attr('rows');
	var width=$inplace.width();
	var computedWidth=rows*width;
	while(stringWidth>computedWidth){
		if(width+40<maxWidth){
			$inplace.width(width+40);
		}else{
			$inplace.attr('rows',++rows);
		}
		width=$inplace.width();
		computedWidth=rows*width;
	}
};
sas.stress.wkbench.widget.Slimsheet._calculateSpanOnHScroll=function(currentNode,col,scrolledToColumn){
	if (currentNode===undefined){
		return 1;
	}
	var span=sas.stress.wkbench.model.TreeNode.getSpan(currentNode);
	if (!scrolledToColumn){    // are we scrolling (firstCol!==0 in this case)
		return span;    // no we are not, return the span of the node
	}
	var prevNode=currentNode.getPrevious();
	var previousSpan= 0, previousCol=0;
	while(prevNode){
		previousSpan+=sas.stress.wkbench.model.TreeNode.getSpan(prevNode);
		//span-=previousSpan;
		previousCol+=previousSpan;      // the column after the span
		prevNode=prevNode.getPrevious();
	}

	// the span is the current col - earlier cols (all the earlier cols are due to the spans)
	span=span-(col-previousSpan);

	if (span>0) {
		return span;
	} else{
		return Math.abs(span);
	}
};
sas.stress.wkbench.widget.Slimsheet._calculateSpanOnVScroll=function(currentNode,row,previousRow){
	var span=sas.stress.wkbench.model.TreeNode.getSpan(currentNode);

	var prevNode=currentNode.getPrevious();
	var previousSpan= 0,i=0;
	if(prevNode) {
		if (prevNode.getOrder()) { // not at root
			while (prevNode) {
				span += sas.stress.wkbench.model.TreeNode.getSpan(prevNode);
				prevNode = prevNode.getPrevious();
				if (previousRow > 0 && (i++ === (previousRow - 1))) {
					break;
				}
			}
		} else if (prevNode.getChildren().length > 1) {
			while (prevNode) {
				span += sas.stress.wkbench.model.TreeNode.getSpan(prevNode);
				prevNode = prevNode.getPrevious();
				if (previousRow > 0 && (i++ === (previousRow - 1))) {
					break;
				}
			}
		}
	}

	if (previousRow>0){
		span=row-span;
	}
	if (span>0) {
		return span;
	} if (span===0){
		return 1;
	} else{
		return Math.abs(span);
	}
};

/* CLICK HANDLER */
sas.stress.wkbench.widget.Slimsheet.doClickAction=function(e,control){
	var target=e.target;
	var row=parseInt(target.dataset.row);
	var col=parseInt(target.dataset.col);
	var source=control.getSlimsheetSource();
	sas.stress.wkbench.widget.Slimsheet.dimInPlaceEdit(control);
	if(source.isSelectable(row,col)&&target.tagName==="DIV"&&target.id&&target.id.indexOf("-scrolled-")!==-1){
		control.fireCellSelected({selected:true,row:row,col:source.getRealColumn(col),filter:source.getCellFilter(row,col)});
	}
	e.preventDefault();
	e.stopPropagation();
};

/* DOUBLE CLICK HANDLER */
sas.stress.wkbench.widget.Slimsheet.doDblClickAction=function(e,control){
	var rowStr=e.target.dataset.row;
	var colStr=e.target.dataset.col;
	var source=control.getSlimsheetSource();
	if(!isNaN(rowStr) && !isNaN(colStr) && !source.isSelectable(parseInt(rowStr)+control.firstRow,parseInt(colStr)+control.firstCol)){
		return;
	}/*only show in place edit for selectable cells*/
	/*only show in place edit for editable cells*/
	var filter=source.getCellFilter(rowStr,colStr);
	if (!filter.getSheetInfo().getData().isEditable(Number(rowStr),Number(colStr)+1)){
		return;
	}
	var id=control.getId()+"-inplace-edit";
	var inplace=document.getElementById(id);
	var tester=document.getElementById(id+"-tester");
	var y=$(e.target).offset().top-$(window).scrollTop();
	var x=$(e.target).offset().left-$(window).scrollLeft();
	if(!inplace){
		inplace=document.createElement("TEXTAREA");
		inplace.style.resize="none";
		inplace.id=id;
		inplace.className='StressSlimsheetInplace';
		$(inplace).css({'font': $(e.target.parentElement.parentElement).css("font")});
		window.document.body.appendChild(inplace);
		tester=document.createElement("DIV");
		tester.id=id+"-tester";
		$(tester).css({
			'position': 'absolute',
			'float': 'left',
			'white-space': 'nowrap',
			'visibility': 'hidden',
			'font': $(e.target.parentElement.parentElement).css("font")});
		window.document.body.appendChild(tester);
	}
	inplace.rows=1;
	inplace.style.visibility="visible";
	inplace.style.width=$(e.target).width()+7+"px";//border:2+2 padding:1+2
	inplace.style.top=y+"px";
	inplace.style.left=x+"px";
	var formulaField=sas.stress.wkbench.ViewManager.getCellEditor().formulaField;
	inplace.value=formulaField.getLiveValue();
	sas.stress.wkbench.widget.Slimsheet._adjustInPlaceEditWidth(tester,inplace);
	$(formulaField.getDomRef()).focus();
	$(inplace).focus();
	sas.stress.wkbench.ViewManager.getCellEditor().getController().gainedFocus();
	$(inplace).keydown(function(event){
		switch(event.keyCode){
			case 27:/*Esc*/
				sas.stress.wkbench.widget.Slimsheet.dimInPlaceEdit(control);
				sas.stress.wkbench.ViewManager.getCellEditor().cancelEditButton.firePress({});
				break;
			case 13:/*Enter*/
				sas.stress.wkbench.widget.Slimsheet.dimInPlaceEdit(control);
				sas.stress.wkbench.ViewManager.getCellEditor().saveEditButton.firePress({});
				break;
		}
	});
	$(inplace).keyup(function(event){
		switch(event.keyCode){
			case 27:/*Esc*/
			case 13:/*Enter*/
				break;
			default:
				sas.stress.wkbench.widget.Slimsheet._adjustInPlaceEditWidth(tester,inplace);
				formulaField.setValue(inplace.value);
				$(formulaField.getDomRef()).keypress();
		}
	});
	$(inplace).blur(function(){
		sas.stress.wkbench.widget.Slimsheet.dimInPlaceEdit(control);
		sas.stress.wkbench.ViewManager.getCellEditor().saveEditButton.firePress({});
	});
	//$(inplace).focusout(function(){sas.stress.wkbench.widget.Slimsheet.dimInPlaceEdit(control);});
	sas.stress.wkbench.StressUtil.setCaretPosition(id,inplace.value.length);
};

sas.stress.wkbench.widget.Slimsheet._doesNodeHaveSubtotalChild=function(node){
	if (node){
		if (node.getSubtotalLikey()!==undefined&&node.getChildren().length===0){
			return true;
		}
		var subtotalChild=node.getChildren()[0];
		return subtotalChild!==undefined&&undefined!==subtotalChild.getSubtotalLikey();
	}

	return false;
};