/**
 * Created by sinsrj on 2/1/2017.
 */
jQuery.sap.declare("sas.stress.wkbench.widget.TaskActionButtons");
jQuery.sap.require("sas.stress.wkbench.widget.CommentDialog");
jQuery.sap.require("sas.hc.ui.layout.HorizontalLayout");
jQuery.sap.require("sas.hc.m.Button");
jQuery.sap.require("sas.stress.wkbench.StressUtil");
jQuery.sap.require("sas.stress.wkbench.ViewManager");

sas.hc.ui.layout.HorizontalLayout.extend("sas.stress.wkbench.widget.TaskActionButtons", {
    renderer: "sas.hc.ui.layout.HorizontalLayoutRenderer"
});
sas.stress.wkbench.widget.TaskActionButtons.prototype.init=function(){
    var rb=sas.stress.wkbench.StressUtil.getBundle();
    this.buttonTemplate=new sas.hc.m.Button({
        text: {
            path:"abc",//cannot be / and cannot be blank, so setting it to anything, we are interested in the content object anyway
            formatter:function(){
                var bindingContext=this.getBindingContext();
                var taskAction=bindingContext.getObject();
                return rb.getText(taskAction.getLabel());
            }
        },
        visible: {
            path:"abc",
            formatter:function(){
                var bindingContext=this.getBindingContext();
                var taskAction=bindingContext.getObject();
                return taskAction.getType()==="STATUS_UPDATE";
            }
        },
        enabled: {
            path: "live>/toggleButtons",
            formatter: function (enabled) {
                return enabled ? false : true;
            }
        },
        press: function(){
            var bindingContext=this.getBindingContext();
            var taskAction=bindingContext.getObject();
            var project=taskAction.getTask().getProject();

            var callBack=function(comment){
                sas.stress.wkbench.StressAPI.saveTaskStatus(taskAction,comment).done(function(){
                    sas.stress.wkbench.ViewManager.loadHomePage(project);
                });
            };
            // call REST API
            sas.stress.wkbench.StressAPI.loadTaskTransitionChangeSummary(taskAction).done(function(changes){
                sas.stress.wkbench.widget.CommentDialog.show(rb.getText(taskAction.getLabel()), callBack, undefined, changes);
            }).fail(function(jqxhr){
                sas.stress.wkbench.StressUtil.handleServerFailure(jqxhr);
            });
        }
    });
    //this.buttonTemplate.addStyleClass("stressTaskActionButton");
};
sas.stress.wkbench.widget.TaskActionButtons.prototype.bindAggregation = function(name, bindingInfo) {
    if(name==="content" && !bindingInfo.template){
        bindingInfo.template=this.buttonTemplate;
    }
    return sas.hc.ui.layout.HorizontalLayout.prototype.bindAggregation.apply(this, arguments);
};
