/*
Copyright (C) 2017 SAS Institute Inc. Cary, NC, USA

This is the ddl for creating the SSR Landing Area table. Eg. EBA_FINREP_GAAP.

NOTE: &LIBREF. refers to the Library used to store SSR Landing Area data.
      &REGULATOR and &MODULE should be appropiately set

*/



PROC SQL NOPRINT;
   CREATE TABLE &LIBREF..&REGULATOR._&MODULE.(
   LEGAL_ENTITY_ID   VARCHAR(36)   label='Legal Entity Identifier',
   CURRENCY_CD   VARCHAR(10)    label='Currency Code',
   REPORT_AS_OF_DT   DATE  FORMAT=NLDATE20. INFORMAT=NLDATE20. label='Reporting Date',
   TEMPLATE_CD   VARCHAR(20)   label='Template Code',
   COLUMN_CD   VARCHAR(10)    label='Column Code',
   ROW_CD   VARCHAR(10)    label='Row Code',
   SHEET_CD   VARCHAR(10)    label='Sheet Code',
   CELL_VAL   VARCHAR(255)   label='Cell Value'
);
QUIT;