/*-- Copyright (c) 2017 by SAS Institute Inc., Cary, NC, USA. All Rights Reserved. --*/ 
/*
$Revision: 1.3 $
$Date: 2015/03/27 15:29:03 $
Model         SAS Supervisory Reporting - DPM
Subject Area  SAS Supervisory Reporting - DPM
Model Version 
Name          ssr_dpm_master_ddl.sas
DBMS          PostgreSQL
Created       2/12/2016 12:22:47 PM
* Copyright (c) 2017 by SAS Institute Inc., Cary, NC 27513
*/
/* uncomment the next statment to suppress the warnings from postgres indicating creation of implicit index for PK */
/* %let postgopt = EXECUTE( set client_min_messages='warning' ) by postgres ; */

%MACRO ssr_dpm_master_ddl(AUTHDOMAIN=, USER=, DATABASE=, SERVER=, PORT=, SCHEMA=, fileloc=, postgopt=);
%let connstr=;
%IF (&SCHEMA > "" AND %INDEX(&SCHEMA, ".") = 0) %then %LET SCHEMA=%str(&SCHEMA).;
PROC SQL NOERRORSTOP;
%IF &DATABASE > "" %then %do;
   %let connstr = &connstr DATABASE=&DATABASE;
%end;
%IF "&SERVER" > "" %then %do;
   %let connstr = &connstr SERVER="&SERVER";
%end;
%IF &PORT > "" %then %do;
   %let connstr = &connstr PORT=&PORT;
%end;
%IF (&AUTHDOMAIN > "") %then %do;
   %let connstr=AUTHDOMAIN=&AUTHDOMAIN &connstr;
%end;
%else %do;
     %let connstr=DBPROMPT=YES USER=&USER &connstr;
      %end;
CONNECT TO POSTGRES (&connstr);
%if %length(&postgopt) > 0 %then
%do;
&postgopt ;
%end;
  %include "&fileloc./dpm_column.sas";
  %include "&fileloc./dpm_context.sas";
  %include "&fileloc./dpm_context_x_dim_x_member.sas";
  %include "&fileloc./dpm_currency.sas";
  %include "&fileloc./dpm_data_point.sas";
  %include "&fileloc./dpm_data_point_shaded.sas";
  %include "&fileloc./dpm_dimension.sas";
  %include "&fileloc./dpm_domain.sas";
  %include "&fileloc./dpm_framework.sas";
  %include "&fileloc./dpm_member.sas";
  %include "&fileloc./dpm_metric.sas";
  %include "&fileloc./dpm_module.sas";
  %include "&fileloc./dpm_open_sheet_member.sas";
  %include "&fileloc./dpm_owner.sas";
  %include "&fileloc./dpm_row.sas";
  %include "&fileloc./dpm_sheet.sas";
  %include "&fileloc./dpm_taxonomy.sas";
  %include "&fileloc./dpm_template.sas";
  %include "&fileloc./dpm_template_table.sas";
  %include "&fileloc./dpm_validation.sas";
  %include "&fileloc./multipart_report_data.sas";
DISCONNECT FROM POSTGRES;
QUIT;
%MEND;
