/*
Copyright (C) 2017 SAS Institute Inc. Cary, NC, USA

name: ssr_batch_create_pkg.sas

This SAS code runs the create Filing package in batch mode

*/


%ssrinit;

%ssr_postinit;


filename nodelib "&ssr_install_path./ssrsvr/sasstp"; /*i18NOK:LINE */

%include nodelib(ssr_stp_create_filing_package.sas) / lrecl=6000;

%let as_of_dt=13JAN2016;
%let currency_cd=EUR;
%let filing_package_desc=Batch Test Filing Package;
%let filing_package_nm=SSR_BATCH_TEST;
%let legal_entity_id=LEI001;
%let module_id=37;
%let taxonomy_id=10;
%let batch_mode_flg=Y;


%macro check_execute_create_package;

   %if 
      %sysevalf(%superq(as_of_dt)=,boolean) eq 0 and 
      %sysevalf(%superq(currency_cd)=,boolean)  eq 0 and 
      %sysevalf(%superq(filing_package_nm)=,boolean)  eq 0 and 
      %sysevalf(%superq(legal_entity_id)=,boolean)  eq 0 and 
      %sysevalf(%superq(module_id)=,boolean)  eq 0 and 
      %sysevalf(%superq(taxonomy_id)=,boolean)  eq 0  
   %then %do;

      %put %sysfunc(sasmsg(sashelp.ssrmsg, 51, NOQUOTE));

      %ssr_stp_create_filing_package;

   %end;
   %else %do;

      %put %sysfunc(sasmsg(sashelp.ssrmsg, 52, NOQUOTE));

   %end;

%mend check_execute_create_package;

%check_execute_create_package;
