/*
Copyright (C) 2017 SAS Institute Inc. Cary, NC, USA

Name: ssr_dpm_ddl_load.sas

This is the ddl for creating the SSR DPM tables in Oracle/ Postgres tables.

*/

%ssrinit;

%ssr_postinit;

%macro ssr_dpm_ddl_select_exec(dbtype=&ssrdpm_dbtype.);
/* This macro select and execute Oracle/ Postgres ddls for DPM */

   %if &dbtype. eq SASRiskCommonDataServer %then %do;

   /* Execute ddls for PostgreSQL */
      filename nodelib "&ssr_sasmisc_path./ddl/ssrdpm/postgres"; /*i18NOK:LINE */

      %include nodelib(ssr_dpm_master_ddl.sas) / lrecl=6000;

      %ssr_dpm_master_ddl(AUTHDOMAIN=&ssrdpm_authdomain., DATABASE=&ssrdpm_db_name., SERVER=&ssrdpm_host_name., PORT=&ssrdpm_port., 
                          SCHEMA=&ssrdpm_schema_name., fileloc=&ssr_sasmisc_path./ddl/ssrdpm/postgres, postgopt=);

   %end;

   %else %if &dbtype. eq Oracle %then %do;

   /* Execute ddls for Oracle */
      filename nodelib "&ssr_sasmisc_path./ddl/ssrdpm/oracle"; /*i18NOK:LINE */

      %include nodelib(ssr_dpm_master_ddl.sas) / lrecl=6000;

      %ssr_dpm_master_ddl(AUTHDOMAIN=&ssrdpm_authdomain., PATH=&ssrdpm_service_name., 
                          SCHEMA=&ssrdpm_schema_name., fileloc=&ssr_sasmisc_path./ddl/ssrdpm/oracle);
      
   %end;

%mend ssr_dpm_ddl_select_exec;

%ssr_dpm_ddl_select_exec;

/* Verify if any error thrown at DB end (only applicable when being executed from SAS Deployment Wizard)*/
%let m_sdw_flg=%sysget(m_sdw_flg);
%ssrsvrc_error_check(sdw_flg=&m_sdw_flg.);
