/*
Copyright (C) 2017 SAS Institute Inc. Cary, NC, USA

Name: ssr_sel_db_datetime_exp.sas

Purpose: This macro will handle the loading of date columns based on target database. 
         For example, if target database is Oracle, this macro will load date variable as datetime 
         and if the target database is PostgreSQL, data variable will be loaded as date only.

Note: ssrdpm_dbtype macro variable should be available.

*/

%macro ssr_sel_db_datetime_exp(in_col);

%if &ssrdpm_dbtype. = Oracle %then %do;
dhms(datepart(&in_col),0,0,0)
%end;

%else %if &ssrdpm_dbtype. = SASRiskCommonDataServer %then %do;
datepart(&in_col)
%end;

%mend ssr_sel_db_datetime_exp;
