%**********************************************************************;
%* Copyright (c) 2017 by SAS Institute Inc., Cary, NC, USA.            ;
%*                                                                     ;
%* NAME:          bankingdds_error_check                               ;
%*                                                                     ;
%* PURPOSE:       Verify for any errors encountered while running ddls ;
%*                                                                     ;
%* USAGE:         %ssrsvrc_error_check                                 ;
%*                                                                     ;
%*                                                                     ;
%**********************************************************************;
%let syscc=0;
%let sqlrc=0;

%macro ssrsvrc_error_check(sdw_flg=N);

%put _ALL_;

    %let sdw_flg = %lowcase(&sdw_flg.);

    %if &sdw_flg.=y %then %do;
        %put **************** INFO: Macro ssrsvrc_error_check being called from SAS Deployment Wizard.****************;
        %if &syscc > 4 or &sqlrc >= 8 %then %do;
            %put **************** ERROR: PROCESS ABORTED ABNORMALLY.****************;
            %put **************** ERROR: Issues encountered in DDL execution.****************;
            %abort abend;
        %end;

        %if ("&syserrortext" > "") %then %do;
            %put **************** ERROR: &syserrortext ****************;
            %abort abend;
        %end;
        %else %do;
            %put **************** INFO: No errors recorded. ****************;
        %end;
    %end;
    %else %do;
        %put **************** INFO: For information only: Macro ssrsvrc_error_check being called from outside of SAS Deployment Wizard. Error scanning will not be performed.****************;
        %put **************** INFO: Complete output of the run (with errors, if any) will be displayed on the screen for user to take appropriate action.****************;
    %end;

%mend ssrsvrc_error_check;
